Sun Apr  1 23:01:31 2001  Owen Taylor  <otaylor@redhat.com>

	* Released 1.2.10.

Sun Apr  1 22:22:47 2001  Owen Taylor  <otaylor@redhat.com>

	[ Addition of safety checks to try to avoid segfaulting
	  on broken setups always. ]

	* gdk/gdkfont.c (_gdk_font_wc_to_glyphs): Add a boolean
	return value to deal with failure of conversion of
	wide characters to glyphs.

	* gtk/gtkentry.c gtk/gtklabel.c: Handle failure of 
	mbstowcs/wcstombs a bit better.

	* gdk/gdkfont.c gdk/gdkdraw.c: Deal with failure of
	_gdk_font_wc_to_glyphs() gracefully

	* gdk/gdkim.c (_gdk_wcstombs_len): quietly return NULL on
	failure instead of g_return_if_fail().

Wed Mar 28 16:05:29 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_select_size): Fix 
	problem where fractional sizes caused infinite loop.
	(bugzilla.redhat.com #33081)

Wed Mar 28 14:52:08 2001  Owen Taylor  <otaylor@redhat.com>

	* docs/Makefile.am: Remove excess rules breaking
	distcheck.

Wed Mar 28 12:33:20 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c: Fix problem where dropping into
	internal child widgets (such as GtkCList tab labels)
	(#52457, reported by Daniel Erat). Can't use
	gtk_container_children(), so provide a substitute
	which uses gtk_container_forall().

2001-03-22  Darin Adler  <darin@eazel.com>

	* gtk/gtkobject.h: Fixed #if G_ENABLE_DEBUG that
	was supposed to be #ifdef G_ENABLE_DEBUG.

Thu Mar 15 15:23:11 2001  Owen Taylor  <otaylor@redhat.com>

	* NEWS: Updated

	* configure.in (GTK_BINARY_AGE): Up micro => 10,
	binary => 10, interface => 1.

	* INSTALL.in: Add some discouraging words about 
	--with-xinput=gxi.

	* configure.in (x_ldflags): Make --with-xinput be
	--with-xinput=xfree, and warn for --with-xinput=gxi.

Thu Mar 15 14:29:47 2001  Owen Taylor  <otaylor@redhat.com>

        * gdk/gdkselection.c (sanitize_ctext): Handle 
	extended segments, which can contain arbitrary octets,
	properly. (Fixes problems with cut-and-paste and,
	e.g., KOI8-R.)
	
	* gtk/gtktext.c gtk/gtkeditable.c: Patch from
	Vlad Harchev to avoid using gdk_draw_text_wc() 
	on text that is really chars, not wchars. (Cannot
	convert between chars and wide chars with assignment!)

Thu Mar 15 01:31:07 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkim.c (_gdk_wcstombs_len): Make somewhat more
	safe on broken libcs, also add a g_return_if_fail()
	to make the failure case when we somehow get a
	string of invalid wide characters more clear.
	(#51644, Sergey Vlasov)

Thu Mar 15 01:05:49 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_add_initial_default_files): Fix 
	problem in testing the result of g_get_home_dir(),
	and test the result of g_get_home_dir() in another
	place for consistency. (#51833). Also fix off-by-one
	error in check against GTK_RC_MAX_MODULE_PATHS.

Thu Mar 15 00:41:47 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalender.c gtk/gtkcombo.c gtk/gtkeditable.c
	gtk/gtkplug.c gtk/gtkradiobutton.c gtk/gtkvpaned.c:
	Patch from Darin Adler to fix unused variables
	warning. (But use gutter_size variable in 
	gtk_vpaned_button_press.) (#51835)

Wed Mar 14 23:38:23 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c (gdk_init_check): Fix missed equal_pos => option
	for --with-xinput=gxi. (Which is broken anyways, but
	oh well...)

	* gtk/gtkeditable.c (gtk_editable_get_event_time): Fix excess free
	in case where there is no current event.

	* gtk/gtkwindow.[ch]: Handle focus for the case of 
	PointerRoot (no window manager) by using algorithm taken 
	from xterm.

Fri Mar  9 22:32:32 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.c (gtk_menu_shell_enter_notify): Only
	check the ignore_enter flag for the menu shell that
	the item is actually a child of, not for attached
	submenus. (#51536)

Fri Mar  2 12:35:40 2001  Owen Taylor  <otaylor@redhat.com>

	* Release 1.2.9

        * NEWS: Final update for 1.2.9
	 
	* INSTALL INSTALL.in: Add note about the movement of
	the include files.

Fri Mar  2 19:33:59 2001  Fatih Demir	<kabalak@gtranslator.org>

	* configure.in: Added tr to ALL_LINGUAS.

Thu Mar  1 04:35:51 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_class_init): Never make harmless
	warning fixes! :-(

Wed Feb 28 21:14:08 2001  Owen Taylor  <otaylor@redhat.com>

	* README.in INSTALL.in: Fix the .in files, add note
	about --with-native-locale.

	* */po/*: Line-number-creepage.

Wed Feb 28 19:10:43 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (real_remove_row): Patch from ChiDeok
	Hwang to move call to sync_selection() up a few lines
	to before the row list is modified, to fix crash when
	removing rows in the undo_selection list.

	(Test case provided by Daniel Elstner:

        http://mail.gnome.org/archives/gtk-list/2001-February/msg00359.html)

Wed Feb 28 15:40:27 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalender.c gtk/gtkdnd.c gtk/gtkitemfactory.c gtk/gtklayout.c
	  gtk/gtkplug.c gtk/gtksocket.c gtk/gtktypeutils.c
	  gtk/gtkwidget.c genmarshal.pl: Fix implicit casts
	between void * and function pointers.

	* gtk/gtklayout.c: Remove cruft after #endif

	* gtk/gtkdnd.c: Include stdlib.h for abs.

Tue Feb 27 18:38:27 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_map): Redo the focus stuff
	once more. Keep track of the focus status via an event
	filter, so we can keep track of whether the window
	or any child has the focus; something that requires
	fields from the XEvent not in the GdkEvent.

	Install this event filter in gtk_window_map() before mapping
	the window, on the guess that this is unlikely to be overriden
	without the overrider chaining up. (fingers crossed)

Tue Feb 27 04:14:21 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_propagate_event): Remove
	left-over debug-printf.

	* gtk/gtkdnd.c (gtk_drag_find_widget): Don't use
	new_allocation.x/new_allocation.y for coordinate,
	translation since they are clip, use the 
	x_offset/y_offset variables we keep for the purpose instead.

Tue Feb 27 02:29:20 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_find_widget): When recursing,
	get the list of children and ref them all before walking
	through the list, to prevent problems when the widget
	hierarchy changes in ::drag_motion/drop handlers.

	* gtk/gtkmain.c (gtk_propagate_event): Only activate
	special key-press grab handling for widgets within
	GtkWindows. Otherwise, fall through to normal case.

	This prevents key events being sent twice to GtkInvisible
	widgets, which can cause all sorts of mischief.

Tue Feb 27 02:16:14 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_propagate_event): Only do special
        special key-press grab handling for widgets within
        GtkWindows. Otherwise, fall through to normal case.

        This prevents key events being sent twice to GtkInvisible
        widgets, which can cause all sorts of mischief.

Tue Feb 27 01:29:34 2001  Owen Taylor  <otaylor@redhat.com>

	* configure.in acconfig.h gdk/gdkfont.c gdk/gdkim.c INSTALL: Add a
	configuration option --with-native-locale, that greatly speeds up
	wide-character/multibyte conversions by dropping the indirection
	through Xlib's property-conversion functions. Off by default due
	to lack of testing for portability, but it should, in general be a
	more correct way of doing things, and should also remove much of
	the speed hit that the recent change to the handling of 8-bit
	fonts may have introduced.

Mon Feb 26 16:34:33 2001  Owen Taylor  <otaylor@redhat.com>

	* README: Update to describe submitting patches
	and bug reports to bugzilla.gnome.org.

Tue Feb 20 23:48:16 2001  Owen Taylor  <otaylor@redhat.com>
 
 	* gdk/gdkim.c,gdk/gdkprivate.h: Add private function
         _gdk_wcstombs_len() which takes a length.
 
 	* gdk/gdkfont.c,gdk/gdkprivate.h,gdk/gdkdraw.c:
 	Consistently handle calls to _wc() font for GDK_FONT_FONT
 	routines by:
 
 	  a) for 8-bit fonts, converting to chars via wcstombs
              (Will make GtkLabel handle using GDK_FONT_FONT for
 	     non-iso-8859-1 a wee bit better, though GDK_FONT_FONTSET
 	     is still the only supported way to get correct i18n.
 	     #50834)
 
 	  b) for 16-bit fonts, assuming each wchar is a glyph
 	     index. (Broken, but no more broken than anything else)
 
Mon Feb 26 21:36:11 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.[ch] (gtk_window_focus_in/out_event): We can't
	maintain a flag in gtk_window_focus_in/out, because
	GtkPlug and cut-and-pastes of GtkPlug override these
	methods and don't chain up. So back out recent change
	adding such a flag, and instead recycle the hack
	GtkPlug uses of making GTK_WIDGET_HAS_FOCUS on the 
	top level represent this information

Fri Feb 23 15:06:48 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktree.c (gtk_tree_class_init): Do the setting
	of tree->root_tree in parent_set rather than _map(), 
	fixing #50892 in a bit better manner.

Fri Feb 23 11:54:25 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklistitem.c (gtk_list_item_focus_out): Emit
	"end_selection", since we won't get subsequent key
	releases. (#13447)

Thu Feb 22 20:50:08 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkplug.c (gtk_plug_set_focus): Change to parent
	implementation instead of cut-and-paste that was
	out of sync.

	* gtk/gtkwindow.[ch] (gtk_window_set_focus): Only send 
	::focus_in_event when the toplevel window actually 
	has focus on it. (Fixes #50857, Akira Higuchi)

Thu Feb 22 19:53:55 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkhandlebox.c (gtk_handle_box_button_changed): Grab
	on a offscreen GtkInvisible so that we can move handle boxes
	whose parents are iconified or on another desktop. Also,
	make sure we don't reattach to such parents. (#1923)

Thu Feb 22 17:07:58 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_popup): Don't flip cursor. (#50934)

Thu Feb 22 16:45:17 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_get_font[_name]):
	Update the current font from the contents of the entry.
	(#3123)

Tue Feb  2 11:22:33 2001  Jody Goldberg <jgoldberg@home.com>

	* gtk/gtkstyle.c : Remove duplicate fwd decl for
	gtk_default_draw_shadow.

Tue Feb 20 11:40:58 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkimage.c (gdk_image_new): Remove excess 
	warning, make warnings more verbose, treat a error
	in shmat as permanent, and don't try again.
	(#51163, Ed Randall.)

Mon Feb 19 20:46:21 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_key_press): Take key presses
	of GDK_Left/GDK_Right when there is a selection to mean
	"move the cursor to the start/end of the selection".
	(Inspired by #50492, Jay Cox, though the implementation
	is different for GTK+-1.2.)

Mon Feb 19 20:15:28 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_timer_1st_time): Add an initial
	delay for the first click before starting to scroll.
	(based on #51026, gtk-enf-990512-0.patch, Eric Fisher)

	* gtk/gtktext.c: GtkText should have I-beam cursor. 
	(based on gtk-enf-990513-1.patch, Eric Fisher.)

Mon Feb 19 18:39:21 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkselection.c (gdk_string_to_compound_text,gdk_text_property_to_text_list):
	Robustify by stripping control characters not allowed in COMPOUND_TEXT
	out before passing to XmbTextpropertyToTextList(), and from the
	result of XmbTextListToTextProperty(). This is in the spirit
	of "Be lenient in what you receive, strict in what you generate." 
	(Fixes #1704)

Mon Feb 19 14:20:36 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkrgb.c (gdk_rgb_convert_555_br): Fix incorrect
	mask. (#51039, fix from Martin Maierhofer)

Fri Feb 16 20:09:42 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c (gtk_ctree_class_init): Add bindings
	for unshifted + and shifted = for non-us keyboards.
	Make <Control>+ and <Control>- work as well as 
	<Control>KP_Plus, <Control>KP_Minus for recursive
	open/close. (#2682, René Seindal)
	
Fri Feb 16 18:50:59 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.c (gtk_real_menu_shell_cancel): Unset
	the active menu item before deactivating the menu,
	so gtk_menu_popdown doesn't change the history. (#50964)
	
Fri Feb 16 15:55:22 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktreeitem.c (gtk_tree_item_draw_lines): 
	draw lines with text_gc rather than black_gc.
	(Patch from Vlad Harchev <hvv hippo ru>, #50926)

Tue Feb 13 15:39:28 2001  Owen Taylor  <otaylor@redhat.com>

	* 1.2.9pre1

	* NEWS: Update.

	* docs/Makefile.am: Remove building of HTML for 
	gdk.texi gtk.texi since it doesn't work.

Tue Feb 13 13:56:58 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.c (find_char_width): Fix problems with
	characters < 256 in wide character locales. (Patch
	from Yoichi Imai.)

Tue Feb 13 00:58:49 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c: Properly handle passive buttons at
	button creation time (#50686).
	
Mon Feb 12 20:37:32 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkrgb.c (gdk_rgb_try_colormap): Call gdk_colormap_sync() - 
	fixes #50678.

	* gdk/gdk.h: Add missing prototype for gdk_colormap_sync().

Mon Feb 12 20:02:32 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c: Fix some cases of implicit casting between
	void * and function pointers.

	* configure.in gtk/gtkmain.c: Add checks for setuid/setgid,
	and refuse to initialize GTK+ if they fail.

	* configure.in (GTK_INTERFACE_AGE): Reset GTK_INTERFACE_AGE
	to zero.

Mon Feb 12 15:55:26 2001  Owen Taylor  <otaylor@redhat.com>
	 
	[ Enabling patch for better looking theme engines ]

	* gtk/gtkstyle.[ch]: Add new API functions for making
	better looking GTK+-1.2.x themes. THESE FUNCTIONS WILL
	NOT BE SUPPORTED IN THE FUTURE. ANY THEMES DEPENDING
	ON THESE FUNCTIONS MUST CHECK FOR GTK+-1.2.x WHERE 
	x >= 1.2.9.

	The functions:
	
	 _gtk_style_set_prop_experimental()
	 _gtk_style_get_prop_experimental()

	are used to allow configuration of assorted geometry 
	parameters.
	
	* gtk/gtkbutton.c: Make DEFAULT_SPACING configurable as
	GtkButton::default_spacing. 

	* gtk/gtkcheckbutton.c gtk/gtkradiobutton.c: Make indicator_size
	and indicator_spacing configurable as GtkCheckButton::indicator_size, 
	GtkCheckButton::indicator_spacing.

	* gtk/gtkcheckbutton.[ch]: Private function
	_gtk_check_button_get_props().

	* gtk/gtkcheckmenuitem.c (gtk_check_button_menu_item_set_show_toggle):
	Make a noop - turning this on is just a bad idea visually, and 
	changing this from a program is just asking a bad idea.

	* gtk/gtk{h,v,}paned.c: Provide configuration parameters
	GtkPaned::handle_full_size, which, if true, will turn
	on GTK+-1.3.2 style full-size paned handles. 
	GtkPaned::handle_width, which sets the gutter size for
	paned widgets. (If set, overrides setting via
	gtk_paned_set_gutter_size())

	* gtk/gtkpaned.[ch]: Add private functions
	_gtk_paned_is_handle_full_size(), _gtk_paned_get_handle_rect(),
	_gtk_paned_get_gutter_size().

	* gtk/gtkstyle.c (gtk_default_draw_box): Add handling for details
	"hpaned", "vpaned", used for drawing full-size grips on horizontal
	and vertical paned widgets. (In the style of GTK+-1.3.2)

	* gtk/gtkhscale.c gtk/gtkhscrollbar.c:

	* gtk/gtkoptionmenu.c: Add configurable parameters:
	
	  GtkOptionMenu::indicator_width
	  GtkOptionMenu::indicator_height
	  GtkOptionMenu::indicator_left_spacing
	  GtkOptionMenu::indicator_right_spacing
	  GtkOptionMenu::indicator_top_spacing
	  GtkOptionMenu::indicator_bottom_spacing

        To control where the indicator is drawn and how big it is.

	* gtk/gtkrange.[ch]: Add configurable parameters:

	  GtkRange::slider_width    - width of trough
	  GtkRange::trough_border   - space to reserve for trough border
	  GtkRange::stepper_size    - size of arrows
	  GtkRange::stepper_spacing - spacing between scrollbar and arrows

	and private accessor _gtk_range_get_props().
	  
	* gtk/gtkwidget.c (gtk_widget_event): Rewrite a bit to 
	quiet GCC. 

	* gtk/gtkwidget.c (gtk_widget_propagate_state): Fix typo
	in last commit.

Mon Feb  5 12:47:09 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_propagate_state)
	  gtk/gtkmain.c (gtk_grab_add): Don't allow insensitive widgets to
	have a grab.

2001-02-10  Ian Peters  <itp@ximian.com>

	* gtk/gtkprogressbar.c (gtk_progress_bar_size_request): use the
	font->ascent and ->descent to calculate the requisition height,
	rather than the gdk_text_height
	(gtk_progress_bar_paint): use the font->ascent instead of the
	gdk_text_height when calculating the vertical offset of the text
	label on the progress bar.  This fixes the baseline of the font on
	the widget.

Fri Feb  2 19:21:23 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_propagate_shapes): Surround additional
	regions with HAVE_SHAPE_EXT. (#50511, Eric Ding)
	
Fri Feb  2 18:31:54 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkimage.c: Remove definition of _XOPEN_SOURCE, since
	it breaks things on BSD. If you want to compile GTK+ with
	-ansi -pedantic, you should supply CPP_FLAGS=_XOPEN_SOURCE 
	when configuring, since GTK+ simply can't be "pure ANSI" 
	in the header files it uses. (#8170, Greg Hudson)

	* gdk/gdkrgb.c (gdk_rgb_select_conv): Exit with an informative
	warning message if no converter can be found. 

Fri Feb  2 15:09:51 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/fnmatch.c (FOLD): Fix problem with passing signed
	chars to isupper() / tolower().

	* examples/packer/pack.c: Add GINT_TO_POINTER, GPOINTER_TO_INT
	to clear up 64-bit warnings. (#567)

Fri Feb  2 13:38:21 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_propagate_event): Fix some reference
	counting problems problems in last patch.

Fri Feb  2 13:20:12 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_propagate_event): When a grab
	widget is in effect, give the grab widget a first
	crack at KEY_PRESS/RELEASE events. (#424)

Fri Feb  2 12:02:23 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c Makefile.am: Use $(libdir), not $(exe_prefix),
	since some people set $(libdir) separately. (#1290, David Kaelbling)

Thu Feb  1 20:32:49 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c: Improve warnings a bit in a fashion similar
	to the part of gtk-enf-990513-0.patch (Eric Fisher) that hasn't
	been superceded.

Thu Feb  1 18:25:46 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c: If PATH_MAX and MAXPATHLEN are not
	defined, define MAXPATHLEN to 2048. (The Hurd doesn't have
	MAXPATHLEN, but the code here depends on a fixed value.)
	(#4524)

Wed Jan 31 22:01:04 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkhandlebox.c (gtk_handle_box_draw): Remove a dependency
	on bin->child != NULL. (Basically, just a cleanup)

	* gtk/gtkhandlebox.c (gtk_handle_box_button_changed): Handle the case
	where child == NULL and handle_position == RIGHT or BOTTOM. (#8041)

Wed Jan 31 21:20:39 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c (real_tree_move): If the node being moved isn't
	viewable there is no way that moving the node will cause the 
	focus row to become not viewable, so omit check on the visibility
	of new_sibling, which is irrelevant. (Fixes #8002, David Helder)

Wed Jan 31 20:33:35 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_set_selection): Check bounds
	when setting selection. (#7302)

Thu Feb  1 02:26:18 2001  Tim Janik  <timj@gtk.org>

	* gtk/Makefile.am ($(srcdir)/gtkmarshal.c): avoid regeneration
	of gtkmarshal.c from stamp file dep, when not @REBUILD@,
	fixes #11008.

Wed Jan 31 19:23:01 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_set_font_name): 
	Apply patch gtk-gharris-000907-0.patch (Guy Harris) fixing problem where 
	wrong row was selected when filters filtered out some fonts.

Wed Jan 31 18:49:33 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_item_state_changed_cb):
	Make the sensitivity of the reparented child track that of
	the original parent menu item. (#34218, David Hodson)

	* gtk/gtkoptionmenu.c (gtk_option_menu_item_destroy_cb): Handle
	the case where the current item is destroyed properly.

	* gtk/gtkoptionmenu.c: Some additional code cleanups and fix
	some edge cases with child-less menuitems.
	
Wed Jan 31 17:16:13 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcombo.c (gtk_combo_window_key_press): Make Return
	key pop down window. (#12074, Jon K Hellan)

Wed Jan 31 16:21:42 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklist.c (gtk_list_signal_item_toggle): Don't allow
	toggling of rows off in BROWSE or EXTENDED mode. (#12072, Jon K Hellan) 
	The solution here isn't perfect - you get an extraneous
	emission of "toggle", which could conceivably confuse an app,
	but better than the current situation. LXR search seems to
	indicate that no apps in GNOME CVS connect to "toggle".

Wed Jan 31 15:46:13 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am (libgtkinclude_HEADERS): Move gtkfeatures.h from
	gtk_public_h_sources to directly here to avoid warning when
	building srcdir != builddir. (#9656)

Tue Jan 30 19:49:02 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c: Patch from Kipp Hickman to make the event
	handlers in gtkrange.c return the proper values (TRUE == handled)
	(#10316).

	This is just the tip of the iceberg, but gtkrange.c is the
	most common place where the propagation is problematical,
	and also a place where it is almost certainly safe to change
	this in the stable branch.

	(You don't want right click popups on a range control or anything...)

Tue Jan 30 19:12:52 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_unmap): Call gdk_window_withdraw
	rather than gdk_window_hide; this makes things work
	correctly if the window is programmatically hidden while
	iconified. [ Backport from HEAD, hope, hope it doesn't break
	anything since it fixes a bunch of stuff. ] (#14082)

Tue Jan 30 18:57:59 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.c (clear_focus_area): We need to clear the focus
	area on focus out, even if a background pixmap isn't set.
	(#13941)
	
Tue Jan 30 18:31:23 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_style_detach): Handle the case where
	bg_pixmap[i] == GDK_PARENT_RELATIVE.

Tue Jan 30 18:24:10 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_set_shape): Fix from Sean Cunningham
	to deal with setting the shape properly when scrolling arrows are
	turned on, but not visible because there is sufficient space.
	(#13432)

Tue Jan 30 16:39:25 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkitemfactory.c (gtk_item_factory_delete_item): For menu
	items with submenus, destroy the item along with the submenu.
	(#7841, Brian Masney(?)) Also, handle paths of the form '<foo>/abcd...' 
	properly.

	* gtk/testgtk.c (menu_items): Add a dummy branch that we delete
	later.

Tue Jan 30 15:51:25 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_real_set_focus): Fix a problem where
	the focus widget sometimes wasn't drawn with the default if there
	was no default widget.

	* gdk/gdkim.c (gdk_ic_destroy): Don't rely on
	ic->mask, which is completely unreliably set, when
	deciding what items to unref/free. (A bit of a hack,
	but this code will be dead in GTK+-2.0.) (#6739)

	* gtk/gtkstyle.c (gtk_style_detach): free colors,
	unreference pixmaps. 

	* gtk/gtkstyle.c (gtk_style_init): Reference colormap
	for some extra safety.

Mon Jan 29 19:44:26 2001  Owen Taylor  <otaylor@redhat.com>

        [ Backport from HEAD ]
	
	* gtk/gtkmenuitem.c gtk/gtkmenushell.c: Patch from David Santiago
	<mrcooger@cyberverse.com> so that when selecting menus with the
	mouse, the first item will not be selected, but when selecting
	with an accelerator, or navigating left-right on a menubar with
	the menus popped up, the first item will be selected.
	
Mon Jan 29 19:00:01 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk{ctree.c,clist.c} (set_cell_contents): Handle setting
	the text of a cell to the old pointer value better, by
	copying the new text before freeing the old text. Some code
	cleanup. (#8079, Karl Nelson)

Mon Jan 29 18:33:24 2001  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c (gdk_init_check): Handle --display= forms
	of options taking arguments. Fix some memory leaks with
	repeated arguments. (#28842, Sam Hunter)

Mon Jan 29 16:34:28 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c (gtk_font_selection_select_best_size): Return
	if fontsel->font_index == -1 - that is, if no font is selected.
	(Should fix #50290)

Mon Jan 29 15:22:51 2001  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_remove): When removing an
	item from a menu, check to see if it matches 
	menu->old_active_menu_item, and if so, unref and clear
	old_active_menu_item (Patch from Pavel Cisler)

	* gtk/gtkmenushell.c (gtk_menu_shell_remove): Unset 
	menu_shell->active_menu_item, if it is the child being
	removed. (Patch based on that of Gene Ragan, #50337)

2001-01-03  Alexander Larsson  <alexl@redhat.com>

	* gdk/gdkwindow.c:
	Set the colormap of input only windows to the system colormap.
	The previous GtkInvisible patch generated a lot of colormap ==
	NULL warnings without this.

2000-12-20  Alexander Larsson  <alexl@redhat.com>

        * gtk/gtkinvisible.c (gtk_invisible_realize):
        Attach the style to the window so that the style it is not
        leaked when unrealizing the window.

2000-12-19  Ramiro Estrugo  <ramiro@eazel.com>

	* gdk/gdkimage.c: (gdk_image_get):
	Deal with the possibility that XGetImage() might return NULL.
	Allocate the GdkImagePrivate structure only after XGetImage()
	succeeds in order not to dereference a NULL ximage pointer.  This
	prevents a core dump when XGetImage() fails - which is unlikely,
	but can happen due to race conditions accessing the geometries of
	drawables.  An x error will still be triggered, but the gdk image
	wrapper at least wont seg fault.
	
Tue Dec 12 11:52:16 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (gtk_clist_optimal_column_width): Fix 
	off-by-one error in checks. (Dave Lambert)

Sun Dec  3 11:44:07 2000  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c: Strip GDK_RELEASE_MASK out of 
	the state we get from X as a temporary hack to
	deal with the fact that GDK_RELEASE_MASK has the
	same values as bits used by XFree86 to indicate the
	keyboard group. (After patch from Vlad Harchev)

2000-20-01  Anders Carlsson  <andersca@gnu.org>

	* gtk/gtktogglebutton.c (gtk_toggle_button_draw): Fix bug when
	a GtkToggleButton is both insensitive and active, it was being
	drawn by the GtkButton draw handler which doesn't check the
	state. Now it's calling gtk_toggle_button_paint instead.

Thu Nov 30 12:39:22 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkspinbutton.c (gtk_spin_button_insert_text): Fix 
	some signed/unsigned comparison problems. (#6510,
	David Kaelbling)

Thu Nov 30 11:19:56 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_move_word): Fix stupid
	bug causing extra word movement backwards. (#15282, Marco Goetze)

Wed Nov 29 21:47:26 2000  Owen Taylor  <otaylor@redhat.com>

        [ Backport from 1.3.x ]

	* gtk/gtktoolbar.c (gtk_toolbar_prepend_widget): Fix to
	prepend not append. (Pointed out by Brett Hall.)
	#11887.

Wed Nov 29 20:56:38 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.[ch] (gtk_widget_is_ancestor): Change
	return type to boolean (Oskar Liljeblad, #18648)

Wed Nov 29 20:44:09 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (gtk_clist_get_pixtext): Allow mask to 
	be NULL. (Vladimir Klebanov, #26545)

Thu Oct 26 02:10:32 2000  Tim Janik  <timj@gtk.org>

        [ Backport from 1.3 / otaylor, 29 Nov 2000 ]
	
	* gtk/Makefile.am: invoke maketypes.awk with LC_ALL=C to avoid
	localization misbehaviour.

2000-11-29  Martin Baulig  <baulig@suse.de>

	* *.pc.in: Make the pkg-config scripts actually work.

2000-11-27  Federico Mena Quintero  <federico@helixcode.com>

	* gtk/gtkspinbutton.c (gtk_spin_button_set_adjustment): Connect to
	the "changed" callback of the adjustment.  We need to redraw the
	spin button's arrows when the adjustment's range changes.
	(adjustment_changed_cb): Draw the arrows.
	(gtk_spin_button_value_changed): Draw the arrows.

Sat Nov 18 11:56:39 2000  Owen Taylor  <otaylor@redhat.com>

	[ backport from 1.3.x ] 

	* gdk/gdkrgb.c: If possible, create only a single shm segment and
	use multiple parts of it instead of creating a bunch of separate
	segments, since the maximum number of segments per system is not
	large.

	* gdk/x11/gdkimage-x11.c (gdk_image_new): Don't set gdk_use_xshm
	to False when we get EINVAL from shmget so that the caller of
	gdk_image_new can retry with a smaller segment size.

Sat Nov 18 11:45:09 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalendar.c: Patch from ChiDeok Hwang to fix
	memleaks found by Evan Martin.

2000-11-10 Elliot Lee <sopwith@redhat.com>
	
	* gtk/gtksocket.c: To handle a really weird error case (race
	condition), check if socket->plug_window is there before doing
	things with it.

Fri Nov 03  Pablo Saratxaga <pablo@mandrakesoft.com>

	* gtk/gtkrc.zh_TW.*: moved gtkrc.zh_TW.Big5 to gtkrc.zh_TW.big5;
	the charset encodign portion MUST be in lowercase.
	* gtk/gtkrc.az: added file for Azeri language

Mon Oct 16 11:39:29 2000  Tim Janik  <timj@gtk.org>

	* configure.in: up version number to 1.2.9, interface 4, binary 9.

2000-10-13  Yukihiro Nakai  <nakai@gnome.gr.jp>

	* configure.in: Add zh_CN.GB2312 (Chinese GB2312) to
	                ALL_LINGUAS

2000-09-30  Martin Baulig  <baulig@suse.de>

	* gtk+.pc.in, gdk.pc.in: Provide pkg-config scripts.

	* configure.in: Create *.pc scripts from the *.pc.in
	templates.
	* Makefile.am (pkgconfig_DATA): Install the *.pc
	scripts in `$(libdir)/pkgconfig'.

Thu Sep 07 20:50:49 2000  George Lebl <jirka@5z.com>

	* gtk/gtkmenu.c:  Backported Nils Barth's patch for submenu
	  navigation with Owen's fixes and suggestions.  The original
	  ChangeLog from Owen for HEAD goes as folllows:  Apply patch from
          Nils Barth and David Santiago to improve submenu
          navigation. The patch does this by creating a triangular
          region from the point where the pointer leaves the
          menu to the submenu.  While the pointer is in
          that region and a timeout has not expired, events
          that would cause the active submenu to change are
          ignored.

Sun Sep 03 00:47:08 2000  George Lebl <jirka@5z.com>

	* gtk/gtkwidget.h:  Add some documenting comments about 
	  GTK_CAN_DEFAULT, GTK_HAS_DEFAULT and GTK_RECEIVES_DEFAULT
	  just as owen said on irc.

	* gtk/gtkwindow.c (gtk_window_set_default):  Don't blindly
	  set HAS_DEFAULT.  Only set it if there isn't another window
	  holding it (a focus window which RECEIVES_DEFAULT) and only unset
	  it if the widget is not the focused window with RECEIVES_DEFAULT.
	  This fixes weird double default bugs in dialogs which has things
	  call gtk_window_set_default at times.

Fri Aug 18 17:27:46 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (gtk_clist_merge): Don't leave dangling
	->prev fields when merging lists. (Found simultaneously
	by Pawel Salek and Jakub Jelinek)

Sun Jul 30 14:17:43 2000  Pablo Saratxaga <pablo@mandrakesoft.com>

	* configure.in,po/{sp,sr}.po: Added Serbian files

Thu Jul 27 05:06:29 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtktable.c: applied patch from Phil Thompson
	<phil@river-bank.demon.co.uk> that enables space settings for
	the last row/columns as well.

2000-07-19  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>

	* gdk/gdk.h, gtk/gtktypeutils.h: Include gdk/gdkrgb.h and
	gtk/gtktypebuiltins.h resp. outside of the extern "C" block. Makes
	some C++ compiler happy. Reported by Denis Vakatov
	<vakatov@peony.nlm.nih.gov>.

Tue Jul 11 20:47:13 2000  Tim Janik  <timj@gtk.org>

	* docs/gtk_tut_it.sgml (name): 
	* docs/gtk_tut_fr.sgml (name): 
	* docs/gtk_tut.sgml (name): scratched notion of completely
	outdated email adress: s/timj@psynet.net/timj@gtk.org/.

Tue Jul 11 08:04:58 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtktree.c (gtk_real_tree_select_child): eek, i've never seen
	a bug here, never been here and never fixed anything ;(
	(don't segfault if tree->root_tree is NULL, which happens prior
	to widget realization, but puke instead).

Sun Jun 18 15:35:35 2000  Pablo Saratxaga <pablo@mandrakesoft.com>

	* gtk/gtkrc.cp1251,gtk/Makefile.am: the cp1251 is also used by
	Byelorussian language; changed the Makefile and file names 
	to reflect that.

Sun Jun 11 12:46:19 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_set_default_icon): Fix
	cut and paste typo where wrong pixmap was being
	unref'ed. (Pointed out by a friend of KUSANO Takayuki.)

Sun Jun 11 10:22:36 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.c (gtk_selection_bytes_per_item):
	Add helper function to compute format / bytes 
	relationship. Use in a couple places to fix up
	errors which assume 8 * format.

	* gtk/gtkselection.c (gtk_selection_request): Use 32
	rather than 8 * sizeof (GdkAtom), to work correctly
	on Alpha.

Thu May 25 03:54:30 2000  Tim Janik  <timj@gtk.org>

	* released Gtk+-1.2.8.

Thu May 25 02:30:57 2000  Tim Janik  <timj@gtk.org>

	* configure.in: gtk version 1.2.8, interface age 3, binary age 8.

Fri May 19 09:54:53 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_clip_rect): fix mangling of rectangle
	height with its width, spotted by Justin David Smith (Ytinasni)
	<justins@velius.chaos2.org>.

Fri May 19 06:49:23 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkfontsel.c (gtk_font_selection_get_font_name): handle
	"(nil)" foundries, patch from Grigorios Magklis.

	* gtk/gtkfontsel.c (gtk_font_selection_load_font): don't crash
	on non-available fonts, based on a patch by Grigorios Magklis
	<maglis@cs.rochester.edu>.

Fri May 19 05:52:08 2000  Tim Janik  <timj@gtk.org>

	* gdk/gdkx.h: wrap contents into extern "C" { }, patch by Leonardo
	Zide (leo@lokigames.com).

Wed May 17 01:03:50 2000  Raph Levien  <raph@acm.org>

	* gdk/gdkrgb.c (gdk_rgb_try_colormap): Changed the behavior
	when the number of colors requested (gdk_rgb_min_colors)
	exceeds the maximum cube tried. Old behavior segfaulted. New
	behavior just uses the maximum cube.

Mon May  8 16:16:53 1999  Pablo Saratxaga <pablo@mandrakesoft.com>

        * gtk/gtkrc.*: added "*-r-*" to all fontsets; that works quite well,
	always finding a font (maybe not very nice, but at least readable)

Thu May  4 02:04:46 2000  Tim Janik  <timj@gtk.org>

        * configure.in (STRIP_DUMMY): some Make 3.79 $(strip ) versions are
        broken and require an empty arg, give it to them.

Sun Mar 26 03:21:28 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtksignal.c (gtk_signal_handlers_destroy): when unref-ing
	the handlers, also invalidate them. bug nailed down by Karl Nelson
	<kenelson@ece.ucdavis.edu>.

Mon Mar 13 18:37:55 2000  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c: Fix a bunch of cases where XGetWindowProperty()
	is called without trapping X errors.

Thu Mar  9 22:10:56 GMT 2000  Tony Gale <gale@gtk.org>

        * docs/gtkfaq.sgml: FAQ Update:
          - Minor cleanups (Emmanuel, me)
          - New questions:
                I need to add a new signal to a GTK+ widget. Any idea? (timj)
                How can I retrieve the text from a GtkMenuItem? (timj)
                How do I validate/limit/filter the input to a GtkEntry? (me)
                Memory does not seem to be released when I free the list
                        nodes I've allocated (timj)

Tue Feb 29 13:10:00 GMT 2000  Tony Gale <gale@gtk.org>

        * gdk/gdkwindow.h gdk/x11/gxid.c gtk/gtkclist.c gtk/gtkclist.h
          gtk/gtkctree.c gtk/gtkmenu.h gtk/gtkwidget.c gtk/testgtk.c
          docs/styles.txt docs/refcounting.txt docs/gtkfaq.sgml
          docs/gtk_tut.sgml docs/gtk.texi TODO:

          Spelling/grammar fixes from Martin Buchholz <martin@xemacs.org>

Fri Feb 25 10:48:53 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.*: Fix problem where stray '"' characters found their
	way into the fontset lists.

Thu Feb 24 16:12:27 GMT 2000  Tony Gale <gale@gtk.org>

	* gtk/gtkcalendar.c: Implement num_marked_dates,
	  and don't emit mutiple day_selected signals on
	  month_prev.
 
Wed Feb 23 10:54:14 GMT 2000  Tony Gale <gale@gtk.org>

	* docs/gtk_tut.sgml: New section on GtkCalendar
	* examples/calendar: Update example code

Tue Feb 22 13:54:12 GMT 2000  Tony Gale <gale@gtk.org>

        * docs/gtkfaq.sgml: FAQ Update

Tue Feb 22 08:52:52 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkthemes.h: add extern "C" scope.

Mon Feb 21 20:16:42 2000  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c: applied  patch from Guy Harris <guy@netapp.com>
	to make appends to the list constant. (gtk-guy-990901-0.patch)

2000-02-19  Havoc Pennington  <hp@pobox.com>

	* docs/gtk_tut.sgml: Don't recommend the use of 
	gtk_signal_handlers_destroy, closes bug #6390

Thu Feb 17 02:19:32 2000  Tim Janik  <timj@gtk.org>

	* gdk/gdk.h:
	* gtk/gtkaccelgroup.h:
	* gtk/gtkthemes.h: remove extraneous prototypes, patch from
	Sam O'Connor <oconnor@eiffel.com>.

Wed Feb 16 05:22:36 CST 2000 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.7

Mon Feb 14 22:50:10 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtktypeutils.c (gtk_type_init): use g_str_hash() and g_str_equal()
	for the typename hash table.

Mon Feb 14 15:01:23 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkpaned.c (gtk_paned_compute_position): Add some sanity checks
	to make sure we never divide by zero. 
	(Problem pointed out by Michal Jaegermann <michal@ellpspace.math.ualberta.ca>)

Mon Feb 14 12:29:38 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c: Apply patch from
	SHIRASAKI Yasuhiro <yasuhiro@awa.tohoku.ac.jp> to make font selector work a little
	better with 2-byte fonts. (Load a fontset instead of a font for two byte fonts.)

	Also, some cleanups in atom handling.

Sun Feb 13 08:02:21 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtksocket.c (gtk_socket_class_init): parent class is GtkContainer,
	not GtkWidget.

Fri Feb 11 02:19:32 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkhpaned.c (gtk_hpaned_size_allocate): 
	* gtk/gtkvpaned.c (gtk_vpaned_size_allocate): 
	* gtk/gtkpaned.c (gtk_paned_compute_position): had to squeeze some
	more guint wrap-around bugs before going to bed.

Thu Feb 10 16:16:35 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkspinbutton.c (gtk_spin_button_size_allocate): guard against
	guint wrap arounds in allocation.width.

	* gtk/gtktable.c (gtk_table_size_allocate_pass1): repeat shrinking
	process untill we fit the allocation given.

Tue Feb  8 09:38:29 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c:
	(gtk_widget_unrealize): guard widget access with ref/unref
	around signal emission.
	(gtk_widget_hide): same here, but also check its destroyed
	state before queueing a resize.

Tue Feb  8 03:05:55 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkstyle.c (gtk_style_new): use gtk_default_prelight_bg instead
	of gtk_default_insensitive_bg as insensitive base color.

	* gtk/gtktext.c (gtk_text_style_set): set the background color according
	to the widget's state.
	(gtk_text_realize): same here.
	(gtk_text_state_changed): same here.
	(draw_bg_rect): compare background color against base[] from
	GTK_WIDGET_STATE (text) not GTK_STATE_NORMAL.

Mon Feb  7 04:01:55 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkmain.c (gtk_main_do_event): ignore delete events when
	grabs are active, unless a delete event is send to the toplevel
	of the currently grab holding widget.

Sun Feb  6 10:13:15 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c (gtk_ctree_drag_data_received): Remove
	debugging g_print's.

Fri Feb  4 19:40:50 2000  Tim Janik  <timj@gtk.org>

	* configure.in: up version number to 1.2.7, interface age 2, binary
	age 7. depend on glib 1.2.7.
	
	* NEWS: updates.

Fri Feb  4 15:54:54 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_size_request): Don't
	ever make the scrolled-window requisition ever depend on the 
	visibility state of the scrollbars for the AUTOMATIC policy. 
	This breaks the	GTK+ requisition model, and causes loops.

Fri Feb  4 15:09:12 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_style_new): Set the charset explicitely for
	the default font to avoid problems with XFree86-4.0 where the
	default charset is iso10646-1, not iso8859-1.

Thu Feb  3 14:58:48 PST 2000 Manish Singh <yosh@gimp.org>

	* acinclude.m4
	* config.guess
	* config.sub
	* ltconfig
	* ltmain.sh: upgrade to libtool 1.3.4 (bugfix only release)

	* gtk/Makefile.am: minor cosmetic consistency tweak

Thu Feb  3 14:46:01 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.c (gtk_menu_shell_button_release): Set
	the activate_time to 0, so that we handle a quick
	press/release press/release properly and don't suppress
	the second release. (Red Hat bug #7545)

Wed Feb  2 22:25:17 2000  Tim Janik  <timj@gtk.org>

	* gtk/gtkctree.c (row_delete):
	(gtk_ctree_node_set_row_data_full): fixed very evil reentrancy
	bugs with destruction notifier, *always* update internal
	structures *before* calling user code.

Sun Jan 30 20:10:52 2000  Lars Hamann  <lars@gtk.org>

	A few more fixes for bug #5487, #2051, #2677.
	* gtk/gtkclist.c : 
	(gtk_clist_button_press):  Reset clist->anchor to -1 if event->type is
 	not GDK_BUTTON_PRESS.
	(resync_selection): resync only if selection_mode is
	GTK_SELECTION_EXTENDED
	* gtk/gtkctree.c (resync_selection): same here

Sun Jan 30 12:29:20 2000  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.h gtk/gtkmenu.h: Removed duplicate prototypes for
	gdk_drag_get_selection() and gtk_menu_detach().

	[ From Jeroen Ruigrok/Asmodai ]

Sat Jan 29 10:11:56 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_size_request): 
	page->tab_label can be NULL.

2000-01-25  Havoc Pennington  <hp@pobox.com>
	
	* gdk/gdkwindow.c (gdk_window_set_back_pixmap): parent_relative
	arg is boolean

	* gdk/gdkselection.c (gdk_selection_owner_set): return boolean

	* gdk/gdkrectangle.c (gdk_rectangle_intersect): return boolean

	* gdk/gdkproperty.c (gdk_property_get): return boolean

	* gdk/gdkinput.c (gdk_input_set_mode): return boolean

	* gdk/gdkim.c (gdk_im_ready): return boolean

	* gdk/gdkgc.c (gdk_gc_set_exposures): gboolean arg

	* gdk/gdkfont.c (gdk_font_equal): return gboolean (mild
	glib clash, should fix glib)

	* gdk/gdkevents.c (gdk_set_show_events): take gboolean arg
	(gdk_get_show_events): return gboolean, and canonicalize 
	to TRUE/FALSE

	* gdk/gdkcolor.c (gdk_colormap_new): gboolean flag whether the
	colormap is private
	(gdk_colors_alloc): gboolean whether to be contiguous
	(gdk_color_equal): return gboolean since we are a predicate
	and not a qsort() (this looks semi-wrong due to glib breakage,
	IMO glib should be fixed)
	
	* gdk/gdk.c (gdk_set_use_xshm): take gboolean arg
	(gdk_get_use_xshm): return gboolean
	(gdk_pointer_is_grabbed): return gboolean

	* gdk/gdk.h: Change prototypes to match all the above changes,
	and re-run egtk-format-protos as required.

Fri Jan 28 12:28:17 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c (resync_selection): 
	* gtk/gtkclist.c (resync_selection):

	Return immediately if clist->drag_pos < 0. This is a workaround
	for the corrupt state that the clist gets into when a
	GDK_2BUTTON_PRESS occurs. See note in gtk_clist_button_press().

	Bug #5487, #2051, #2677; fix suggested by David Helder and T. Alexander Popiel.
	
	* gtk/gtknotebook.c (gtk_notebook_size_request): Fix uninitialized
	variable from recent commit.

Thu Jan 27 15:22:09 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_begin): Fix stupid typo in last commit.

Thu Jan 27 18:00:55 2000  Tim Janik  <timj@gtk.org>

	* gtk/Makefile.am: prefix all autogenerated source that get build in
	$(srcdir) with $(srcdir)/, so make doesn't assume they got generted
	in builddir. since we subsequently cd into srcdir for autogeneration,
	the paths have to be stripped from the target file names, thusly we
	use $(@F) as target names now.
	put a comment about configure.in's --disable-rebuilds option,
	which can be used for non-writable source directories, for development
	setups though, srcdir has to be *writable*.

Thu Jan 27 00:15:03 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_begin gtk_drag_get_event_actions):
	  Finish the job of allowing event to be NULL.
	  (Fixes bug #4283, reported by Chris Blizzard)

	* gtk/gtkentry.c (entry_adjust_scroll): When calculating
	  things so that the cursor appears on screen, properly
	  take into account INNER_BORDER.
	  (Fixes bug #4754, reported by Antonio Campos)

Wed Jan 26 23:12:28 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_map): Don't
	  show the tab_label unless it itself is visible.

	  gtk/gtknotebook.c (gtk_notebook_size_request):
	  Do a better job of making sure that the visibility
	  of the tab label corresponds to whether it should
	  be mapped or not.

Wed Jan 26 21:17:03 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_position):
	  Use the requisition, not the allocation, since the
	  allocation has not necessarily been computed yet.
	  (Pointed out by Eugene Osintsev)

Wed Jan 26 19:44:25 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_style_new): Dont' set
	  style/base[GTK_STATE_INSENSITIVE] both to
	  gtk_default_insensitive_bg!
	  (Bug #2187, reported by Jonathan Blandford)

	* gtk/gtkaccelgroup.c (gtk_accelerator_valid):
	  Add Alt_L, Alt_R to list of invalid accelerators.
	  (Bug #3736, reported by Vlad Harchev)

Wed Jan 26 19:01:56 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (open_ref_dir): Fix several
	bugs which occured after an attempt to open 
	invalid home directory left cmpl_state->reference_dir == NULL.

	 - completion on files in home directory didn't work
	 - completion on an empty string caused  segfault

	 (Bug #3678, reported by Steve Ratcliffe)

	* gtk/gtkscale.c (gtk_scale_get_value_width): Fix
	cut and paste error that was causing scales to
	be incorrectly positioned.
	(Bug #2956,
	 patch from Steve Ratcliffe <steve@parabola.demon.co.uk>)

2000-01-27  Shirasaki Yasuhiro  <yasuhiro@gnome.gr.jp>

	* acinclude.m4 (AM_GTK_WITH_NLS): Add -lintl to libs
	when checking for dcgettext, if we've found we needed
	it for dgettext.

Wed Jan 26 18:06:07 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_queue_clear_area): Ignore
	queue_clear on NO_WINDOW widgets during a reparent,
	since at that point the window and widget heirarchies
	are out of sync. This stops crashing in some cases
	(the scrolled window reparent test, for instance), and
	_probably_ won't cause drawing errors.

	* gtk/testgtk.c: Make the reparenting-a-scrolled-window
	test do what it was supposed to do and be robust against
	window closings, etc. (Bug #2443)

Wed Jan 26 16:56:54 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c: Fix return values on mouse events.
	(Bug #2686, Sky <seb_sky@yahoo.com>)

	* gtk/genmarshal.pl: Fix up handling of FOREIGN.
	(pointed out by George Lebl)

 	* gdk/gdkcolor.c (gdk_color_copy): Made const-safe.
	(From Ettore Perazzoli  <ettore@helixcode.com>)
 
Mon Jan 24 10:44:48 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalendar.c (gtk_calendar_main_button): Handle
	clicks between rows or outside calender area correctly.
	(Patch from Damon Chaplin)

	* gtk/gtkclist.c (gtk_clist_set_row_data_full): 
	* gtk/gtkctree.c (gtk_ctree_node_set_row_data_full): 
	  Call destroy function when overwriting existing data. 
	  (Pointed out by Damon Chaplin)

Tue Jan 25 09:55:41 2000  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c: Remove useless #include of <X11/Xmu/WinUtil.h>,
	  which was causing problems on various systems with Xmu.
	  This hasn't been needed for a very long time.
	  (Fixes #1185 3167)

Sun Jan 23 22:27:36 2000  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdki18n.h: Include <ctype.h> when defining
	  gdk_isw* in terms of is* as a fallback.
	  (Bug #4106 - Dan Winship <danw@MIT.EDU>)

Sun Jan 23 22:12:36 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkviewport.c (gtk_viewport_size_allocate): Don't
	  realize the widget when it is size allocated!
	  (old, old bug)

	* gtk/gtkviewport.c (gtk_viewport_adjustment_value_changed):
	  Removed unused call to gdk_window_get_size() that
	  showed up when the above was fixed.

Sun Jan 23 20:52:40 2000  Owen Taylor  <otaylor@redhat.com>

	* INSTALL: Added short note about setting LDFLAGS
	  and CPPFLAGS to find libraries not in the default
	  install path. Fixed env/setenv confusion for csh.

Sat Jan 22 15:44:30 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_reparent): Correctly
	  fix up widget->window when the widget is a
	  NO_WINDOW container widget.

Sat Jan 22 12:40:48 2000  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpixmap.c (gdk_pixmap_seek_string): Rewrite
	  to account for the fact that feof() does _not_ 
	  return TRUE on errors, and thus avoid infinite loops
	  when trying to use gdk_pixmap_create_from_xpm()
	  on unreadable values.

Fri Jan 21 18:32:43 2000  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaspectframe.h (struct _GtkAspectFrame): s/gint/gboolean/.

Fri Jan 21 16:24:08 2000  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkgc.c (gdk_gc_set_dashes): Change from
	  gdk_gc_set_dashes to take gint8 instead of gchar to
	  make it clearer that it is _not_ a NULL terminated string.

	* gdk/gdk.h gdk/gdkfont.c gdk/gdkgc.c gdk/gdkselection.c
	  gdk/gdkwindow.c gtk/gtkprogress.[ch] gtk/gtkthemes.[ch]
	  gtk/gtktreeitem.[ch] gtk/gtkwidget.[ch]: Constify string
	  arguments.

2000-01-13 Elliot Lee <sopwith@redhat.com>
	
	* gtk/gtktooltips.c: Add note about gtk_tooltips_set_colors().

2000-01-07  Jesus Bravo Alvarez  <jba@pobox.com>

	* configure.in (ALL_LINGUAS): Oops, Galician (gl) wasn't there yet

Thu Dec 30 04:51:05 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkvscale.c (gtk_vscale_pos_background): 
	* gtk/gtkhscale.c (gtk_hscale_pos_background): when calculating the
	background size relative to our allocation, guard against small
	allocations, we may have not yet been size allocated.

Fri Dec 24 03:41:33 1999  Tim Janik  <timj@gtk.org>

	* gtk/Makefile.am: reverted sopwith's changes to Makefile.am,
	the builddir != srcdir case was already handled fine, and his
	"fix" would produce multiple copies of the built sources.
	for development you just need a writable srcdir.

December 20, 1999 Elliot Lee <sopwith@redhat.com>

	* gtk/Makefile.am: Fix builddir != srcdir for
	  generation of gtktypebuiltins*.[ch]

Thu Dec  2 10:59:14 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c (xdnd_check_dest): Allow version >= 3,
	not just version == 3. We implement all 3 + most of 4 - 
	(we don't support matching text/plain;charset=iso-8859-1
	to a dest that expects text/plain). We'll still advertise
	3 to be safe, but any client implementing version >= 3
	must interoperate with 3.
	
Tue Nov 16 10:15:54 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkitemfactory.c (gtk_item_factory_parse_path):
	If translation does not include a '/', use entire
	translation instead of crashing.

Mon Nov 15 17:17:51 GMT 1999 Tony Gale  <gale@gtk.org>

        * docs/gtkfaq.sgml: s/gtk_main_iteration/g_main_iteration/

Sat Nov 13 22:30:29 GMT 1999 Tony Gale  <gale@gtk.org>

        * docs/gtkfaq.sgml: threads example from Erik Mouw.
        New question on GtkLabel background colors.

        * docs/gtk_tut.sgml:
          - Correct the example code callback
            function definitions.
          - Update the gtkdial example code, from Frans van Schaik.
          - Update setselection.c to current API.
	  - Merge the various versions of this document.

	* examples/Makefile examples/*/*.c: Update to code
	listed in tutorial.

Fri Nov 12 22:24:14 MET 1999  Sven Neumann <sven@gimp.org>

	* gdk/gdkinputcommon.h
	* gdk/gdkinputxfree.h: Call XFreeDeviceState() on results of 
	XQueryDeviceState(). (Ported from HEAD)

Wed Nov 10 17:26:49 GMT 1999 Tony Gale  <gale@gtk.org>

        * gtk/gtkclist.c: Fix off-by-one bug in parameter
        check.

Sun Oct 31 22:21:11 1999  Tim Janik  <timj@gtk.org>

	* docs/gtk_tut.sgml:
	s/gtk_accel_group_attach/gtk_window_add_accel_group/.

Sat Oct 30 13:17:18 BST 1999 Tony Gale <gale@gtk.org>

        * docs/gtkfaq.sgml: FAQ update

Sat Oct 30 09:09:09 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.c (gtk_target_list_remove): Use
	g_list_remove_link, not g_list_remove.

	[ From Geert Bevin <gbevin@thunderstorms.org> ]
	
Sun Oct 24 07:41:40 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkclist.c (real_undo_selection): commented out g_print()
	statement upon unselection (how the heck did that slip in?).

Sat Oct 23 03:03:08 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtktext.c (gtk_text_freeze): 
	(gtk_text_thaw): undraw/draw cursor here to avoid unnecessary scrolling
	in frozen state (and aparently crashes). patch provided by Anders
	Melchiorsen <and@kampsax.dtu.dk>.

Sat Oct 23 02:53:20 1999  Tim Janik  <timj@gtk.org>

	* fix insensitive default/focus widget activation,
	reported by Matt Goodall <mgg@isotek.co.uk>.

	* gtk/gtkwindow.c (gtk_window_key_press_event): 
	(gtk_window_activate_default):
	(gtk_window_activate_focus):
	return handled=FALSE for actiavtion of insensitive default
	widgets. return handled=TRUE for activation of insensitive
	focus widgets. don't activate in either case.

Tue Oct 19 09:55:08 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk-config.in (lib_gtk): Switch order of @x_cflags@
	and $glib_cflags to match library order and in the
	theory that an old version of GLib is more likely to
	be in the include directory for X then vice-versa.
	(Bug #2776)

Tue Oct 19 09:46:49 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_init): Always use LC_CTYPE 
	to determine the locale for fontsets, not LC_MESSAGES;
	the user may want English messages with a handling
	for non-English languages. (LC_CTYPE=ru_RU LC_MESSAGES=fr_FR
	will still be broken) (Bug #2891)

Tue Oct 19 20:36:42 1999  Changwoo Ryu  <cwryu@adam.kaist.ac.kr>

	* gtk/gtkrc.ko: Fixed the wrong number of "*"'s.

Tue Oct 19 12:15:13 1999  Changwoo Ryu  <cwryu@adam.kaist.ac.kr>

	* gtk/gtkrc.ko: Changed the Korean default fontset.

Fri Oct  8 10:55:51 CDT 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.6

Fri Oct  8 02:32:47 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklayout.c (gtk_layout_adjustment_changed): Fix bug
	where when scrolling to the left or top double exposes
	were done, causing major slowdowns.

Thu Oct  7 18:31:55 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_init): Always normalize codeset
	names to lowercase and alphanumeric, before looking
	them up.

	* gtk/Makefile.am: Install codeset variant gtkrc files
	with normalized names.

Thu Oct  7 22:52:42 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkitemfactory.c (gtk_item_factory_popup_with_data): even
	popup menus when the menu is already visible, but its parent
	is still hidden, (happens after tornoff window got hidden).

Thu Oct  7 11:09:55 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am (install-data-local): Fix
	a typo where gtkrc.vi_VN.tcvn5712 wasn't getting
	deleted, causing error messages on install.

Thu Oct  7 11:03:06 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk[hv]paned.c (gtk_{h,v}paned_draw): Redraw
	the handle as well, since we now sometimes ignore
	exposes on the handle while resizing.

Wed Oct  6 18:02:31 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_append_default_pixmap_path): Fix stupid
	extra g_free introduced in one of the last one or two 
	commits.

Wed Oct  6 16:38:36 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am gtk/gtkrc*: Make naming of gtkrc files
	consistent, put each style that a gtkrc.* file creates
	in a unique namespace, remove old files before installing.

Wed Oct  6 14:31:16 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_init): Avoid leaking memory when
	gtk_rc_init is called multiple times. (Yes, people who
	do that have bugs in their code.)

Tue Oct  5 11:36:57 PDT 1999 Manish Singh <yosh@gimp.org>

	* gtk/Makefile.am: listing gtkrc in gtkconf_DATA seems to barf.
	Remove it since it's generated by the Makefile anyway

Tue Oct  5 02:43:41 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkinputcommon.h (gdk_input_device_new): Free
	device->info.axes for core pointer.

Mon Oct  4 16:16:53 1999  Pablo Saratxaga <pablo@mandrakesoft.com>

        * gtk/gtkrc.{bg,iso88591[345]}: add gtkrc files for some new charset
        encodings: iso-8859-13 (for Lithuanian), iso-8859-14 (used by celtic
        languages), iso-8859-15 (used in Estonia) and microsoft-cp1251 (used
        by Bulgarian).

1999-10-01  Kjartan Maraas  <kmaraas@online.no>

	* configure.in: Added "uk" to ALL_LINGUAS.

Thu Sep 30 13:55:25 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/testgtk.c (destroy_idle_test): Rename idle to 
	idle_id, to deal with obsolete, broken C libraries.

Wed Sep 29 15:41:08 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktreeitem.c (gtk_tree_item_size_allocate): 
	Get rid of stupid C unsigned integer bug.
	(Bug #2440)

1999-09-28  Kjartan Maraas  <kmaraas@online.no>

	* configure.in: Added "ro" to ALL_LINGUAS.
	
Mon Sep 27 02:50:15 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkvscale.c (gtk_vscale_draw): Don't add in
	allocation->x/y twice!

	* gtk/gtkhscale.c: Make usage of gtk_hscale_pos_trough()
	consistent with gtk_vscale_pos_trough().

Sun Sep 26 19:44:34 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcontainer.c (gtk_container_queue_resize): We may
	be queueing a resize on a toplevel container between
	the time we show it and when we map it. So, we need
	to test GTK_WIDGET_VISIBLE() for toplevels, and only
	use GTK_WIDGET_DRAWABLE() for child windows.

Thu Sep 23 20:11:38 CDT 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.5

Fri Sep 24 02:00:21 1999  Tim Janik  <timj@gtk.org>

	* configure.in (GTK_VERSION): changed version from Gtk+-1.2.5-pre2,
	to Gtk+-1.2.5, interface age 0, binary age 5.
        
Thu Sep 23 16:41:03 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am (LDADDS): Add GDK_WLIBS to LDADDS 
	(fixes bug #2144)

Fri Sep 24 00:51:45 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkcontainer.c (gtk_container_queue_resize): check for
	container DRAWABLE (instead of VISIBLE), so we don't queue
	resizes on non-toplevel containers.

Thu Sep 23 17:59:59 1999  Tim Janik  <timj@gtk.org>

        * gdk/gdkevents.c (gdk_event_translate): grr, even if Gdk doesn't
        handle CreateNotify itself, still put out a debuging message for
        --gdk-debug=events. made the ReparentNotify debugging message more
        verbose.
        wrap xcoords translation for ConfigureEvents into an error trap,
        a destroy event may already be pending, and in that case, the
        actuall coordinate values are not at all critical.

Mon Sep 20 13:17:39 1999  Pablo Saratxaga <pablo@mandrakesoft.com>
	
	* configure.in,po/pt_BR.po: added Portuguese Brazilian file from
	Alex Sandro Queiroz e Silva <asandro@lcg.dc.ufc.br>

Mon Sep 20 01:21:53 1999  Tim Janik  <timj@gtk.org>

	* released Gtk+-1.2.5-pre2, interface age 0, binary age 5.

Sun Sep 19 18:13:31 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.[ch]: Make the data argument
	const guchar *.

Sat Sep 18 22:24:15 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkcc.c: Stop leaking the color_hash all over
	the place. Simplify and improve the logic.

Sat Sep 18 21:27:40 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c: Try to behave sensibly if 
	the focus widget is the window itself. (Should
	we allow this at all?)

Fri Sep 17 09:57:15 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_set_sensitive): 
	* gtk/gtknotebook.c (gtk_notebook_set_scrollable): 
	* gtk/gtknotebook.c (gtk_notebook_set_show_border): 
	* gtk/gtkclist.c (gtk_notebook_set_show_border): make gboolean args
	in prototypes and implementations consistent (Tomas Ogren).

	* gdk/gdk.h, gdk/gdkcolor.c: make return types (gint or gboolean)
	for prototypes and function implementations consistent (reported
	by Tomas Ogren).

	* gtk/gtklayout.c (gtk_layout_remove): unset GTK_IS_OFFSCREEN flag
	before the widget is unparented (reported by damon).

	* gtk/gtkdnd.c: make the cursor and icon data _unsigned_ char,
	since we provide unsigned data anyways.

Thu Sep 16 21:32:01 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c (gtk_tooltips_set_tip): Delay
	the call to gtk_tooltips_layout_text() until later.

	* gtk/gtktooltips.c (gtk_tooltips_draw_tips):
	Call gtk_widget_ensure_style() before using the style.

Wed Sep 15 02:52:19 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_event): Added workaround
	for old widgets that don't propagate draws to all
	children. (Namely gnome-dock for gnome-libs <= 1.0.16)

Tue Sep 14 19:37:53 1999  Tim Janik  <timj@gtk.org>

	* configure.in (GTK_VERSION): slight version increment to 1.2.5-pre2.

Tue Sep 14 19:22:19 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_queue_resize): don't queue the parent
	for a redraw but just the widget that requested the resize.

Tue Sep 14 18:29:47 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkcontainer.c: added new widget level method
	gtk_container_set_reallocate_redraws() and a GtkContainer flag
	reallocate_redraws : 1 to reflect the setting, exported this through
	the argument system as a boolean ::reallocate_redraws.

	* gtk/gtkwidget.c (gtk_widget_size_allocate): when queueing redraws
	on the widget because the allocation changes, do so as well for
	widget->parent if the parent has reallocate_redraws set to TRUE.
	with that containers requesting reallocation redraws get automatically
	redrawn if their children changed allocation (this unfortunately
	affects also other children that didn't change allocation, but we
	cannot work around that before 1.3).

Tue Sep 14 18:23:01 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkevents.c (gdk_event_translate): tell if expose events have
	send_event set in debugging output.
	(gdk_compress_exposures): default initialize the event so we don't
	operate on bogus values (namely send_event).

	* gtk/gtkwidget.c (gtk_widget_idle_draw): only emit ::draw if width
	_and_ height are >0 (not _or_).

	* gtk/gtktable.c (gtk_table_remove): use gtk_widget_queue_resize()
	instead of gtk_container_queue_resize(), which is a core gtk internal
	function (must have been on crack when i queued that).

	* gtk/gtkprivate.h: added new private flag GTK_FULLDRAW_PENDING, so
	we can check more reliably if we want to discard expose events.
	* gtk/gtkwidget.c: added setting/unsetting of the GTK_FULLDRAW_PENDING
	flag.
	
	* gtk/gtkwidget.c (gtk_widget_event): don't discard synthesized exposes,
	we simply trust these events. for deciding whether to discard exposes,
	check GTK_FULLDRAW_PENDING instead of RESIZE_PENDING.
	
Mon Sep 13 15:01:21 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_queue_clear_area): Ignore
	queues of areas that are completely off screen.

	* gtk/gtkwidget.c (gtk_widget_idle_draw): Fix broken
	logic for handleboxes.

	* gtk/gtkwidget.c (gtk_widget_queue_draw_data): Add santity
	check on width/height.

Mon Sep 13 02:22:47 1999  Tim Janik  <timj@gtk.org>

	* gtk/Makefile.am: backed out Raja's recent VPATH build "improvements",
	we are fine with using $@ the way we do (if we actually encounter
	brokeness with $@ in VPATH builds because of additional path prefixes,
	we need to use $(@F) actually).

Mon Sep 13 01:34:53 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtksignal.c: renamed two variables, hopefully didn't introduce
	short lived bugs, that would allow language bindings to do surgeries
	to our guts.

1999-09-12  Raja R Harinath  <harinath@cs.umn.edu>

	* configure.in (wctype): Fix AC_DEFINEs.

Fri Sep 10 21:31:00 1999 Pablo Saratxaga <pablo@mandrakesoft.com>

	* po/et.po,configure.in: added Estonian language file
	* po/el.po: added Greek file from gtk+ HEAD cvs

Fri Sep 10 15:22:50 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_size_allocate): Fix typo
	where comparison was being done against an uninitialized
	value causing intermittant results depending on
	compiler flags. Also make it clearer that we aren't
	ever initializing the child as 0x0 (though this will
	be caught in gtk_widget_size_allocate())

Fri Sep 10 10:06:56 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_set_transient_for): Move
	gtk_window_unset_transient_for() call after we do checks
	involving the old transient parent.
	[ From Lance Capser <lmc@cyberhighway.net> ]

Wed Sep  8 07:13:29 1999  Tim Janik  <timj@gtk.org>

	* configure.in: fixed "GNU Make" check to pass with new make version
	3.77.95.

1999-09-07  Raja R Harinath  <harinath@cs.umn.edu>

	* gtk/Makefile.am (gtk.defs): Go back to using `touch' to create
	an empty file.

Mon Sep  6 00:11:56 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (gtk_ctree_is_ancestor): return FALSE if node has
	no children. (Reported by: Chris Rogers <gandalf@pobox.com>)

1999-09-03  Raja R Harinath  <harinath@cs.umn.edu>

	* gtk/Makefile.am (gen_sources): Improve VPATH builds.
	`$@' is valid only in the build dir, not after we've done 
	`cd $srcdir'.  Also use `test -f' instead of less portable
	`test -e'.

Fri Sep  3 17:20:57 CDT 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.5-pre1  (test release)

Fri Sep  3 15:59:56 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.c (correct_cache_insert): Rewrite
	 for simplicity, and hopefully correctness.
	 (Fixes bug #1322, which was a segfault when
	  on some insertions with the properties around
	  the insertion set up just wrong.)

	* gtk/gtktext.c (gtk_text_adjustment): When we receive
	 a "changed" signal, clamp the new value to the adjustment
	 bounds to avoid segfaulting if someone tries to change
	 the adjustment to a bogus value. (Bug #1795)

Thu Sep  2 16:33:59 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c: When we receive an unexpected
	destroy notify on one of our windows, don't just
	warn about it, also mark our windows as destroyed.

	* gtk/gtkmain.c: Ignore unexpected destroy notifies
	for children, for toplevel windows handle them
	like delete_event.

	* gtk/gtkplug.c: Add an unrealize handler so that
	we unref plug->socket_window when we are done
	with it.

Fri Sep  3 14:52:54 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.c (clear_area): Fix stupid signedness
	 problem that was causing background to sometimes
	 be misaligned.

Fri Sep  3 12:26:33 1999  Owen Taylor  <otaylor@redhat.com>

	[ Fixes pointed out by Ettore Perazzoli <ettore@comm2000.it> ]
	
	* gtk/gtkmenu.c (gtk_menu_position): Make
	 sure we never position menus with negative x, y,
	 since gtk_widget_set_uposition() can't handle that.

	* gtk/gtkmenuitem.c (gtk_menu_item_position_menu):
	 Modify the positioning code a bit so that we always
	 put the top-left corner onscreen. (This is for
	 UI reasons, gtk_menu_position() now takes care of
	 gtk_widet_set_uposition() brokeness.)

Fri Sep  3 16:04:41 1999  Tim Janik  <timj@gtk.org>

	* gtk-config.in (--version): don't echo @GTK_VERSION@, but
	@GTK_MAJOR_VERSION@.@GTK_MINOR_VERSION@.@GTK_MICRO_VERSION@, so the
	AM_PATH_GTK() macros don't get confused by the -pre1.

Fri Sep  3 03:06:30 1999  Tim Janik  <timj@gtk.org>

	* configure.in: changed version number to 1.2.5-pre1,
	interface age 0, binary age 5. we still require Glib-1.2.4 though.
	
	* gtk/Makefile.am: fixed up things for -jx, x > 1.
	
	* NEWS: updates for 1.2.5.

Sun Sep  5 08:48:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_modify_style): Ref the
	  RC style that is passed in. The lack of the ref
	  before was a bug. If people worked around this
	  bug, this will introduce a slight memory leak
	  in their code. The code should typically look like:

	    rc_style = gtk_rc_style_new ();
	    [...]
	    gtk_widget_modify_style (widget, rc_style);
	    gtk_rc_style_unref (rc_style);

	* gtk/gtkwidget.c (gtk_widget_modify_style): Reset
	  the style if it was already set.

	* gtk/gtkwidget.c (gtk_widget_set_name): Only set the
	  style if it was set before.

Sun Sep  5 08:10:53 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkfont.c (gdk_font_hash_insert): Add
	  name => font and name => fontset hashes. The 
	  name => fontset hash is a _big_ win since we
	  weren't previously caching fontsets at all and loading
	  fontsets is expensive. The name => font hash
	  is less of a win, but it does save us from doing
	  repeated XQueryFont calls on the same font.

	* gdk/gdkprivate.h (struct _GdkFontPrivate): Add a names
	  list so we can remove font/fontset from hash.

Thu Sep  2 19:02:37 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkproperty.c (gdk_atom_intern): Remove useless
	  and slightly confusing test. [ XInternAtom (,,TRUE)
	  will never return None ].

	* gtk/testgtk.c (main): Add a check to see if we
	  are being run from the correct directory and
	  to quit nicely if we are not.

	* gtk/gtkrc.c (gtk_rc_slist_remove_all): Make function
	  static.

	* configure.in (REBUILD): Change check for perl5
	  to check explicitely for v >= 5.002. (5.001
	  does not work with our scripts.)

Thu Sep  2 23:00:03 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkenums.h (GtkWindowPosition): added GTK_WIN_POS_CENTER_ALWAYS.

	* gtk/gtkwindow.c:
	queue resizes unconditionally (gtk_widget_queue_resize will figure
	what to do if the window is not realized).
	(gtk_window_move_resize): only recenter the window
	for GTK_WIN_POS_CENTER_ALWAYS.
	(gtk_window_compute_reposition): handle GTK_WIN_POS_CENTER_ALWAYS in
	the same way as GTK_WIN_POS_CENTER.

Thu Sep  2 22:39:27 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c (gtk_window_reposition): check for the last position
	with (!(info->last_flags & GDK_HINT_POS)) instead of
	(!info->last_flags & GDK_HINT_POS).

	* gtk/gtkwindow.c (gtk_window_move_resize): constrain new_width and
	new_height unconditionally, because we use these values even if
	!default_size_changed && !hints_changed.
	comented the (default_size_changed || hints_changed) case with
	respect to resize rejects from the window manager.

	* gtk/gtkwindow.c (gtk_window_move_resize): save info->last values
	in the zvt condition hack, since this includes the window hints, set
	the hints after the handling_resize case.

	* gtk/gtkwindow.c (gtk_window_show): constrain the default size that a
	window is initially shown with to the geometry.

Thu Sep  2 07:38:56 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c (gtk_window_move_resize):
	s/size_changed/default_size_changed/g so i know what's
	really going on (frying brain on smaller flame now).

Thu Sep  2 05:47:47 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c (gtk_window_move_resize): queue a new resize if
	we have size_changed upon handling_resize. this is a gross
	workaround for the broken zvt widget and should be removed in
	1.3 again (search for FIXME).
	Owen provided an accurate comment for this:

        /* We could be here for two reasons
         *  1) We coincidentally got a resize while handling
         *     another resize.
         *  2) Our computation of size_changed was completely
         *     screwed up, probably because one of our children
         *     is broken. It's probably a zvt widget.
         *
         * For 1), we could just go ahead and ask for the
         * new size right now, but doing that for 2)
         * might well be fighting the user (and can even
         * trigger a loop). Since we really don't want to
         * do that, we requeue a resize in hopes that
         * by the time it gets handled, the child has seen
         * the light and is willing to go along with the
         * new size. (this happens for the zvt widget, since
         * the size_allocate() above will have stored the
         * requisition corresponding to the new size in the
         * zvt widget)
         *
         * This doesn't buy us anything for 1), but it shouldn't
         * hurt us too badly, since it is what would have
         * happened if we had gotten the configure event before
         * the new size had been set.
         */

Sat Sep  4 08:39:26 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_set_geometry_hints)
	  gdk/gdkwindow.c (gdk_window_set_hints):

	Don't omit setting the properties if flags == 0 -
	there may be an existing set of properties there
	already. (Very old bug. Would it be better to
	delete the property instead?)

	* gdk/gdkselection.c (gdk_selection_property_get): Fix 
	  spelling error in comment.

Wed Sep  1 20:46:11 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c: deal properly with the fact that RC
	  style lists may include rc styles more than once.

	* gtk/gtkrc.c (gtk_rc_append_pixmap_path): Removed
	  unused static function.

	* gtk/gtkrc.c (gtk_rc_find_pixmap_in_path): Keep a
	  stack of directories of RC files currently being
	  parsed and implicitely add them to pixmap path.
	  
	  This fixes a bug where the directory would get
	  appended then overwritten by pixmap_path declarations.

	  (bug #1462, from Peter Wainright <prw@wainpr.demon.co.uk>)

	* gtk/gtkthemes.c (gtk_theme_engine_unref): Call
	  theme's exit function. (Patch from Peter Wainwright,
	  bug #1454)

	* gtk/gtkradiomenuitem.c (gtk_radio_menu_item_destroy):
	  Add a destroy() handler to take care of removing
	  group for menu item. (Fixes bug #1197)

	* gtk/gtkwidget.c (gtk_widget_size_request): Fixed thinko
	  in warning message.

Wed Sep  1 21:27:42 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c (gtk_window_move_resize): don't require a server
	roundtrip to figure window's width and height, since we know that
	anyways from widget->allocation.

Wed Sep  1 14:05:30 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkimage.c (gdk_image_new): Use gdk_error_trap_push()
	  to avoid stomping over gdk_error_warnings.

	* gdk/gdkimage.c (gdk_image_new): compute image->bpp
	  as (bits_per_pixel + 7) / 8. This gives the same
	  result as before for multiples of 8, but actually
	  a "reasonable" value for 1bit or 4bit displays.

Wed Sep  1 12:37:44 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_move_resize): Compute
	  the hints after we request the new size.

Wed Sep  1 10:38:37 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_compute_hints): Removed
	  GTK_WIDGET_REALIZED() assertion - we can compute the
	  hints before we are realized.

	* gtk/gtkwindow.c (gtk_window_move_resize): Reorder
	  hint changing so that we have a value of hints_changed
	  when we decide whether to constrain the window size.

	* gtk/gtkwindow.c (gtk_window_move_resize): Spelling fix.

	* gtk/gtkwindow.c (gtk_window_constrain_size): cleanups,
	change back to G_MAXINT.

Wed Sep  1 14:26:45 1999  Pablo Saratxaga <pablo@mandrakesoft.com>

        * po/da.po,configure.in: aded danish file from
        Birger Langkjer <birger.langkjer@image.dk>

Wed Sep  1 06:54:59 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c (gtk_window_get_geometry_info): zero initialize
	new GtkWindowGeometryInfo, so fields like GdkGeometry geometry
	contain uncluttered values.
	(gtk_window_compute_hints): simply assert that window is realized
	and that geometry_info is valid, since we rely on this anyways.
	(gtk_window_constrain_size): major cleanups to the code.
	if (flags & GDK_HINT_BASE_SIZE) use geometry's base width and height
	for the base size, instead of the minimums. use 32767 as max width
	and height (like in gtkwindow.c) instead of G_MAXINT.

Wed Sep  1 04:41:25 1999  Tim Janik  <timj@gtk.org>

	* cleaned up the GtkContainer.need_resize flag handling mess, we
	only need to force resize requests when we were prematurely
	realized, or our widget tree was modified when we were temporarily
	hidden. handling these cases directly upon showing the window (i.e.
	while the GdkWindow is still unmapped) avoids the need to wait for
	a configure event response and therefore makes the GUI more snappier
	and avoids blank windows during the roundtrip.

	* gtk/gtkwidget.c:
	(gtk_widget_hide): 
	(gtk_widget_show): don't queue resizes on toplevels, they know how
	to deal with matters.

	* gtk/gtkcontainer.c (gtk_container_queue_resize): set the ->need_resize
	flag directly for not visible resize containers and spare us unecessary
	signal emissions.

	* gtk/gtkwindow.c:
	(gtk_window_realize): if we need to enforce premature size allocation,
	queue a container resize so we are correctly resized later on.
	(gtk_window_init):
	(gtk_window_size_request):
	don't freak around with the ->need_resize flag,
	gtk_container_queue_resize() will care about that.
	(gtk_window_show):
	handle initial resizing issues here, we can handle matters better in
	this place, especially since we know that our GdkWindow is still
	unmapped.
	(gtk_window_move_resize):
	don't care about ->need_resize at all.
	handle size changes properly that occoured while we waited for a
	configure event.

Tue Aug 31 15:58:46 1999  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkwidget.c (gtk_widget_set_uposition):
        * gtk/gtkwindow.[hc] (gtk_window_reposition):
        Move the hint setting code from gtk_widget_set_uposition
        to here; set the hints so that we respect any previously
        set geometry hints.

        * gtk/gtkwindow.c (gtk_window_compute_reposition): Don't
        change the window hints here or move the window here,
        let that happen in gtk_window_move_resize().

Tue Aug 31 06:58:52 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_event): when discarding exposes due
	to already queued resizes (and therefore redraws) on a widget, check
	its anchestry as well.

	* gtk/gtkcontainer.c:
	(gtk_container_queue_resize): clear resize widgets for resize
	containers before aborting prematurely. this is especially important
	for toplevels which may need imemdiate processing or their resize
	handler to be queued.
	(gtk_container_dequeue_resize_handler): added new internal function for
	gtkwindow.c.

	* gtk/gtkwindow.c (gtk_window_move_resize): if we are resizing due to a
	configure event, take possible changes in window position into account
	as well.
	if we request a new window size, queue up a resize handler that will
	last until the configure event response arrives.
	combined the ->need_resize case (initial show) with the general size
	(hints) changed case and added even more comments.
	if !auto_shrink, only revert to the old allocation if the new size
	is smaller than the current allocation.

Tue Aug 31 11:55:20 1999  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkwindow.c (gtk_window_set_arg, gtk_window_set_policy,
                           gtk_window_set_geometry_hints
                           gtk_window_set_default_size):
        When hints are set, queue a resize so that the hints will
        be eventually reset on the toplevel.

        * gtk/gtkwindow.c (gtk_window_show): Use
        gtk_window_compute_default_size(). Clear the need_resize flag
        on the initail map so that we don't unnecessarily trigger the
        resize code.

        * gtk/gtkwindow.c (gtk_window_move_resize): Split apart
        into separate functions. Compare the hints we are setting
        with what we set last time so that we can accurately
        tell when we need to reset the hints.

        * gtk/gtkwindow.c (gtk_window_compute_default_size): New
        function to figure out the size from requisition
        and default_size.

        * gtk/gtkwindow.c (gtk_window_constrain_size): Function
        from fvwm to constrain a size to the geometry hints.

        * gtk/gtkwindow.c (gtk_window_compare_hints): New function
        to compare two sets of geometry hints.

        * gtk/gtkwindow.c (gtk_window_compute_hints): Renamed
        from gtk_window_set_hints(), just compute the hints,
        don't set them.

        * gtk/gtkwindow.c (gtk_window_compute_reposition): Move
        code from gtk_window_move_resize() to separate function,
        rationalize a bit.

Tue Aug 31 13:05:03 1999  Owen Taylor  <otaylor@redhat.com>

	* gtkrc.h: Move the ref_count member out of the GtkRcStyle
	structure into a new private structure.

	* gtkrc.c: Split GtkRcStyle into public/private.
	In the private part, add a list of pointers to the
	RcStyle lists this RcStyle participates in.

	* gtkrc.c: When a RcStyle is free, remove all
	lists referencing it from the 
	realized_style_ht hash, and free those lists.
	
	* gtk/gtkrc.c (gtk_rc_clear_styles): Don't call
	gtk_rc_init(), since that adds the default styles
	to the list of parsed RC files again.

	* gtk/gtkrc.c: Use gtk_rc_style_find() consistently.
	
Mon Aug 30 19:00:00 1999 Pablo Saratxaga <srtxg@chanae.alphanet.ch>

	* gtk/gtkfontsel.c: little i18n patch backported from gtk+ 1.3.0
	( now all font properties showing in the font selector are 
	translatable)
	* po/*.po: get the corresponding stringsfrom gtk+ 1.3.0

Sun Aug 29 13:38:59 BST 1999 Tony Gale <gale@gtk.org>

        * docs/gtkfaq.sgml: Minor FAQ Update

Sat Aug 28 14:34:37 BST 1999 Tony Gale <gale@gtk.org>

        * docs/gtkfaq.sgml: FAQ update

Thu Aug 26 14:14:42 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_size_allocate): reactivated the sanity
	checks that ensure that a widget's allocation is at least 1 in width
	and height. (GNOME note: this doesn't affect old panel code anymore,
	because GtkSocket will request width and height of at least 1 since
	Fri Jul 23).

	* gtk/gtkwindow.c (gtk_window_realize): if the widget hasn't been
	allocated yet (happens if the user realizes the window prematurely),
	size request and allocate it.
	(gtk_window_size_allocate): guard against guint underflows.

Wed Aug 25 19:01:36 1999  Lars Hamann  <lars@gtk.org>

	* gtk/Makefile.am (gtk_built_sources): reordered stamp-gtk.defs
 	in gtk_built_sources, so gtk.defs gets built prior to all other
 	sources.

Wed Aug 25 15:45:46 1999  Tim Janik  <timj@gtk.org>

	* configure.in: evaluate $PERL for the perl version check. added
	--disable-rebuilds to give the user an option to completely disable
	any source autogeneration rules.

Mon Aug 23 15:05:17 CDT 1999  Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.4

Mon Aug 23 23:16:14 1999  Tim Janik  <timj@gtk.org>

	* configure.in: evaluate $ac_make when checking for GNU Make.

Mon Aug 23 19:11:17 1999  Tim Janik  <timj@gtk.org>

	* gtk/Makefile.am:
	invoke indent on gtkmarshal.*. 
	rewrote source generation rules, use COPYING as oldest source tag for
	a piggyback rule to generate all sources from (don't touch it ;).
	major cleanups, strip spaces on build rules for GNU Make.

	* gtk/genmarshal.pl: don't operate on hardcoded filenames but take
	source and target files from commandline arguments. don't invoke indent.

	* gdk/Makefile.am: minor cleanups, strip spaces on build rules for
	GNU Make.

	* docs/Makefile.am: added generation.txt.

	* Makefile.am: require automake 1.4, build README from README.in and
	INSTALL from INSTALL.in in dist-hook.
	
	* README.in:
	* INSTALL.in: new files to autogenerate README and INSTALL from.

	* gtk/COPYING:
	* gdk/COPYING: new files containing the GNU LESSER GENERAL PUBLIC
	LICENSE.

	* configure.in: figure wether we have GNU Make, version update to
	Gtk+ 1.2.4, interface age 2, binary age 4.
	
	* NEWS: updates.

	* docs/generation.txt: minor additions/corrections.

Sat Aug 21 14:07:36 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtknotebook.c (gtk_notebook_real_switch_page): queue_resize
	notebook after switch to avoid drawing problems.
	(Bug#856 Reported by: Theodore Roth <troth@netmagic.net>)
	
	(gtk_notebook_pages_allocate): don't map not visible tab_labels, 
	show them instead. 
	(Bug#1805 Reported by: Dave Cole <dave@dccs.com.au>)

Wed Aug 18 09:20:10 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c:
	we use window->need_resize from configure_event now, to indicate that
	the gtkwindow should keep its allocation (e.g. because the user resized
	the window through window manager handles). resize_count is now reliably
	used to figure whether we got the allocation we requested from the
	window manager.
	configure events get queued as resizes now, the real stuff (size
	computation and allocation) now only goes on in gtk_window_move_resize().
	GtkWindow's requisition now contains its *real* requisition (like all
	other widgets), *not* taking usize into account.
	geometry_info->last_{width|height} is now updated from set_hints() only
	so it always contains the last hints we set for the window manager.
	made some event handlers return TRUE instead of FALSE.
	the overall code should be much more straight forward now, and the
	significant code portions are accompanied by comments now.
	(gtk_window_set_hints):
	removed requisition argument and made it
	fetch the requisition through gtk_widget_get_child_requisition.
	we also don't move the gdkwindow here anymore, gtk_window_move_resize()
	does that now.
	(gtk_window_show):
	ensure that the widget is realized before calling 
	gtk_container_check_resize() (and thus gtk_window_move_resize()), also
	ensure that we got properly size requested and allocated before
	realization.
	(gtk_window_configure_event):
	ignore plain window moves, or reallocate the widget tree through the
	resize queue otherwise.
	(gtk_window_move_resize):
	mostly rewrote this function to figure window manager hints more
	reliably, coalesce window moves and resizes to reduce configure events
	and do actuall size allocations.

Tue Aug 17 07:43:04 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_event): discard expose events for widgets
	that have a resize pending, because a redraw is already queued for them.

	* gdk/gdkevents.c (gdk_event_translate): give a debugging note when
	discarding configure events.

	* gtk/gtkcontainer.c: removed ugly connect_to ::size_allocate signal
	hack to clear resize_widgets.

	* gtk/gtkwidget.c (gtk_widget_size_allocate): call clear_resize_widgets
	for resize containers prior to size allocation. (this is also a bit
	ugly, but avoids side effects for stopped emissions and is thus more
	reliable).
	(gtk_widget_unparent): removed disconnect call for clear_resize_widgets.

	* gtk/gtktooltips.c (gtk_tooltips_paint_window): renamed this
	function from gtk_tooltips_expose, as we connect to ::expose_event
	*and* ::draw now.

1999-08-18  Federico Mena Quintero  <federico@redhat.com>

	* gtk/gtkselection.c (gtk_target_list_ref): Added missing sanity
	checks.
	(gtk_target_list_unref): Likewise.

	* gdk/gdkpixmap.c (gdk_pixmap_unref): g_return_if_fail() the
	refcount is greater than zero.

	* gdk/gdkwindow.c (gdk_window_unref): Likewise.

	* gdk/gdkfont.c (gdk_font_unref): Likewise.

	* gdk/gdkgc.c (gdk_gc_unref): Likewise.

	* gdk/gdkdnd.c (gdk_drag_context_unref): Likewise.

	* gtk/gtkthemes.c (gtk_theme_engine_unref): Likewise.

Tue Aug 17 15:47:07 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c (gtk_color_selection_draw_value_bar):
	guard against division by zero. (Fixes bug #1339)

Tue Aug 17 10:56:49 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_move_{forward,backward}_word): 
	Prevent the trivial leak of information of allowing
	word motion when the entry is not visible.

Tue Aug 17 10:28:52 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_fileop_error): Propagate
	modality to error dialog as well as confirmation dialogs.
	(Bug #1803, reported by Rosanna Wing Sze Yuen)

Wed Aug 11 13:38:26 BST 1999 Tony Gale  <gale@gtk.org>

	* docs/gtkfaq.sgml: FAQ Update

Wed Aug 11 01:04:57 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktreeitem.c (gtk_tree_item_draw_lines): Honor
	tree->view_lines.
	(gtk-guy-990611-3.patch: Guy Harris <guy@netapp.com>)

	* gtk/Makefile.am (install-data-local): Solaris apparently
	has various troubles with ln -f; use rm first instead.
	(gtk-guy-990611-2.patch: Guy Harris <guy@netapp.com>)

	* gdk/gdkproperty.c (gdk_property_get): Fix assumption
	that format 32 => sizeof(item) == 4. It really is
	sizeof(long).

1999-07-30  Raja R Harinath  <harinath@cs.umn.edu>

	* gtk/Makefile.am (stamp-m): Don't `mv' from builddir to srcdir,
	use `cp' followed by `rm' (the `rm' was already there).

July 30, 1999 Elliot Lee <sopwith@redhat.com>
	
	* configure.in: Fix autoconf warnings about cross compilation by
	trying to provide sane defaults for AC_TRY_RUN.
	* docs/Makefile.am: Tell distcheck how to generate the .gif files.
	* gtk/Makefile.am: If we refer to gtkmarshal.[ch] in $(srcdir),
	put them into $(srcdir) when generated. Also add a dependency of
	gtksignal.h on gtkmarshal.h for -j builds. 
	* gtk/gtk(dnd,style,gamma).c: Minor warning fixes.

Wed Jul 28 09:29:19 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_main_iteration_do): Added missing
	GDK_THREADS_{LEAVE,ENTER} pair.
	(From Paul Fisher <pnfisher@redhat.com>)

Fri Jul 23 01:00:15 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtksocket.c (gtk_socket_size_request): asure that the requested
	width and height are always >0 (owen).

Fri Jul 23 00:00:47 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_size_allocate): backed out my recent
	change that assured that a widget's allocated with and height are
	always >1, since this breaks *buggy* panel code. unfortunately this
	back-breaks the gimp's color selector.

	* gtk/gtkdrawingarea.c (gtk_drawing_area_size_allocate): asure that our
	allocation is always >0 in width and height, before sending the
	configure event; this is a *gross* hack to get the gimp back to work.
	
	* marked both cases with TODO-1.3

Wed Jul 21 15:47:39 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.c: Don't display wrap indicators when
	text is not editable and word wrap is on.

Wed Jul 21 08:21:40 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkitemfactory.c (gtk_item_factory_create_item): special case
	option menus here as they are not derived from menu shell, assure that
	the option menu has a menu we can add items to.

Tue Jul 20 23:29:48 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtknotebook.c (gtk_notebook_page_allocate): convert allocation->
	width/height to (gint) before calculations and check against < 0 to
	avoid guint wraparounds.

Sun Jul 18 00:35:49 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_size_allocate): ensure that the allocated
	width and height is never zero. sanity check both dimensions against
	32767 and issue a warning if the allocation is greater than that.

Fri Jul 16 22:20:21 PDT 1999 Manish Singh <yosh@gimp.org>

	* ltconfig
	* ltmain.sh: upgrade to libtool 1.3.3

Thu Jul  8 11:30:18 1999  Owen Taylor  <otaylor@redhat.com>

	* INSTALL: Indicate that the --with-glib= configure
	time flag is unsupported.

	* configure.in: Some small fixups for libgno

Wed Jul  7 15:03:30 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_events_pending): Unlock around call
	to g_main_pending() as well.

Wed Jul  7 14:59:01 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_main_iteration): Unlock around
	call to g_main_iteration() - since that will regrab
	GTK+ lock to process events.

Mon Jul  5 20:36:03 1999  Owen Taylor  <otaylor@redhat.com>

	* docs/generation.txt: Added a file that gives
	documenation about the autogeneration process for
	various autogenerated files.
	
Thu Jul  1 15:01:55 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c
	- Regularize with the rest of GTK+ by making widget->requisition
	  not reflect the set_usize()
	- Always recompute geometry hints, then check if they
	  changed before sending them to the X server. The
	  previous checks for changes would fail in a number
	  of circumstances. 

Thu Jul  1 11:55:59 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c: Include <stdlib.h> for strcmp().

Wed Jun 30 19:26:36 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c:
	- Code cleanups
	- Instantaneously update on modifier key presses
	- Allow cancellation of the drag with Escape.

Tue Jun 29 23:02:42 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c (gdk_x_error / gdk_x_io_error): Don't
	core dump at all on X IO errors, only core dump
	if --enable-debug for X errors.

Tue Jun 29 17:04:09 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/testgtk.c (create_handle_box): Set the policy
	to auto_shrink - otherwise the appearance is rather
	strange when flipping between horizontal and vertical.

Tue Jun 29 15:59:25 1999  Owen Taylor  <otaylor@redhat.com>

	* configure.in (LIBS): Look for libgmodule in the
	right location.

Mon Jun 28 09:29:52 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c: add ::default_width and ::default_height arguments.
	(gtk_window_set_default_size): don't change a value if it's < 0.
	queue a resize.

Sun Jun 27 11:00:33 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtktext.c (gtk_text_insert): don't segfault on NULL inserts.

Mon Jun 28 12:08:25 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (cmpl_completion_fullname): Don't
	add an extra "/" when concating "/" + filename.
	(From Matt Grossman <mattg@oz.net>)

Mon Jun 28 10:57:12 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c (draw_cell_pixmap): Reset clip mask
	for fg_gc if we set it for drawing pixmap.

Thu Jun 24 17:06:23 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkevents.c (gdk_event_translate): removed old ""Got event for
	unknown window:" message. disabled ConfigureNotify discarding code,
	because it led to events being processed out of order.

Thu Jun 24 12:22:02 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkglobals.c: preinitialize gdk_error_code to 0.

	* gdk/gdkevents.c (gdk_event_send_client_message_to_all_recurse): since
	we export this function, supress error warnings and don't reset the
	error code in the first half of this function.

	* gdk/gdk.c (gdk_x_error): set gdk_error_code to the actuall X error
	code (instead of just -1) so gdk_error_trap_pop() reveals something
	actually informative about the error that happened.

	* gdk/*.c:
	don't rely on gdk_error_code being -1 if an error occoured, but just
	gdk_error_code != 0.

Thu Jun 24 11:50:07 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkevents.c (gdk_event_apply_filters): advance the filter list
	pointer *before* invoking the filter function, so we at least don't
	crash if a filter is removed that is currently executed. window filters
	*really* need to be made truely reentrant at some point.

Wed Jun 16 20:28:34 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkevents.c (gdk_event_translate): don't segfault for
	window==NULL in ConfigureNotify.

Mon Jun 14 11:10:15 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkevents.c (gdk_event_translate): print the atom name in the
	PropertyNotify debug messages.

Thu Jun 17 13:57:31 1999  Owen Taylor  <otaylor@redhat.com>

	* docs/gtk_tut.sgml: Removed references to
	code examples in my directory on gtk.org as
	they should all be in the tutorial now.

	* docs/gtk_tut.sgml: Added sources for dial-test
	and scribble-xinput programs that were previously
	missing.

Tue Jun 15 12:45:12 1999  Owen Taylor  <otaylor@redhat.com>

        Fixes from Peter Wainwright <prw@wainpr.demon.co.uk>
	
	* gtk/gtkrc.c (gtk_rc_parse_engine): If rc_style->engine is
	already set, call old engine's destroy function and
	unref the old engine.

Thu Jun 10 17:59:38 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkdrawingarea.c (gtk_drawing_area_size): queue a resize.

Wed Jun  9 15:13:16 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkaccelgroup.h: mark certain functions as internal.

Wed Jun  9 13:48:28 1999  Tim Janik  <timj@gtk.org>

        * gtk/gtkpreview.c (gtk_preview_set_expand): queue a resize if the
        expand behaviour changed.

        * gtk/gtklabel.c (gtk_label_set_pattern):
        (gtk_label_set_justify):
        (gtk_label_set_line_wrap):
        don't bother invoking queue_clear, the reallocation does
        that for us, always free_words so the upcoming resize will
        relayout the label's contents.

Wed Jun  9 12:50:48 1999  Tim Janik  <timj@gtk.org>

        * applied argument implementation patches from Elena Devdariani
        <elena@cogent.ca>.

        * gtk/gtktoolbar.c: ::orientation, ::toolbar_style, ::space_size,
        ::space_style, ::relief
        * gtk/gtkruler.c: ::lower, ::upper, ::position, ::max_size
        * gtk/gtkpreview.c: ::expand
        * gtk/gtkpaned.c: ::handle_size, ::gutter_size
        * gtk/gtknotebook.c: ::homogeneous
        * gtk/gtklabel.c: ::wrap
        * gtk/gtklist.c: ::selection_mode
        * gtk/gtkhandlebox.c: ::handle_position, ::snap_edge
        * gtk/gtkcurve.c: ::curve_type, ::min_x, ::max_x, ::min_y, ::max_y
        * gtk/gtkcolorsel.c: ::update_policy, ::use_opacity
        * gtk/gtkclist.c: ::sort_type
        * gtk/gtkcheckmenuitem.c: ::active, ::show_toggle
        * gtk/gtkaspectframe.c: ::xalign, ::yalign, ::ratio, ::obey_child

Fri Jun  4 00:08:59 1999  Owen Taylor  <otaylor@redhat.com>

	* TODO: Added entry about menu keyboard navigation, removed
	some finished items.

Tue Jun  1 23:38:38 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c: Removed ill-thought-out part of last
	comment.

Tue Jun  1 23:30:09 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_style_attach): Get the reference
	counting right when we have to attach a new style
	for a different visual. (Chi-Deok Hwang <cdhwang@sr.hei.co.kr>)

	* gtk/gtkstyle.c: Documented the refcounting
	peculularities of gtk_style_attach.

1999-06-01  Tim Janik  <timj@dhcpd7.redhat.com>

	* gtk/gtkwindow.c (gtk_window_new): added return if fail for invalid
	window types.

	* examples/packer/pack.c (main): use GTK_WINDOW_TOPLEVEL instead
	of GTK_TOPLEVEL for creating the window.

1999-06-01  Tim Janik  <timj@dhcpd7.redhat.com>

	* gtk/gtkmain.c (gtk_init_check): don't segfault when --gtk-module is
	the last argument (reported by Per Winkvist).
	
Mon May 31 00:11:24 1999  Owen Taylor  <otaylor@redhat.com>

	* acinclude.m4: Standardize on func_dgettext
	not func_gettext, so that the checks for dgettext
	actually are paid attention to.

Sat May 29 11:17:29 PDT 1999 Manish Singh <yosh@gimp.org>

	* docs/Makefile.am: add Changes-1.2.txt to EXTRA_DIST

	* acinclude.m4
	* config.guess
	* config.sub
	* ltconfig
	* ltmain.sh: upgrade to libtool 1.3.2
	
Tue May 25 13:13:12 1999  Owen Taylor  <otaylor@redhat.com>

        Fixes for invisible XOR lines (Frank Loemker
	<floemker@TechFak.Uni-Bielefeld.DE>)
	
	* gtk/gtkclist.c (gtk_clist_realize): Always use
	a non-zero pixel for GDK_XOR.

	* gtk/gtkvpaned.c gtk/gtkhpaned.c: 
	Use GDK_INVERT instead of GDK_XOR.

Wed May 12 21:56:40 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (adjust_adjustments): signal emit value_changed
	signals if h/voffsets differ from adjustment values.
	Reportet by Jerome Bolliet <bolliet@in2p3.fr>

Mon May 10 22:20:06 CDT 1999 Shawn T. Amundson <amundson@gtk.org>

	* GTK+ is as easy as 1.2.3...

Mon May 10 04:20:41 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenushell.c (gtk_menu_shell_activate_item): propagate
	::selection-done emissions up to the topmost menu shell.

Fri May  7 10:15:14 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_set_scrollable): Unset
	the user data on the window before destroying it.

	* gtk/gtknotebook.c (gtk_notebook_unrealize): Add an
	unrealize handler to take care of destroying 
	notebook->panel properly. 
	(Bug #1198 - Morten Welinder <terra@diku.dk>)

	* gtk/gtktext.c (expand_scratch_buffer): Fix reversal
	of g_new and g_realloc to stop memory leak. (Actually,
	we could just use g_realloc(), but I'm not 100% sure
	that is portable).
	(Bug #1196 - Morten Welinder <terra@diku.dk>)

Wed May  5 22:51:06 1999  Owen Taylor  <otaylor@redhat.com>
	
        Patch from Sung-Hyun Nam <namsh@lgic.co.kr>
	
	* gdk/gdkim.c: Fix cut-and-paste errors for 
	x/y and PreeditAttributes/StatusAttributes.

Wed May  5 22:24:21 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_set_geometry_hints): Change
	G_MAXINT to 2^16 to alleviate overflow problems in
	various window managers.

Wed Apr 21 00:42:08 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkplug.h: Removed stray GtkPlugButton declaration.

	* gdk/gdkfont.c (gdk_text_measure): Fix the return value
        for fontsets.

	* gtk/gtkbutton.c (gtkbutton_expose): Fix warning
	with bin/button confusion.

Thu May  6 04:53:26 1999  Tim Janik  <timj@gtk.org>

	* gtk/testgtk.c: in the ItemFactory test, link radio items together,
	and show how preselection of radio items is done.

Sun May  2 13:31:14 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtktreeitem.c (gtk_tree_item_set_subtree): 
	* gtk/gtktree.c (gtk_tree_add) (gtk_tree_insert):
	* gtk/gtktoolbar.c (gtk_toolbar_insert_element): 
	* gtk/gtkpaned.c (gtk_paned_pack2) (gtk_paned_pack1):
	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_add): 
	* gtk/gtktable.c (gtk_table_attach): 
	* gtk/gtklist.c (gtk_list_insert_items): 
	* gtk/gtkmenushell.c (gtk_menu_shell_insert): 
	* gtk/gtknotebook.c (gtk_notebook_insert_page_menu): 
	* gtk/gtkpacker.c (gtk_packer_add_defaults) (gtk_packer_add): 
	* gtk/gtkbin.c (gtk_bin_add): 
	* gtk/gtkbox.c (gtk_box_pack_start) (gtk_box_pack_end): 
	* gtk/gtkfixed.c (gtk_fixed_put): 
	* gtk/gtklayout.c (gtk_layout_put):
	general fixups to container_add logic. always realize child if
	child->parent is realized, only map the child and queue a resize
	if child and child->parent are both visible.

Fri Apr 30 09:02:28 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_real_unrealize): use gtk_container_forall
	instead of gtk_container_foreach to walk and unrealize children, so
	composite children get also unrealized.
	(gtk_widget_real_show): don't call gtk_widget_map() if we don't need to.
	(gtk_widget_map): assert that the widget is visible (basic constrain).
	(gtk_widget_real_map): assert that the widget is realized (basic
	constrain).

Fri Apr 29 00:53:20 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkbindings.c (gtk_pattern_spec_init): plugged a memory leak.

Wed May  5 12:42:01 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_set_geometry_hints):
	Initialize size_hints.x and size_hints.y because kwm
	brokenly pays attention to them.
	(Bug #1181 -  Lars Heete <hel@admin.de>)

Wed May  5 11:38:56 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkrgb.c (gdk_rgb_choose_visual): Free the 
	return value of gdk_list_visuals(). 
	(Bug #1193 - Morten Welinder <terra@diku.dk>)

Wed May  5 10:47:54 1999  Owen Taylor  <otaylor@redhat.com>

	* configure.in (LIBS): Add $INTLLIBS into $LIBS
	directly, rather than repeating the checks for
	gettext.

	* INSTALL: Added information about gettext and
	NLS support.

	* acinclude.m4 (LIBM): Check for dgettext, not
	just gettext. This should hopefully fix things wrt
	systems with old versions of GNU gettext installed.

Tue May  4 11:12:56 PDT 1999 Manish Singh <yosh@gimp.org>

	* gdk/gdkim.c (gdk_im_real_open): cast the return value of
	XSetIMValues to (void *) when comparing to NULL, to workaround
	the problem of some compilers barfing since older X headers don't
	have the prototype for it.

Tue May  4 09:32:08 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am gtk/gtkrc.iso-8859-2: Add a gtkrc
	file for iso-8859-2 locales.

	* configure.in (ALL_LINGUAS): ALL_LINGUAS update.

Tue Apr 27 16:38:32 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am: Fix typo of static_sources for static_SOURCES.
	 (Pointed out by andy@rz.uni-karlsruhe.de and others).
	 Remove some suspicious and useless lines. 

Tue May  4 08:44:08 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (gtk_clist_draw, draw_rows): Use 
	width,height = 0, 0 to mean - here to edge of window,
	instead of -1, -1, since the former is all we support.

Tue May  4 08:34:43 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_main): Correctly free list nodes
	when removing from quit_functions list.

Mon Apr 19 10:11:12 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkcolor.c (gdk_colormap_new): Fix memory leak
	for pseudocolor where colormap->colors was double
	allocated.

	* gdk/gdkcolor.c (gdk_colormap_alloc1): Store the
	color value in the hash table with the pixel filled
	in so when we do later hash table lookups, the color
	value is correct.
	
Sun May  2 15:29:45 PDT 1999 Manish Singh <yosh@gimp.org>

	* gdk/gdkdraw.c (gdk_draw_lines): check private->destroyed before
	making the call

Sat May  1 11:04:12 PDT 1999 Manish Singh <yosh@gimp.org>

	* acinclude.m4
	* config.guess
	* config.sub
	* ltconfig
	* ltmain.sh: upgrade to libtool 1.3

Tue Apr 27 14:17:16 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkpacker.c (gtk_packer_size_request): remove unused variable.

Tue Apr 27 18:23:35 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_draw_cursor_on_drawable): 
	 When redrawing characters on non-visible entry, use appropriate
	 '*' character. (Bug #1130 - Jean-Marc Jacquet <jm@littleigloo.org>)

Tue Apr 27 11:17:35 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c (xdnd_set_{targets,actions}): Fix leak
	pointed out by Morten Welinder <terra@diku.dk>.

Tue Apr 27 01:31:40 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (drag_dest_cell): compute destination cell
	from drag coordinates.
	(gtk_clist_drag_data_received) (gtk_clist_drag_motion):
 	use drag_dest_cell.

	* gtk/gtktree (drag_dest_cell)
	(gtk_ctree_drag_data_received) (gtk_ctree_drag_motion): likewise.
	(Bug #1129)

Wed Apr 21 21:26:11 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkitemfactory.c (gtk_item_factory_init): properly initialize
	translate_* fields.
	(gtk_item_factory_finalize): invoke translate_notify independant from
	translate_data.
	(gtk_item_factory_set_translate_func): likewise.
	(gtk_item_factory_destroy): only remove ifactory pointer from those
	widgets that belong to us (stupid me).

Wed Apr 21 14:20:22 1999  George Lebl  <jirka@5z.com>

	* gdk/gdkwindow.c: (gdk_window_remove_filter) correctly remove the
	  default filter from the list

Mon Apr 19 12:05:31 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_style_init): Fixed leak of
	rc_style list when lookup succeeeds.

1999-04-18  Tomas Ogren  <stric@ing.umu.se>

	* gtk/gtkrc.c: Add a / before the directory name to keep directory
	names from eachother. (Already fixed in 1.3.x)

Fri Apr 16 20:41:43 PDT 1999 Manish Singh <yosh@gimp.org>

	* gdk/gdk.c: #include "gdkkeysyms.h" for gdk_XConvertCase #defines

	* gtk/gtkfontsel.c (gtk_font_selection_create_xlfd): use
	g_strdup_printf instead of calcing the length separately

Thu Apr 15 01:11:24 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (resync_selection): 
	* gtk/gtkclist.c (resync_selection): fixed undo_selection bug.
	* gtk/gtkclist.c (gtk_clist_button_release): fixed resync_selection
 	bug.

Tue Apr 13 17:14:28 CDT 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.2

Tue Apr 13 02:49:33 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c: removed some silly #ifdef HAVE_CONFIG
	that we don't do in many other places. (Fixing duplicate 
	#include of config.h)

	* gdk/gdkevents.c: include gdkinput.h _after_ config.h.
	Otherwise, #ifndef XINPUT_NONE check in the latter
	doesn't work. (Bug #546)

Sun Apr 11 15:08:27 1999  Tim Janik  <timj@gtk.org>

	* configure.in: bumped version number to Gtk+ 1.2.2, interface 0,
	binary 2.
	
	* NEWS: updates.

Sun Apr 11 14:38:03 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkpixmap.c (_gdk_pixmap_create_from_xpm): check for color
	"None" case insensitive.

Fri Apr  9 19:22:19 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c gtk/gtkdnd.c gtk/gtkmenuitem.c:
	Add some missing GDK_THREADS_ENTER()/LEAVE around
	timeouts. (Patches from Sebastian Wilhelmi <wilhelmi@ira.uka.de>)

Thu Apr  8 20:10:33 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkentry.c (gtk_entry_key_press): use gtk_widget_activate()
	rather than emit_by_name.

	* gtk/gtkeditable.c (gtk_editable_insert_text): keep a reference
	on the widget across multiple signal emissions.
	(gtk_editable_delete_text): same here.
	(gtk_editable_class_init): set widget_class->activate_signal after
	editable_signals[ACTIVATE] has been created.

Wed Apr  7 22:59:47 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkpaned.c (gtk_paned_set_position): Don't clamp
	position here prematurely -- we might not have the
	right ->min_position and ->max_position yet.

Tue Apr  6 16:38:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.c gdk/gdkselection.c: (gtk_selection_request):
	Add error traps so if the other end of the connection
	dies, we survive.

	* gtk/gtkselection.c (gtk_selection_notify): Clean
	up properly when selection property retrieval fails.
	
	* gtk/gtkselection.c (gtk_selection_request): Correctly
	reject SelectionRequest notifies where the handler
	returns no data.

Tue Apr  6 12:24:21 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_dest_leave): Only unhighlight
	when we've previously highlighted.

	* gtk/gtkdnd.c (gtk_drag_dest_handle_event): Don't
	emit two "drag_leave" signals for Motif drops.

	* gtk/gtkdnd.c (gtk_drag_source_handle_event): Send
	back the correct status messages when dropping from
	Motif onto a proxy window that is rejecting the
	drop.

	* gdk/gdkdnd.c (gdk_drag_motion): Separate out the
	dest_xid field into two fields - one for the window
	to send in messages, one to indicate the last looked
	up window for caching purposes. This is needed, so
	that Leave messages get the correct window.

Mon Apr  5 17:11:57 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpixmap.c (_gdk_pixmap_create_from_xpm): Check 
	explicitly for the string "None" - it is in the XPM
	spec and some servers treat unknown colors in odd ways
	(like asking the user!)

Mon Apr  5 13:21:30 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c (gdk_event_check, gdk_event_prepare):
	Fix warning created by people mucking around
	with the gsource API.

	* gdk/gdkevents.c (gdk_io_invoke, gdk_input_add_full):
	Change mapping between GIOCondition and GdkInputCondition
	to match the way the Linux kernel does it. This should
	fix problems where closed pipes were no longer signalling
	GDK_INPUT_READ on systems with a native poll().

Thu Apr  1 16:58:10 PST 1999 Manish Singh <yosh@gimp.org>

	* gdk/gdkevents.c: made "->" into a "." of previous change so
	it compiles

	* gtk/gtkfontsel.c: added braces enclosing an if-else construct

	* autogen.sh: add --enable-maintainer-mode

	* configure.in: set ACLOCAL="$ACLOCAL $ACLOCAL_FLAGS"

Thu Apr  1 18:41:25 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c (gdk_compress_exposures): Set the
	window field of the event structure before calling
	user filters.

Wed Mar 24 23:03:49 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.1

	* docs/gtk-config.1.in:
	  docs/Makefile.am:
	  configure.in: gtk-config is now generated.

	* docs/gtk-config.1: Removed, now generated.

1999-03-31  Federico Mena Quintero  <federico@nuclecu.unam.mx>

	* gdk/gdk.c (gdk_init_check): Use False as the last argument to
	XInternAtom() here.  This is a particularly Old And Nasty(tm) bug.

Sat Mar 27 23:32:13 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkarg.[hc]: added functions from GLE, gtk_arg_reset() to free
	the value and reset type to GTK_TYPE_INVALID, and gtk_arg_values_equal()
	to compare two argument values. added gtk_arg_to_valueloc() to set a
	variable from an arg through its location (pointer).

	* gtk/gtkobject.[hc]: implemented gtk_object_get() in terms of
	gtk_object_arg_get() and gtk_arg_to_valueloc(), floats are collected
	as gfloat*, uchars are collected as guchar*, ints are collected as
	gint*, etc...

Mon Mar 29 17:45:47 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkaccelgroup.c gtk/gtkgtkbindings.c:
	Include <string.h> instead of <strings.h>.

	* gtk/gtkstyle.c: Fix double include of gtkthemes.h
	(actually, a lot more duplicate includes occur if
	 you trace through the sequence of #include's)
	gtk-jbb-990320-0: John Bley, jbb6@acpub.duke.edu
	
Mon Mar 29 17:31:52 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkim.c (gdk_mbstowcs): Free the value of the
	intermediate text property - prevents major memory
        leak when gdk_use_mb.
	gtk-d3august-990311-0: Bj|rn Augustsson <d3august@dtek.chalmers.se>

Mon Mar 29 17:02:58 1999  Owen Taylor  <otaylor@redhat.com>

        Patches from Akira Higuchi <a-higuti@math.sci.hokudai.ac.jp>
	gtk-a-higuti-990322-[0-3]

	* gdk/gdkfont.c (gdk_text_extents_wc): Make  work when
	sizeof(wchar_t) != sizeof (GdkWChar)

	* configure.in: Fix confusion between GTK_LOCALE_[C]FLAGS
	that was causing -DX_LOCALE not	to work.

	* gtk/gtkrc.c (gtk_rc_init):
	X_LOCALE will never have LC_MESSAGES defined

	* gdk/gdk.c (gdk_init_check):
	Remove --xim-preedit and --xim-status from argv properly.

	* gdk/gdkim.c (gdk_ic_real_new): Add a gdk_flush() so
	that the client window is present on the X server
	before we pass it to the input method.

Tue Mar  9 10:46:49 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c (motif_find_drag_window): Fix bug where
	if --display is specified on the command line, than
	the drag window will not be created on that display.
	
Tue Mar  9 10:38:24 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkproperty.c (gdk_atom_intern): Fixed bug where
	lookups with only_if_exists == TRUE were inserting
	bogus values into the atom cache.

Thu Mar 25 12:38:31 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkrc.c (gtk_rc_append_default_module_path): get $HOME from
	g_get_home_dir() (gtk-pmc-990123-0.patch.gz).

	* gtk/gtkwindow.c (gtk_window_key_press_event): feature keypad up/down/
	left/right as well (gtk-michael-980726-0.patch.gz).

	* gtk/gtklabel.[hc]: bunch of miscellaneous cleanups, such as s/0/NULL/
	for pointer values, use gchar instead of char. fixed uline allocation
	leaks, changed the allocation pattern so we use G_ALLOC_AND_FREE mem
	chunks instead of G_ALLOC_ONLY.
	(gtk_label_size_request): always alter requisition as passed and leave
	widget->requisition alone.
	(gtk_label_set_text): allow NULL strings.
	(gtk_label_new): likewise.

Wed Mar 24 23:03:49 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.1

	* INSTALL:
	  README:
	  sanity_check: Updated.

	* docs/gtk-config.1.in:
	  docs/Makefile.am:
	  configure.in: gtk-config is now generated.

	* docs/gtk-config.1: Removed, now generated.

Wed Mar 24 09:24:03 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkdrawingarea.[hc]: type/macro fixups.

Mon Mar 22 05:51:34 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkbin.c (gtk_bin_draw): only redraw children that are visible
	*and* mapped (i.e. drawable).
	(gtk_bin_expose): only send exposes to drawable children.

	* gtk/gtkbox.c (gtk_box_draw): only redraw children that are drawable.
	(gtk_box_expose): only send exposes to drawable children.

	* gtk/gtkhscale.c (gtk_hscale_draw): 
	* gtk/gtkvscale.c (gtk_vscale_draw):
	hm, this is an ugly one. we first compute the size of our trough area
	here (window relative) and then check intersection with the draw_area
	which is parent relative because we're a NO_WINDOW widget, so we need
	to offset the trough area by allocation.x and allocation.y before the
	check. (this must not be done for the background area though, since
	that's already computed parent relative).

Mon Mar 22 00:41:39 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_unrealize): unmap clist if neccessary,
	unrealize title buttons.

Fri Mar 19 16:45:27 PST 1999 Manish Singh <yosh@gimp.org>

        * acinclude.m4
        * config.guess
        * config.sub
        * ltconfig
        * ltmain.sh: upgrade to libtool 1.2f

        * autogen.sh: libtool is not required to autogen gtk+

        * acconfig.h: remove WITH_SYMBOL_UNDERSCORE (not explictly
        needed)

Fri Mar 19 00:00:22 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_column_title_passive)
	(gtk_clist_column_title_active): 
	only connect/disconnect to GtkWidgetClass::event to block mouse events.

	* gtk/gtkclist.c (vertical_timeout) (horizontal_timeout): 
	zero initialize event, removed superfluous gdk_window_get_pointer call

	* gtk/gtklist.c (gtk_list_vertical_timeout)
	(gtk_list_horizontal_timeout): removed superfluous
 	gdk_window_get_pointer call

Wed Mar 17 09:00:00 1999  Tim Janik  <timj@gtk.org>

	* plugging problems reported by "Bruce Mitchener, Jr."
	<bruce@puremagic.com> due to a purify session.

	* gtk/gtkstyle.c:
	(gtk_style_ref): 
	(gtk_style_unref): assert ref_count to be > 0.

	* gtk/gtkclist.c (gtk_clist_set_cell_style): { 0 } initilaize
	the requisition.
	(gtk_clist_set_shift): likewise.

	* gtk/gtklayout.c: introduce gtk_layout_finalize() to unref the
	adjustments.

	* gdk/gdkselection.c (gdk_selection_property_get): first XFree(t),
	then reset it to NULL.

	* gtk/gtklist.c (gtk_list_horizontal_timeout): zero initialize the
	event before sending it and set send_event to TRUE (which needs to
	be done for *all* synthesized events).
	(gtk_list_vertical_timeout): likewise.

	* gdk/gdkcolor.c:
	(gdk_colors_free): 
	(gdk_colormap_free_colors): use colormap->colors[in_pixels[i]] as the
	key for g_hash_table_remove() in both functions, this prevents us
	from accessing possibly uninitialized portions of a GdkColor structure
	where we are only interested in its pixel value.

	* gtk/gtktipsquery.c (gtk_tips_query_destroy): plug small memory
	leaks.

	* gtk/gtkdrawingarea.c (gtk_drawing_area_send_configure): set send_event
	to TRUE when synthesizing events.

Wed Mar 17 00:44:23 1999  Tim Janik  <timj@gtk.org>

	* configure.in: bumped version number to Gtk+1.2.1, interface 0,
	binary 1.
	
	* NEWS: updates.

	* gtk/gtkfeatures.h.in: added GTK_CHECK_VERSION(major,minor,micro)
	macro to test for specific gtk versions, e.g.
	#if GTK_CHECK_VERSION (1,2,1)
	    gtk_menu_ensure_uline_accel_group (menu);
	#endif /* Gtk+1.2.1 */
	this macro will return whether the Gtk+ header files are from version
	major.minor.micro or _newer_, as opposed to gtk_check_version() which
	requires an exact match for binary compatibility.
		
Tue Mar 16 17:43:33 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkitemfactory.c (gtk_item_factory_parse_rc_string): ensure the
	item factory class has been created.
	(gtk_item_factory_parse_rc): likewise.

	* gtk/gtkmenu.c:
	keep proper references for old_active_menu_item.
	(gtk_menu_reparent): unset the usize of the new parent,
	so the menu can sanely be size requested and we don't get nasty screen
	artefacts upon next reparentation.
	(gtk_menu_motion_notify): set send_event to TRUE if we synthesize an
	enter notify. only synthesize enter notifies if the pointer really is
	inside the event window.
	(gtk_menu_popdown): use gtk_menu_shell_deselect().
	(gtk_menu_popup): move the background setting stuff into
	gtk_menu_tearoff_bg_copy() so it can be called from other places as well.

	* gtk/gtkmenushell.c (gtk_menu_shell_button_press): use
	gtk_menu_shell_select_item() to select the new item.
	(gtk_menu_shell_deselect): export this function, so gtkmenu.c can
	do the right thing for deselection as well.

Sat Mar 15 20:10:33 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.[hc]:
	(gtk_widget_accelerators_locked): return whether a widget's accelerators
	are locked.

        * gtk/gtkmenu.c (gtk_menu_key_press): don't remove or install new or
	existing accelerators if the widget's accelerators are locked.

Sat Mar 14 19:44:05 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkitemfactory.[hc]: allow managing of foreign menu items.

	* gtk/gtkmenu.c: truely forward key press and key release events to
	the menu widget from the toplevel or tearoff window. we can't simply
	connect to that, we need to stop further processing of the events as
	well.

Sat Mar 13 13:14:17 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenu.c:
	(gtk_menu_key_press): pass event->keyval, event->state to
	gtk_accelerator_valid, instead of event->keyval twice.
	refuse to install single letter accelerators for menus that use
	single letter shortcuts.

	* gtk/gtkitemfactory.c (gtk_item_factory_create_item): use
	gtk_menu_ensure_uline_accel_group().

	* gtk/gtkmenu.[hc]: added gtk_menu_ensure_uline_accel_group()
	which will always return an uline accel group, made
	gtk_menu_get_uline_accel_group() return NULL if the group isn't
	yet created.

Mon Mar 15 01:03:27 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.h (struct _GtkCListColumn): added button_passive flag.

	* gtk/gtkclist.c (gtk_clist_column_title_passive):
	Leave button sensitive, trap  button_press, button_release,
	motion_notify, enter_notify and leave_notify events instead.
	(gtk_clist_column_title_active): disconnect event handler.
	(gtk_clist_drag_data_get): fixed memory leak. Reported by
	Guillaume Laurent <glaurent@worldnet.fr>	

Mon Mar 15 03:39:47 1999  George Lebl  <jirka@5z.com>

	* gtk/gtkdnd.c: (gtk_drag_highlight) swap the
	  gtk_drag_highlight_expose and gtk_drag_highlight_paint since
	  it was connecting a void function to expose_event and the int
	  returning function to the draw signal

Wed Mar 10 23:49:55 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtklayout.c (gtk_layout_adjustment_changed): fixed a few
	width/height mixups.
	
	* gtk/gtkctree.c (tree_delete): emit an tree_unselect_row signal
	if needed.

Wed Mar 10 02:07:31 1999  Tim Janik  <timj@gtk.org>

	* merged from 1.3:
1999-03-09  Federico Mena Quintero  <federico@nuclecu.unam.mx>

	* gtk/gtkstyle.c (gtk_default_draw_handle): Significantly reduced
	the number of calls to gdk_draw_point() (and thus to X) by
	clipping the points by hand.

	* gtk/gtkhandlebox.c (draw_textured_frame): Actually make use of
	the clip parameter.
	(gtk_handle_box_paint): Only paint the handle if the expose area
	intersects it.

Wed Mar 10 00:11:32 1999  Tim Janik  <timj@gtk.org>

	* gtk/testgtk.c (create_item_factory): unref the item factory after
	window's destruction.

	* gtk/gtkmenushell.c (gtk_menu_shell_activate_item): keep a reference
	count on the menu shell around the menu item's activation, since the
	signal emission may cause menu shell destruction.

	* gtk/gtkitemfactory.c:
	the previous code leaked one accel group per menu. we use
	gtk_menu_get_uline_accel_group() now to fix that, and with that
	also create the underline accelerator group of the menus only if
	required (i.e. an underline accelerator has been specified).
	(gtk_item_factory_construct):
	(gtk_item_factory_create_item): removed code that would create an
	extra accel group for the menu (and leak references).
	(gtk_item_factory_create_item): adapted the underline accelerator
	installation code to properly feature gtk_menu_get_uline_accel_group().

	* gtk/gtkmenu.[hc]: added gtk_menu_get_accel_group() to retrive
	menu->accel_group, this may return NULL if the accelerator group
	hasn't been set yet.
	added gtk_menu_get_uline_accel_group() to retrive the underline
	accelerator group of the menu, this will be created on demand
	and proper care is taken about its reference count.

	* gtk/gtkitemfactory.h:
	* gtk/gtkitemfactory.c:
	dumped the approach of keeping a widgets by action list on the
	factory since the factory<->widget destroy negotiation didn't work
	and would be hard to get going at all. instead we keep a list of
	GtkItemFactoryItem items on the factory (GtkItemFactoryItems are
	persistant throughout a program's life time).
	also, i removed the static const gchar *key_* variables, and made
	them inline strings (they weren't actually used anyways).
	(gtk_item_factory_add_item): update ifactory->items.
	(gtk_item_factory_destroy): destroy ifactory->items (and remove
	the item factory pointer from the remaining ifactory widgets).
	(gtk_item_factory_get_widget_by_action): walk the GtkItemFactoryItem
	list to find the widget.
	(gtk_item_factory_get_item): new function that works around
	gtk_item_factory_get_widget() limitations, this function will only
	return menu items, even for <Branch> entries.

Tue Mar  9 01:01:28 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkfont.c (gdk_font_load): first lookup the xfont ID in our
	font hash table, if we have a GdkFontPrivate entry for this font
	already, simply increment its reference count, provided by Olaf Dietsche
	<olaf.dietsche+list.gtk@netcologne.de>.

	* gtk/gtkstyle.c (gtk_style_copy): plug a GdkFont reference leak, fix
	provided by Olaf Dietsche <olaf.dietsche+list.gtk@netcologne.de>.

Sun Mar  7 06:13:29 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkcontainer.c:
	(gtk_container_add_with_args): 
	(gtk_container_addv): 
	(gtk_container_add): before adding a child to a conatiner, make sure
	it is (default) constructed, this is neccessary because under certain
	circumstances the child will get relized and mapped immediatedly, in
	which case it has to be constructed already.

Mon Mar  1 17:58:21 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtksignal.c (gtk_signal_connect_by_type): count object_signal
	values > 1 as TRUE also.

Wed Feb 24 05:27:44 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.2.0

	* AUTHORS: updated
	
Wed Feb 24 05:26:20 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* gtk/gtkitemfactory.h: added a dummy gpointer to 
	  GtkItemFactoryClass for Tim Janik.

Mon Feb 22 21:22:11 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcontainer.h gtk/gtkwidget.h: Added some
	  padding to class structures to allow addition
	  of signals without breaking binary compatibility.

Thu Feb 25 13:38:38 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_size_request): still
	request the extra width or height if the corresponding scrollbar is
	already visible (the change from 09:50 needs to apply to policy ==
	GTK_POLICY_AUTOMATIC only).

Thu Feb 25 11:27:36 1999  Tim Janik  <timj@gtk.org>

	* TODO: updates, i left the text widget related portions in there,
	to serve as a guide line for things to watch out for when it gets
	reimplemented.

Thu Feb 25 09:50:38 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_size_request): don't add
	extra width or height if the requested size is mandatory (i.e. set
	through child->usize).

Thu Feb 25 02:13:20 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* gtk/gtkmenu.[ch]: New function gtk_menu_reorder_child()
	  from Tim Janik.  

Thu Feb 25 00:48:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfontsel.c: Don't access *bitmapped_sizes
	if nbitmapped_sizes == 0. (Pointed out by
	zucchi@zedzone.fsi.com.au (Michael Zucchi))

Wed Feb 24 23:12:09 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.h gtk/gtkclist.c: Make prototypes 
	for drag_data_get and drag_data_received handlers
	match the types used for gtk_singal_new; time needs
	to be a uint, not a uint32. 
	
Wed Feb 24 20:34:59 1999  Owen Taylor  <otaylor@redhat.com>

	* README: Changed bug reporting instructions to
	describe using the GNOME bug tracking system.

Wed Feb 24 19:08:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (draw_cell_pixmap): Unset the clip
	mask for the GC if we set it. (Patch from
	Lars Hamann <lars@gtk.org>)

Thu Feb 24 23:58:44 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtksignal.c (gtk_signal_handler_pending_by_id): added function
	to check if a specific signal handler connection exists (similar to
	gtk_signal_handler_pending_by_func). and yes, this is a neccessary
	addition, since without this function, signal handlers can not be
	(un)blocked or disconnected in a generic fashion without producing
	g_warnings().
	made gtk_signal_get_handlers() an inline function since it's used in
	a lot of places, especially within signal emission.

Wed Feb 24 19:35:15 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtktext.c (gtk_text_key_press): if the widget is not editable,
	don't silently eat up GDK_Return, GDK_Home and GDK_End, return FALSE
	instead so the user can still hook up key bindings.

Wed Feb 24 11:19:12 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_size_request): warn about
	&widget->requisition, even for toplevels.

	* gtk/gtkwindow.c (gtk_window_move_resize): request size into an
	automatic variable and check if our size has changed.
	when we decide to reallocate everything, we need to resize our
	own GdkWindow as well.

	* gtk/gtkmain.c:
	* gtk/gtkobject.c: hack time, make --gtk-debug=objects work even
	after gtk_type_init(), this is to "fix" gnome's arg parsing oddities.

	* gtk/gtktypeutils.h: don't segfault in GTK_CHECK_CLASS_TYPE and
	GTK_CHECK_TYPE upon NULL pointers.

	* gtk/gtklayout.c: removed bogus prototypes of gtk_layout_gravity_works,
	gtk_layout_set_static_gravity, gtk_layout_add_child_cb and
	gtk_layout_remove_child_cb to shut up compiler.
	
	* gtk/Makefile.am: added an empty rule
	gtkrc:
		:
	so make doesn't try to "update" gtkrc from gtkrc.c.

Wed Feb 24 05:53:15 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* gtk/Makefile.am: removed gtkrc rule added by   
	  Sergey Panov, because GTK+ no longer built.  We
	  don't need to install an empty gtkrc anyway.

Wed Feb 24 01:22:39 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* *.[ch]: Added notice to look in AUTHORS and ChangeLog files
	  for a list of changes.

Tue Feb 23 17:52:37 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkitemfactory.c (gtk_item_factory_create_item): fix implicit
	branch creation, we need the *real* parent path for this and
	gtk_item_factory_parse_path() only returns the parent path with "_?"
	stripped off.

1999-02-23  Pavel Machek  <pavel@artax.karlin.mff.cuni.cz>

	* gtk/gtkentry.c (gtk_entry_finalize): trivial bugfix

Mon Feb 22 19:06:30 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c (xdnd_send_*): When sending events to
	 windows with a proxy, set the window field in the
	 sent event to the original window, not to the proxy.
	 (This gives consistency with Motif, and also provides
	  information to the destination that it wouldn't have 
	  otherwise).
	
	* gtk/gtkdnd.c: Fixed some refcount leaks for windows.

	* gdk/gdkdnd.c (xdnd_send_xevent): When sending
	 Xdnd event to the root window, set the event mask
	 to ButtonPressMask. Hopefully, this should give us 
	 compatibility with kfm, if it uses the Qt style
	 of root window drops.

Mon Feb 22 08:45:10 GMT 1999 Tony Gale  <gale@gtk.org>

	* docs/gtk_tut.sgml:
	  - Complete the ProgressBar API
	  - Fix the CList example code

	* examples/clist/clist.c, examples/progressbar/progressbar.c:
	   Update from tutorial

Sun Feb 21 17:44:52 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/testgtkrc: Removed check-y/check-n backgrounds -
	 the effect looked like a bug.

Sun Feb 21 17:14:44 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_set_geometry_hints): Always
	 set the max width or height to at least 1, since 0 
	 triggers bugs in some window managers. (The window 
	"pops out" of the frame in fvwm)

Sun Feb 21 16:16:22 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkscrolledwindow.c gdk/gdkfont.c gdk/gdkim.c:
	 Changed warnings from g_message() to g_warning().

	* gdk/gdkim.c (gdk_ic_destroy): Changed g_print
	 to g_message within GDK_NOTE()

	* gtk/gtkcolorsel.c  gtk/gtkhandlebox.c:
	 Removed some leftover debugging printfs.

Sun Feb 21 15:59:55 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/MwmUtil.h gdk/gdkwindow.c: Account for the
	fact that Xlib expects format == 32 to be a long,
	even on 64-bit architectures.
	
	[ patch from George Lebl (jirka@5z.com) ]

Sun Feb 21 14:46:02 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_init_check):
	  gdk/gdk.c     (gdk_init_check):

	Added initialization variants that return a status
	instead of dying.

Sun Feb 21 14:21:46 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c: removed debugging statements
	about embedded XID's. They could have been
	moved to the new PLUGSOCKET debug key, but they weren't
	really useful anyways.

	* gdk/gdk.h: Added gdk_error_trap_push/pop to provide
	a clean interface to the gdk_error_code functionality
	of trapping X errors.

	* gtk/gtkplug.c gtk/gtksocket.c: Add error
	traps around accesses to foreign windows.

Sun Feb 21 15:37:25 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.h: marked gtk_window_set_focus, gtk_window_set_default,
	gtk_window_remove_embedded_xid and gtk_window_add_embedded_xid as
	internal functions.

Sun Feb 21 11:39:06 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.c (find_line_containing_point): Revise
	algorithm for scrolling backwards. This one might actually 
	work with one-line-high	Text widgets.

	* gtk/gtkmain.c: Removed a misplaced comment, a few 
	formatting cleanups.

Sat Feb 20 20:59:25 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c: hm, set_modal doesn't really work with random
	gtk_grab_add/gtk_grab_remove calls. either the window user uses
	the set_modal interface or he places grab_add/grab_remove on his own.
	(gtk_window_set_modal): enforce modality state either way.
	(gtk_window_hide): revert previous change.

Sat Feb 20 20:04:48 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkcalendar.c (gtk_calendar_button_press): increment years and
	months by two not three on double clicks, patch provided by Nick Lamb
	<njl98r@ecs.soton.ac.uk>.

Sat Feb 20 19:44:36 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c: added ::modal argument.
	(gtk_window_hide): reset window->modal from the current grab state
	(this is only relevant when grab_add/grab_remove is called on the
	window by bypassing gtk_window_set_modal).
	(gtk_window_remove_embedded_xid): 
	(gtk_window_add_embedded_xid): don't use g_print() but g_message()
	within #ifdef G_ENABLE_DEBUG. when the hack got these functions
	added (ChangeLog doesn't know them)?

Fri Feb 19 14:59:45 EST 1999 Sergey Panov  <sipan@mit.edu>

        * gtk/gtkrc,gtk/gtkrc.ja, gtk/gtkrc.ko,
	gtk/gtkrc.ru: Collecttion of the locale dependent
	gtkrc files and

	* gtk/Makefile.am: patched to get that collection
	installed in to $(prefix)/etc/gtk/

Fri Feb 19 17:52:28 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtksignal.h: grouped function names into application-level,
	widget-level and non-public.

	* gtk/gtktreeitem.c (gtk_tree_item_size_request): use auto
	pix_requisition instead of item->pixmaps_box->requisition.

Thu Feb 18 17:26:09 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_queue_clear_area): 
	 When queueing clears relative to widget->window,
	 actually store widget->window so we know that
	 the coordinates are window-relative.

Thu Feb 18 11:46:57 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk.m4: Fix glib_config_args gtk_config_args
	  confusion. (pointed out by
	  Roland Dreier <droland@mail.math.okstate.edu>)

	* gtk/gtksocket.c gtk/gtkmain.c gtk/gtkdebug.h
	  (gtk_socket_filter_func): Move the plug-socket
	  debugging code to a new "plugsocket" debug keys
	  from the previous hardcoded DPRINTF.

Thu Feb 18 00:54:46 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkclist.c: added widget arg ::titles_active.

Thu Feb 18 00:27:46 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_queue_clear_area): only translate widget
	relative coordinates to window relative if the widget is not a toplevel
	(i.e. it has ->parent != NULL), otherwise the area size gets screwed up
	for toplevels.

Tue Feb 16 14:25:44 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* INSTALL
	  README
	  configure.in
	  gtk+.spec
	  docs/gtk-config.1: version = 1.1.16

	* Makefile.am: removed colorsel example since it
	  doesn't actually exist.

	* Released GTK+ 1.1.16

Mon Feb 15 23:55:27 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/testgtk.c (create_text): Use a ScrolledWindow
	 test how Text widgets work within ScrolledWindow.
	 (POLICY_AUTOMATIC drew very badly, so it uses
	  POLICY_ALWAYS for the vscrollbar)

	* gtk/gtktext.c (gtk_text_unrealize): Free the cache
	 in the unrealize handler. Some code in gtktext.c
	 assumes that if text->line_start_cache is non-NULL,
	 the widget is realized. We'll recompute it again
	 anyways if we later re-realize.

Fri Feb 12 15:47:20 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcalender.c gtk/gtkentry.c gtk/gtkhandlebox.c
	  gtk/gtknotebook.c gtk/gtktext.c  gtk/gtkviewport.c 
	  gtk/gtkwidget.c: 

	 When setting styles, remove unecessary explicits draws 
	 and clears.

	* gtk/gtkrange.c: Ugly fix so the steps get the
	 correct background.
	 
Mon Feb 15 22:55:50 1999  Owen Taylor  <otaylor@redhat.com>

	* NEWS: Updated for 1.1.16.

Mon Feb 15 19:36:57 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_finalize): Free
	 label->label_wc.

Mon Feb 15 18:02:22 1999  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkdnd.c: Some coding style fixups.

	* gtk/gtkdnd.c (gtk_drag_set_icon_pixmap): Set a flag
	 so that we destroy the icon window that we created
	 when the drag ends.

Thu Feb 11 18:43:12 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbindings.c (gtk_binding_set_add_path): When
	  we find a match, stop searching. (Because we
	  assume pspec != NULL in the search).

Wed Feb 10 01:18:22 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkhandlebox.c (gtk_handle_box_draw_ghost): Fix
	  up painting of "ghosts".

	* gtk/gtkhandlebox.c (gtk_handle_box_button_changed): 
	  Add double-click reattachment.

v	* gtk/gtkhandlebox.c: Grab on widget->window,
	  not on handlebox->bin_window. This means we don't 
	  have to worry about ungrabbing while reparenting.

	  Don't make a GTK+ grab - that wasn't necessary.

	* gtk/gtkhandlebox.c: Only compute the root -> desk
	  offset once, when starting the drag, instead
	  of continuously. This should solve the *Bad Window*
	  errors that were occurring because of race conditions
	  with the WM.
	  
	* gtk/gtkhandlebox.c: Completely reworked the 
	  the logic of reattachment. We introduce the 
	  concept of the "snap edge", which is an edge
	  that needs to be aligned for reattachmed.
	  We set a reasonable default from 
	  handlebox->handle_position, but an application
	  might want to change this in some circumstances.

	* gtk/gtkhandlebox.[ch]: Add settors:
            gtk_handle_box_set_handle_position  ();
            gtk_handle_box_set_snap_edge        ();

Mon Feb 15 11:13:01 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_set_focus): 
	  gtk/gtkwidget.c (gtk_widget_real_grab_focus):

	If the focus widget is the same, but does not currently
	have the focus, call gtk_window_set_focus(). This is needed
	so that click focusing with GtkPlug works correctly.

Mon Feb 15 07:45:28 1999  Tim Janik  <timj@gtk.org>

	* configure.in (--enable-debug): default to yes for development trees.

Fri Feb 12 00:08:01 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtklist.c (gtk_list_remove_items_internal): don't autoselect
	focus_row in case of GTK_SELECTION_EXTENDED

	* gtk/testgtk.c : few changes in list example.

	* gtk/gtklistitem.c (gtk_list_item_class_init): 
	* gtk/gtkctree.c (gtk_ctree_class_init): 
	* gtk/gtkclist.c (gtk_clist_class_init): 
	fixed indentation, removed unused key bindings
	
Wed Feb 10 01:02:46 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (real_remove_row): 
	* gtk/gtkctree.c (gtk_ctree_remove_node): don't autoselect focus_row
	in case of GTK_SELECTION_EXTENDED

	* gtk/testgtk.c : few changes in clist/ctree examples.

Wed Feb 10 15:49:16 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c (gtk_window_class_init):
	* gtk/gtkctree.c (gtk_ctree_class_init): applied patch from Paolo
	Molaro to fix GTK_TYPE_POINTER args of ::tree_collapse and
	::set_focus signals.

	* docs/gtk_tut.sgml: s/menufactory/itemfactory, minor fixups
	to the item factory example.

Wed Feb 10 11:05:53 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c: Reverted coding style "fixups"

Wed Feb 10 10:43:50 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_set_icon, gdk_window_set_group):
	 Supplement the existing WMNormalHints, don't 
	 overwrite them.

Wed Feb 10 08:35:36 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkcolorsel.c (gtk_color_selection_draw_value_bar): asure that
	->value_buf always points to an allocated area.
	(gtk_color_selection_drag_end): new function hooked up to drag_end to
	destroy the drag_window.

	* gtk/gtkdnd.c: some coding style fixups.

Wed Feb 10 06:47:17 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkwindow.c: various indentation fixes.

	* gdk/gdkevents.c: coding style fixups.
	NULL initialize event_func, event_notify and event_chunk.
	(expose_predicate): made this function static.
	(gdk_event_handler_set): perform destroy notification even if no
	event_func is set.

	* gdk/gdkrectangle.c (gdk_rectangle_union): added g_return_if_fail
	statements.

Sun Feb  7 19:49:21 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_move_resize): Fixed some
	  bugs with set_default_size.

Sat Feb  6 13:23:51 1999  Owen Taylor  <otaylor@redhat.com>

	* docs/Changes-1.2.txt: Added information about
	 the change to gtk_widget_size_request().

	* gtk/gtkentry.c: Call gtk_widget_get_child_requisition
	 explicitely since we differentiate between the usize
	 set by the user and what we got. (Ugh)

	* gtk/gtkwidget.[ch] (gtk_widget_get_child_requisition):
	 New function to return the effective size of a widget
	 as it looks to its parent.

	* gtk/gtkwidget.c (gtk_widget_size_request): Leave
	 widget->requisition set to exactly what the widget
	 asked for, and then make a copy of that into
	 the requisition argument. Allow a NULL requisition
	 argument, and, if G_ENABLE_DEBUG, warn if
	 requisition == &widget->requisition.

	* gtkalignment.c gtkaspectframe.c gtkbutton.c gtkclist.c
	  gtkcontainer.c gtkentry.c gtkeventbox.c gtkfixed.c
	  gtkframe.c gtkhandlebox.c gtkhbox.c gtkhpaned.c 
	  gtklayout.c gtklist.c gtklistitem.c gtkmenu.c
	  gtkmenubar.c gtkmenuitem.c gtknotebook.c
	  gtkoptionmenu.c gtkpacker.c gtkscrolledwindow.c
	  gtktable.c gtktoolbar.c gtktree.c gtktreeitem.c
	  gtkvbox.c gtkviewport.c gtkvpaned.c gtkwindow.c

	 Avoid calling gtk_widget_size_request with
	 requisition == widget->requisition; use 
	 gtk_widget_get_child_requisition to get the
	 size of children.

Tue Feb  9 19:49:46 1999  Owen Taylor  <otaylor@redhat.com>

	* configure.in (LDFLAGS): Removed extraneous line
	  that crept in in previous commit.

Tue Feb  9 19:39:32 1999  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkentry.[ch] gtk/gtkeditable.h: Moved
	  entry->visible into editable class. (Leave it
	  behind deprecated for compatibility)
	 
	* gtk/gtkeditable.c: If not editable->visible,
	  return *'s for clipboard and selection.

Tue Feb  9 19:11:43 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.c (gtk_style_new): If we can't find
	  helvetica, fall back to "fixed". If we can't
	  find "fixed", exit cleanly.

Tue Feb  9 16:03:44 1999  Owen Taylor  <otaylor@redhat.com>

	* acconfig.h configure.in: Rename 
	  XIM_INST_IS_MISSING_OR_STRANGE to USE_X11R6_XIM

	* Conditionalize destroy callbacks with USE_X11R6_XIM.

Tue Feb  9 15:35:13 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_style_set): Added
	  a style_set() function so that word lengths get
	  recomputed on style change.

Mon Feb  8 21:00:20 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (CLIST_OPTIMUM_SIZE): changed to 64
	(gtk_clist_draw_focus) (hadjustment_value_changed) (draw_row):
 	few fixes to respect GTK_CAN_FOCUS flag.

	* gtk/gtkctree.c (draw_row): 
 	respect GTK_CAN_FOCUS flag.

Mon Feb  8 19:22:27 GMT 1999 Tony Gale  <gale@gtk.org>

	* example/colorsel/*: missing from the CVS for some reason

Mon Feb  8 13:08:51 GMT 1999 Tony Gale  <gale@gtk.org>

	* examples/Makefile: add SpinButton example

Mon Feb  8 12:50:06 GMT 1999 Tony Gale  <gale@gtk.org>

	* docs/gtk_tut.sgml:
	  - Heavily edited GtkCombo section initially from
	    Christopher T. Lansdown <lansdoct@screech.cs.alfred.edu>.

	  - Cleanups and some glib stuff from
	    David Wheeler <wheeler@ida.org>

	* Makefile.am: update to include the latest Tutorial examples.

Sat Feb  6 11:20:16 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_idle_draw): Add the
	entire draw_data_list back to the free list, not
	just the last element.

Sat Feb  6 00:21:14 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (draw_row): 
	* gtk/gtkclist.c (draw_row) (new_column_width) (scroll_horizontal)
	(title_focus): search last visible column instead of
	using clist->columns.

Fri Feb  5 13:23:50 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_move_resize): Adjust
	saved positions of children when resizing a 
	guffaw_gravity = TRUE window.

	* gtk/gtkdnd.c (gtk_drag_highlight): Rework the
	 highlighting so that it is done in callbacks for
	 draw and expose. This should solve problems with
         multiple highlights for the same GdkWindow.

	* gtk/gtkdnd.c (gtk_drag_highlight): Fix bug where
	the highlight was being drawn with an incorrect
	width/height for !NO_WINDOW widgets.

Tue Feb  2 11:06:02 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_style_set): Fixes
	 to account for the changed structure of the windows
	 of range widgets.

1999-02-05  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtk[hv]paned.c (gtk_[hv]paned_size_allocate): 
	Don't assume any more that the gtkwidget.c code
	will queue a redraw on us during a size_allocate -
	queue clear/draws as appropriate for our groove.

1999-02-04  Christopher Blizzard  <blizzard@redhat.com>

	* gtk+.spec (Packager): Change my email address.

Thu Feb  4 05:42:34 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* INSTALL
	  NEWS
	  README
	  configure.in
	  gtk+.spec
	  docs/gtk-config.1: version=1.1.15

	* Makefile.am: example files where incorrect for
	  menu directory.

	* Released GTK+ 1.1.15

Wed Feb  3 17:29:57 PST 1999 Manish Singh <yosh@gimp.org>

	* gtk/gtkclist.h: spelling fix in comment from
	joey@kuolema.Infodrom.North.DE (Martin Schulze)

Tue Feb  2 12:39:42 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c: Make sure we set the icon window position 
	 before it is shown to prevent annoying flicking to 0,0.
	 Make it consistent that info->cur_x/y do not include
	 info->hot_x/y displacement.

Tue Feb  2 08:59:16 GMT 1999 Tony Gale  <gale@gtk.org>

	* docs/gtk_tut.sgml: new sections on Layout and
	  SpinButton [nice widget]

	* examples/spinbutton/*: example code

Mon Feb  1 19:25:54 1999  Owen Taylor  <otaylor@redhat.com>

	* docs/gtk-config.txt (testinput_SOURCES): Put
	in some information about 'gtk-config --libs gthread'.

	* docs/Changes-1.2.txt: Updated section on threads.

Tue Feb  2 00:28:44 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (gtk_ctree_insert_node): in case of
	GTK_SELECTION_BROWSE select first inserted row.
	(resync_selection): select rows in correct order.

	* gtk/gtkclist.c (real_insert_row): in case of GTK_SELECTION_BROWSE
 	select first inserted row.
	(resync_selection): select rows in correct order.

	* gtk/gtklist.c (gtk_list_end_selection): select rows in correct order.

Mon Feb  1 16:47:55 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk.m4: Pass gthread on to gtk-config.

	* configure.in gtk-config.in: Support gthread flag to 
	  add thread cflags/libraries into the output of 
	  gtk-config.

Mon Feb  1 15:14:56 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_size_allocate): 
	 Fixed problem with uints resulting in huge child
	 allocations.

Mon Feb  1 14:54:28 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_expose): Cast uints
	 to ints in geometry calculations. This should
	 prevent FP exceptions on FreeBSD when quantities
	 become negative. [ Actually, this is probably
	 a workaround with a gcc bug with handling of
	 bitfields, according to Ben Jackson <ben@ben.com> ]

Mon Feb  1 13:35:14 GMT 1999 Tony Gale  <gale@gtk.org>

	* examples/Makefile: update to new examples

	* examples/menu/itemfactory.c: I must have forgotten to
	  'cvs add' this file

Mon Feb  1 09:16:03 GMT 1999 Tony Gale  <gale@gtk.org>

	* docs/gtk_tut.sgml:
	  - Complete documentation of Label widget API
	  - New sections for the following:
		* Arrows
		* Alignment
		* Button Boxes
		* Viewports

	* examples/arrow/*, examples/buttonbox/*, examples/label/*
	  - New code examples

Fri Jan 29 09:44:37 GMT 1999 Tony Gale  <gale@gtk.org>

	* examples/fixed/*, examples/frame/*
	  - Examples from the Tutorial

Fri Jan 29 09:18:41 GMT 1999 Tony Gale  <gale@gtk.org>

	* docs/gtk_tut.sgml:
	  - New sections on the Fixed and Frame containers
	  - Rearrange the Containers section so the easier ones
	    are first
	  - Move the List widget section to an appendix

Thu Jan 28 12:14:12 GMT 1999 Tony Gale  <gale@gtk.org>

	* docs/package_tutorial.sh: script to convert and
	  package up the tutorial - stick it here so I don't lose
	  it when I accidentally delete it again.
 
Thu Jan 28 10:16:28 GMT 1999 Tony Gale  <gale@gtk.org>

        * docs/gtk_tut.sgml:
          - Replace all uses of deprecated functions.
          - Replace menufactory example with itemfactory example
            from Nick Scott <mendigo@geocities.com>
          - Minor bug fixes in the examples.

1999-01-28  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>

	* gdk/gdkim.c:
	s/XIM_INSTANTIATE_IS_MISSING_OR_STRANGE/XIM_INST_IS_MISSING_OR_STRANGE/

Thu Jan 28 01:57:06 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* INSTALL
	  NEWS
	  README
	  configure.in
	  gtk+.spec
	  docs/gtk-config.1: version=1.1.14

	* Released GTK+ 1.1.14

Thu Jan 28 01:34:29 1999  Owen Taylor  <otaylor@redhat.com>

	* gtkfontsel.c gtkcolorsel.c: When translating
	N_() strings, use _(), not gettext(), since we
	really need to call dgettext().

Wed Jan 27 20:51:25 PST 1999 Manish Singh <yosh@gimp.org>

	* acinclude.m4: Xsed isn't valid here, don't use it

	* ltmain.sh
	* ltconfig: better file magic regexp for Linux libs

Wed Jan 27 23:05:55 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklayout.[ch] (gtk_layout_realize): Move 
	gravity_works back to a static global variable,
	since it is a global constant, and this way we
	keep structure sizes uniform.

Wed Jan 27 22:59:07 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am (static_SOURCES): Move gtkintl.h
	from $source_headers to $static_sources since
	it should not be installed.

Wed Jan 27 22:51:23 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c (expose_predicate): Allow exposure
	 compression across GravityNotify events to improve
 	 the appearance of a GTK+ window unshading.

Wed Jan 27 21:56:07 1999  Owen Taylor  <otaylor@redhat.com>

        [ patch from Takashi Matsuda <matsu@arch.comp.kyutech.ac.jp> ]
	
	* acconfig.h configure.in gdk/gdkim.c: Add configure 
	flag for disabling XRegisterIMInstantiateCallback(), default
	it to off for Solaris. Always try to open the
	input method immediately, and only if that fails,
	register than instantiate callback.

	* gtk/gtkentry.c: Some tweaks to make sure that we
	only get and set the IC attributes when appropriate.
	
Wed Jan 27 20:08:54 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (open_user_dir): Patch from
	Sebastian Wilhelmi  <wilhelmi@ira.uka.de> to
	use g_get_home_dir() instead of calling getpwuid() 
	ourselves.

Wed Jan 27 20:06:06 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklayout .c (gtk_layout_adjustment_changed):
	Removed some g_print()'s

Wed Jan 27 18:57:57 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.h gdk/gdkdnd.c: Change signatures for 
	gdk_drag_begin() and gdk_drag_motion() so that the set 
	of possible actions is passed on each motion, not just at
	the beginning of the drag. We do this so that
	we can restrict the set of possible drag events
	when the user presses a modifier key during a 
	drag.

	* gdk/gdkdnd.c: Send a motif Operation-changed
	message when the set of possible actions change,
	as well as when the suggested action change.

	* gdk/gdkdnd.c: Change the XdndActionList whenever
	the set of actions change.

	* gdk/gdkdnd.c: Add a filter to catch changes to
	the XdndActionList property for the source widget.

	* gtk/gtkdnd.c: Change the set of possible actions
	when the user presses Control, Shift, or Control-Shift,
	to only include the corresponding action.
	
	* gtk/gtkdnd.c (gtk_drag_button_release_cb):
	Disconnect button signals before we possibly
	free info structure.

Wed Jan 27 18:40:50 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_main_do_event): Hack scrollwheel
	support into the eventloop, by treating button 4-5
	presses on scrolled windows and scrollbars specially. 
	Put it here to keep the ugliness small and confined.
	(We need to intercept the normal propagation in any case
	to have this work reliably right now, since some
	subwidgets will trap the button presses)
	
	* gtk/gtkviewport.c (gtk_viewport_realize): Select for 
	BUTTON_PRESS to	support the above hack.
	
Tue Jan 26 14:02:50 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_show/hide): Remove TimJ's
	checks for already being mapped or hidden. See
	the ICCCM's section on state changes for why this
	is a bad idea.

Wed Jan 27 17:05:40 1999  Owen Taylor  <otaylor@redhat.com>

	* Separate out GLIB_LIBS and GLIB_DEPLIBS. This
	may fix the --with-glib option. GLIB_LIBS are
	the libs to link example programs against, while
	GLIB_DEPLIBS are dependency libraries.

Wed Jan 20 11:19:00 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c: Use floor() instead of truncating
	to integer values so we get translation invariance.

	* gtk/gtklayout.c (gtk_layout_size_allocate): Set upper
	and lower values for adjustments in size_allocate().

	* gdk/gdkwindow.c gdk/gdk.h gdk/gdkprivate.h: New
	function gdk_window_set_static_gravities() to set
	up a window for guffaw scrolling.
	
	* gdk/gdkwindow.c (gdk_window_internal_destroy): Set flags
	indicating destroyed state before cleanup.

	* gtk/gtkprivate.h gtk/gtkwidget.c: Add a new
	private flag IS_OFFSCREEN. If set, this indicates
	to GTK+ that the widget is not to be considered
	viewable regardless of its map state. Queued draws
	on offscreen widgets are suppressed.

	Added new function static gtk_widget_is_offscreen() to
	check this flag on a widget and its ancestors.

	* gtk/gtklayout.[ch]: Major revisions.

	- Use gdk_window_set_static_gravities to set static gravity 
	on all child windows, and thus avoid having to create a window
	for NO_WINDOW children.

	- Adjust allocations of children as we scroll them
	so queued draws work correctly.

	- Don't allocate our children directly in a put()
	or move(); just queue a resize() like every other
	widget.

	* gtk/testgtk.c: Make the arrows on the scrollbars
	work, create a larger and more demanding test.
	
Wed Jan 27 09:19:07 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdkcolor.c (gdk_colormap_unref): assert ref_count>0.

Mon Jan 25 20:05:22 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_set_{visual,colormap}): 
	New functions to set the colormap or visual
	of an existing widget. These functions should not
	be called on a widget that has previosly been
	realized.

	* gtk/gtkcolorsel.c (gtk_color_selection_dialog_init):
	Set the visual and colormap on the toplevel dialog,
	then push them for the child widgets. As opposed
	to push/pop in _new(), this way, things will work
	properly with gtk_widget_new().
	
Mon Jan 25 19:41:56 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_page_allocate): Queue
	a redraw on the tab area when a tab changes size.
	(Includes improvements from Lars Hamann)

Mon Jan 25 19:00:13 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c (gtk_color_selection_value_events): 
	 Back out the last solution to updating problem. And
	 try a different one that is less dependent on
	 the state of the widget. Just redraw the value_marker
	 when it gets mapped. Somebody needs to analyze
	 this widget more carefully and figure out when
	 it should be setting the contents of the previews
	 with more care.

Mon Jan 25 17:48:03 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c: Removed some GTK_WIDGET_DRAWABLE()
	tests - we need to update the value bar's contents
	even when the widget is unmapped.

Mon Jan 25 15:47:46 1999  Owen Taylor  <otaylor@redhat.com>

	* acinclude.m4 (ac_result): Don't define ENABLE_NLS
	 unless we have a working NLS. (This should keep
	 libintl.h from being included when it doesn't
	 exist).

Mon Jan 25 11:05:10 1999  George Lebl  <jirka@5z.com>

	* gtk/gtkbutton.c: set RECEIVES_DEFAULT on init, and a
	  button press on the widget doesn't grab default anymore

	* gtk/gtkcheckbutton.c,gtk/gtkoptionmenu.c,gtk/gtkradiobutton.c:
	  unset RECEIVES_DEFAULT on init

	* gtk/gtkwidget.[ch]: add a RECEIVES_DEFAULT flag to widget
	  flags

	* gtk/gtkwindow.c,gtk/gtkplug.c: on pressing <enter>, activate
	  the focused widget if it is a RECEIVES_DEFAULT widget,
	  no matter what the current default_widget is

	* gtk/gtkwindow.c: on focus change, migrate the HAS_DEFAULT
	  flag to CAN_DEFAULT widgets if they RECEIVE_DEFAULT as well
	  or migrate it back to the default_widget if the focus widget
	  doesn't "RECEIVE_DEFAULT"

Sun Jan 24 18:09:24 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c (motif_read_initiator_info): Byteswap
	the MotifInitiatorInfo structure _before_ using it.

Sun Jan 24 12:17:39 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkcolor.c (gdk_colormap_real_destroy): Fix 
	 reversed assertion. 
	 (Pointed out by Austin Donnelly <austin@greenend.org.uk>)

	* gtk/gtkruler.c (gtk_ruler_expose): Remove unecessary
	 and harmful call to gtk_paint_box(). We are going
	 to paint onto the backing store later anyways.

Sat Jan 23 11:15:39 1999  Owen Taylor  <otaylor@gtk.org>

	* gdk/gdkdnd.c (gdk_window_register_dnd): X expects
	 longs, not uint32 for XChangeProperty, when 
	 format == 32.

	* gdk/gdkdnd.c (motif_read_initiator_info): Byte-swap
	 the MotifInitiatorInfo structure if necessary.

 	* gdk/gdkdnd.c: When extracting and constructing
         Motif DND messages, don't use data.s[], data.l[]
	 since on 64bit architectures, these won't necessarily
	 be in the same place with data.b[]. 

 	* gtk/testdnd.c (target_drag_drop): Return TRUE for
	 drag_drop within the drop zone.
 
	* gtk/gtkdnd.c (gtk_drag_dest_handle_event): Only send
	 a XmTRANSFER_FAILURE if no drop site is found, not
	 on every drop!

Fri Jan 22 19:22:39 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkeditable.c: Add flags field to 
	 GtkTargetEntry table.
	
	* gdk/gdkwindow.c (gdk_window_is_viewable): Treat foreign
	 windows as always viewable, since we can't track their
	 map-state reliably without speed problems. (Fixes
	 problem where updating didn't occur properly within
	 GtkPlug)

Sat Jan 23 13:41:00 1999  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtkctree.c
	(tree_delete): Don't search selection list twice.
	(real_select_row): Remove extra ';', add default for clarity.

Sat Jan 23 01:44:43 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkspinbutton.c (gtk_spin_button_get_value_as_int)
	(gtk_spin_button_get_value_as_float): removed extra
 	gtk_spin_button_update calls again.
	* gtk/gtkclist.c (gtk_clist_unmap): unblock dnd signal handler if
	neccessary
	* gtk/gtknotebook.c (gtk_notebook_button_press): grab_focus before
	switch_page
	(gtk_notebook_set_shape): don't use cur_page if it's NULL.

Fri Jan 22 12:20:54 1999  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtktooltips.c:
	Fix recent change to match existing coding style.

Fri Jan 22 07:33:44 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkvscale.c (gtk_vscale_pos_trough): take value_spacing into
	account for GTK_POS_LEFT.

	* gtk/gtkradiobutton.c (gtk_radio_button_set_group): use
	gtk_toggle_button_set_active () to set the new state.
	(gtk_radio_button_new): only _set_group if group != NULL.
	(gtk_radio_button_clicked): reference the widget.
	(gtk_radio_button_init): make radio buttons active upon
	startup.

Thu Jan 21 17:13:12 1999  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtkselection.c:
	(gtk_selection_property_notify): Check args for NULL.
	(gtk_selection_default_handler):
	Replace manual list count with call to g_list_length.
	Remove signedness of temp var 'count' to agree with usage.
	Slight spacing adjustment for readability.

	* gtk/gtkbox.c, gtk/gtklayout.c, gtk/gtkselection.c:
	Init a few ptrs to NULL, to quiet warnings.

Thu Jan 21 16:03:02 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbutton.c (gtk_button_expose): Code cleanup.

	* gtk/gtktreeitem.c: Add a paint routine, fix up bugs
	in drawing where if the expose area was contained
	completely in the right side of the tree the background
	wasn't redraw, etc.

	* gtk/gtkwidget.c (gtk_widget_clip_rect): Fix a bug
	in clipping draw regions while propagating them
	upwards.

Thu Jan 21 12:20:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c (gtk_color_selection_dialog_new): 
	Pushing	and popping the visual/cmap in the init() 
	function does no good, because the window itself needs
	to be create with that visual/cmap.

	So do it in the new() function instead. 

	This will require people doing gtk_widget_new() to do 
	the push/pop themselves, but I don't see any way around
	it other than digging in and tweaking the window
	widget's colormap and visual ourselves, which
	is highly non-kosher, but would be safe...

Thu Jan 21 16:04:35 1999  Timur Bakeyev <mc@bat.ru>

	* gtk/gtkrc.c (gtk_rc_init): It was reported by Owen Taylor 
	<otaylor@redhat.com>, that LC_ALL produce unparsable garbage
	on some glibc'ed systems and HP/UX. So, falling to LC_CTYPE.

Thu Jan 21 02:11:44 1999  Owen Taylor  <otaylor@redhat.com>

	* Set and read the XdndActionList property defined
	in the Xdnd spec. We do this always, not just for
	XdndActionAsk like the spec says, but if we don't
	find it, we fall back to actions = suggested_action,
	which is compatible with the language of the spec.

Thu Jan 21 01:15:28 1999  Jeff Garzik  <jgarzik@pobox.com>

	* gdk/gdkdnd.c (gdk_drag_context_unref):
	Move not-null assertion before pointer de-ref.

	* gdk/gdkevents.c (gdk_event_queue_find_first):
	Fix infinite loop bug.  Someone should look at this further to
	make sure the events_pending tests are correct.

Thu Jan 21 00:44:47 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_dest_drop): Default handling
	for drops should be keyed on GTK_DRAG_DEFAULT_DROP
	not GTK_DRAG_DEFAULT_MOTION.

Wed Jan 20 21:52:51 1999  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtkclist.c (real_remove_row):
	Don't search entire row list twice for element being removed.

	* gtk/gtkmenushell.c (gtk_menu_shell_insert):
	Replaced hand-coded implementation of g_list_insert with
	call to g_list_insert.

	* gtk/gtktooltips.c
	  (gtk_tooltips_destroy_data, gtk_tooltips_layout_text):
	tooltipsdata->row test not-null test now properly encompasses
	both g_list_* calls.

Thu Jan 21 02:47:36 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtknotebook.c (gtk_notebook_focus): few cleanups.
	(gtk_notebook_key_press): call select page function for
	GDK_DOWN key in case of tab_pos == TOP. Changed other
	positions accordingly.

Wed Jan 20 19:57:14 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_begin): Start off with the
	cursor for "no drop" since if we'll get a status
	if we are over a drag window, but none if we aren't
	over one. 

1999-01-20  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtkcombo.c (gtk_combo_entry_key_press):
	Free 'nprefix', closing a memory leak.
	Spaced out the code a bit to make it more readable.

	* gtk/gtkhbox.[ch] (gtk_hbox_new),
	  gtk/gtkvbox.[ch] (gtk_vbox_new):
	Change 'homogenous' arg from gint to gboolean.

	* gtk/gtktogglebutton.[ch]:
	New function gtk_toggle_button_get_active().

1999-01-20  Federico Mena Quintero  <federico@nuclecu.unam.mx>

	* gtk/gtkdnd.c (gtk_drag_get_event_action): Allow button 2 to act
	as GDK_ACTION_ASK.  Also, allow MOD1 to specify GDK_ACTION_ASK
	only if that action is enabled in the actions argument.

1999-01-20  Raja R Harinath  <harinath@cs.umn.edu>

	* configure.in (gtklocaledir): New variable.  Define to
	$prefix/$DATADIRNAME/locale.  This will point to the directory
	where po/Makefile actually installs the message translation
	tables. 
	* gtk/Makefile.am (INCLUDES): Define GTK_LOCALEDIR to
	$(gtklocaledir) rather than $prefix/share/locale.

Wed Jan 20 21:07:45 1999  Timur Bakeyev <mc@bat.ru>

	* gtk/gtkrc.c (gtk_rc_init): There are some systems, that lacks of
	LC_MESSAGES in locale.h. As a last resort for such systems, set locale
	according to LC_ALL.

Wed Jan 20 13:06:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.[ch] (clear_[focus_]area): Instead of drawing
	a background pixmap in with gdk_draw_pixmap(), set
	it as a tile pixmap for a GC. This should speed
	up things considerably and also will hide a bug
	where text->first_onscreen_ver_pixel is being
	corrupted, causing the bg pixmap drawing code to generate
	graphics exposes.

Tue Jan 19 22:15:10 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtklist.c
	(gtk_list_button_press):  only call grab_add if pointer_grab succeeds.
	(gtk_list_unmap): remove pointer/widget grabs if needed.
	(gtk_list_signal_focus_lost): removed.
	(gtk_list_focus) (gtk_list_set_focus_child): set last_focus_child.
	(gtk_list_remove_items_internal) (gtk_list_clear_items): unset
 	undo_focus_child if neccessary. In case of SELECTION_BROWSE/EXTENDED
 	select a new item if selection is empty.

Tue Jan 19 00:21:15 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkcompat.h: add compatibility define for
	gtk_ctree_set_reorderable.

Tue Jan 19 00:02:10 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (gtk_ctree_node_set_row_data_full): 
	add a sanity check [from Todd Dukes <todddukes@netscape.net>]
	
Mon Jan 18 22:54:11 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_button_press): only call grab_add
	if pointer_grab succeeds.
	(gtk_clist_unmap): remove pointer/widget grabs if needed.

Mon Jan 18 15:46:14 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_init): Initialize
	label->label_wc. (We allocate labels from
	a memchunk)

Mon Jan 18 18:53:08 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkscale.c (gtk_scale_set_digits): CLAMP digits into a
	meaningfull range (we need to stay below a certain limit anyways
	to avoid string buffer overflows).

	* gtk/gtkvscale.c (gtk_vscale_pos_background): fixed up background
	area calculations for GTK_POS_RIGHT and GTK_POS_BOTTOM.
	* gtk/gtkhscale.c (gtk_hscale_pos_background): likewise.
	(gtk_hscale_draw_value): safety CLAMP the value's x position for
	GTK_POS_TOP and GTK_POS_BOTTOM, so we don't paint strings outside of
	our allocation.

	* gtk/gtkscale.c: implemented GtkScale::digits, GtkScale::draw_value
	and GtkScale::value_pos arguments.

Mon Jan 18 14:26:17 1999  Owen Taylor  <otaylor@redhat.com>

	* docs/Changes-1.2.txt: Some editing, a little more
	detail.

Mon Jan 18 13:25:14 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.[ch]: Added gtk_menu_set_title() to
	set the title of a menu in the torn-off state.

	* gtk/gtkthemes.c (gtk_theme_engine_get): When loading
	of theme engine fails, just warn and do without -
	don't error out.

	* gtk/gtkmain.c (gtk_check_version): s/to/too/.

Mon Jan 18 01:21:03 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (draw_row): fixed auto resize bug.

Sun Jan 17 17:35:28 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.13

	* README:
	  INSTALL:
	  docs/gtk-config.1: ver=1.1.13

Mon Jan 18 00:22:54 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_button_press) (gtk_clist_button_release):
	block drag source signal handler during column resizes.
	(gtk_clist_set_column_visibility): resize clist if needed.
	(gtk_clist_map): raise resize windows to make resize
 	cursor visible again.

Sun Jan 17 22:47:15 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.[hc]: 
	* gtk/gtkspinbutton.[hc]: 
	* gtk/gtkscrolledwindow.[hc]:
	* gtk/gtkprogressbar.[hc]:
	* gtk/gtkpreview.[hc]: 
	* gtk/gtkobject.[hc]:
	* gtk/gtkentry.[hc]: 
	* gtk/gtkctree.[hc]:
	* gtk/gtkcontainer.[hc]:
	* gtk/gtkclist.[hc]:
	removed deprecated functions: gtk_clist_set_border,
	gtk_container_block_resize, gtk_container_unblock_resize,
	gtk_container_need_resize, gtk_ctree_set_reorderable,
	gtk_ctree_show_stub, gtk_ctree_set_use_drag_icons,
	gtk_entry_adjust_scroll, gtk_object_class_add_user_signal,
	gtk_preview_put_row, gtk_progress_bar_construct,
	gtk_scrolled_window_construct, gtk_spin_button_construct,
	gtk_widget_freeze_accelerators,	gtk_widget_thaw_accelerators.

	* gtk/gtkcheckmenuitem.c: removed binary variant of
	gtk_check_menu_item_set_state, this is still defined in gtkcompat.h
	though.

	* docs/Changes-1.2.txt:
	removed section about gtk_idle_remove_by_data vs.
	gtk_timeout_remove_by_data, we actually don't even provide a
	gtk_timeout_remove_by_data() function.
	added a table with removed functions and their replacements.
	
	* NEWS: updates for 1.1.13.

Sun Jan 17 17:56:33 1999  Owen Taylor  <otaylor@redhat.com>

	Patch from Felix Bellaby <felix@pooh.u-net.com>

	* gdk/gdk.c: Use XmbSetWMProperties to set
	the class/command on the loader window so that the
	client machine is also set in the same place.
	(For X11R5 sesssion management compatibility)

	* gdk/gdk.c: (gdk_set_sm_client_id) Implementation
	of function to set the session manager client ID.

	* gdk/gdkwindow.c (gdk_window_new): Set 
	WM_CLIENT_LEADER propertiy on all windows pointing
	back to GDK's leader window.

Sun Jan 17 12:01:57 1999  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtkrc.c (gtk_rc_style_init): Allow a bg_pixmap
	of "<none>", as there was no way to set the background
	on all widget but some widgets. This is important
	because Text widgets with background images are
	slow and possibly ugly.

1999-01-17  Nat Friedman  <nat@nat.org>

	* gtk/gtkscrolledwindow.c (DEFAULT_SCROLLBAR_SPACING): New macro.
  	Changed the spacing from 5 to 3.

	* gtk/gtkmenubar.c (BORDER_SPACING): Changed the extra spacing on
 	the menubar from 2 to 0.

Sun Jan 17 11:51:17 1999  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtktext.c (gtk_text_move_cursor): Fix typo
	[ gtk-mailund-990116-0: Thomas Mailund Jensen <mailund@daimi.au.dk> ]

Sun Jan 17 11:15:05 1999 Christopher Blizzard  <blizzard@appliedtheory.com>

	* gtk+.spec: Update to version 1.1.13, change packager address.

Sun Jan 17 14:52:29 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkcompat.h:
	* gtk/gtkcheckmenuitem.[hc]:
	deprecated gtk_check_menu_item_set_state, people should use
	gtk_check_menu_item_set_active instead.
	
	* gtk/testgtk.c:
	 s/gtk_check_menu_item_set_state/gtk_check_menu_item_set_active/.

Sun Jan 17 05:19:14 1999  Tim Janik  <timj@gtk.org>

        * configure.in: incremented version number to 1.1.13, bin age 0,
	interface age 0.

	* gtk/gtkmain.c (gtk_idle_remove_by_data): use g_idle_remove_by_data to
	remove idles, so `data' cannot conflict with other sources.

	* gtk/gtkcompat.h: define gtk_style_apply_default_pixmap here.

	* gtk/gtkstyle.[hc]: removed gtk_style_apply_default_pixmap.
	(struct _GtkStyle): reordered GtkStyleClass*klass; member.

Sat Jan 16 19:42:48 1999  George Lebl  <jirka@5z.com>

	* gtk/gtktooltips.c: for NO_WINDOW widgets, add their allocation.y
	  to the position of the tooltip. This fixes tooltip positioning
	  problems with some widgets such as a checkbox.

Sat Jan 16 14:01:53 1999  Stuart Parmenter <pavlov@gtk.org>

	* gtk/gtklayout.c (gtk_layout_put): check for child widget being NULL

Sat Jan 16 05:02:22 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_button_press): fixed double click bug.

Fri Jan 15 19:16:42 1999  Tim Janik  <timj@gtk.org>

	* gtk/Makefile.am: define GTK_DISABLE_COMPAT_H for compilation of gtk
	code.

	* gtk/gtkrc.c (gtk_rc_style_unref): added an assertment.

	* gtk/gtkcompat.h:
	* gtk/gtklabel.h: 
	don't provide compatibility defines if GTK_DISABLE_COMPAT_H is defined.

	* gtk/gtkstyle.h:
	* gtk/gtkstyle.c: coding style, indentation and alignment fixups.
	(gtk_draw_string): 
	(gtk_paint_string): 
	(gtk_draw_polygon):
	(gtk_style_set_background): fixed assertments.
	(gtk_default_draw_ramp): 
	(gtk_default_draw_cross): 
	(gtk_default_draw_oval): issue warnings since these functions aren't
	yet implemented.

	* gdk/gdkwindow.c:
	(gdk_window_hide): only unmap window if already mapped.
	(gdk_window_show): only map window if !mapped.
	(gdk_window_internal_destroy): destroyed windows can't be mapped.

	* gtk/gtkwidget.c (gtk_widget_event): don't ignore expose events just
	because a resize is queued on a widget, we rely on the expose events
	now.

Fri Jan 15 10:22:21 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_class_init): 
	nparams for selection_get should be 3, not 2.
	[ From Damon Chaplin <damon@karuna.freeserve.co.uk> ]

	* gtk/gtkeventbox.c (gtk_event_box_paint): Add a paint
	routine so queued redraws work inside event boxes.

Thu Jan 14 17:47:37 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_draw_cursor_on_drawable): Only
 	 redraw character under cursor when not displaying 
	highlighted selection.

	* gdk/gdkrgb.c (gdk_rgb_init): Add in a cast to
	gpointer to make IRIX cc happy.

Thu Jan 14 12:29:50 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcheckbutton.c (gtk_check_button_draw): Restructure
	the drawing code to remove a bit of duplication - 
	and to remove a call to gtk_widget_draw_focus()
	that queues a redraw when an expose occurs.

	* gtk/gtklabel.c (gtk_label_expose): Fix up handling
	  of ypadding.

	* gtk/gtknotebook.c (gtk_notebook_draw): If we redraw
	  the whole widget, also redraw the corresponding
	  areas of the child widget. (have_visible_child 
	  still has some problems)

	* gdk/gdkpixmap.c: Change some g_new's to g_new0 so
	  that fields unused for pixmaps get initialzized
	  sanely.

        * gdk/gdk.h gdk/gdkwindow.c gdk/gdkprivate.h: Add new calls
	  gdk_window_is_visible() and gdk_window_is_viewable()
	  and a mapped flag to the window private structure.
	
        * gtk/gtkbin.c gtk/gtkclist.c gtk/gtkfixed.c gtk/gtkitem.c
	  gtk/gtklayout.c gtk/gtklist.c gtk/gtkmenushell.c
	  gtk/gtknotebook.c gtk/gtkpaned.c gtk/gtktree.c
	  gtk/gtktreeitem.c gtk/gtkviewport.c: 
	Map windows after mapping children.
	
	* gtk/gtkwidget.c (gtk_widget_clip_rect): Handle 
	rectangles completely clipped away correctly.

	* gtk/gtkwidget.c (gtk_widget_idle_draw): Don't
	call gtk_widget_draw if width or height is 0.

	* gtk/gtkwidget.c (gtk_widget_idle_draw): Don't
	rely on GTK_REDRAW_PENDING after we've cleared
	it. (This was causing draw-combining to not
	happen at all).

	* gtk/gtkbin.c gtk/gtkscale.c: Remove uneccessary calls
	to gtk_widget_queue_draw() when mapping.

Thu Jan 14 11:29:53 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_get_event_action): Make
	MOD1-drag also do action ask.

	* gtk/gtkdnd.c (gtk_drag_button_release_cb): Send the
	button-release event we simulate to get grabs released,
	with a window of GDK_ROOT_PARENT instead of the actual 
	widget. This is a bad hack in some sense, but seems
	to work nicely. (It's sort of like what you would
	if you grabbed on button press, then the user 
	released outside of the widget.)

Thu Jan 14 20:29:16 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.[ch] (gtk_style_apply_default_background): 
	Change copy_area => !set_bg. Use tile instead of 
	gdk_window_copy_area when drawing without !set_bg.
	
	This does mess up timj's neat check-button example,
	but is consistent with how we interpret background
	pixmaps everywhere else in the default scheme.

	Restructure code for clarity.

Thu Jan 14 19:19:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c: Do all event processing in
	dispatch() instead of prepare() and check().

Wed Jan 13 22:34:29 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkbutton.c gtk/gtkclist.c gtk/gtkhandlebox.c
	gtk/gtkframe.c gtk/gtk[hv]box.c gtk[hv]paned.c gtk/gtklist.c
	gtkmenu.c gtkmenuitem.c gtkmenubar.c gtknotebook.c
	gtk/gtkscrolledwindow.c gtk/gtktable.c gtk/gtktree.c
	gtk/gtktreeeitem.c gtk/gtkviewport.c
	
	Fix up comparisons of signed and unsigned ints to avoid 
	assigning negative widths/heigths.

Wed Jan 13 21:18:41 1999  Owen Taylor  <otaylor@redhat.com>

	* acinclude.m4 (ac_result): Unset CATOBJEXT so
	that the macros and Makefiles correctly handle
	disabling NLS when no gettext is found.

Wed Jan 13 20:14:32 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkarg.c (gtk_arg_copy): in comparisions with GTK_TYPE_STRING, use
	the fundamental type to catch GTK_TYPE_IDENTIFIER as well.

	* gtk/gtkmenushell.c:
	(gtk_real_menu_shell_activate_current):
	(gtk_menu_shell_button_release): asure that we only activate sensitive
	menu items, reported by Dave Cole <dave@dccs.com.au>.

Wed Jan 13 13:28:00 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c: eliminate queue_clears or queue_draws where we know
	that expose events will be generated.
	(gtk_widget_map): only queue_draw for NO_WINDOW widgets.
	(gtk_widget_unmap): only queue_clear_child for NO_WINDOW widgets.
	(gtk_widget_size_allocate): we don't need a queue_clear on changing
	allocations of !NO_WINDOW widgets, we do still need a full redraw for
	them though.

	* gtk/gtklabel.c (gtk_label_set_text): check whether the new string
	actually differs from the original.

Tue Jan 12 22:50:44 PST 1999 Manish Singh <yosh@gimp.org>

	* acinclude.m4
	* ltconfig
	* ltmain.sh: upgrade to libtool 1.2d (with fixes for irix6 and osf)

Tue Jan 12 18:30:51 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/testdnd.c (label_drag_data_received): Add 
	a drag_data_received handler for the label.

Tue Jan 12 15:01:50 1999  Owen Taylor  <otaylor@redhat.com>

        * gdk/gdkevents.c: Removed the putback_events queue, 
	since it was causing problems with event ordering -
	just keep a single queue. If we need it, we can
	add priorities to events.

	* gdk/gdkevents.c: Annotate events with flags - we allocate
	a GdkEventPrivate structure in gdk_event_new() and use these
	flags to mark an event being translated as "pending" -
	I.e., not yet ready to be dequeued. So we can put
	the event on the queue and get the order of the
	events right. (This solves the double-click problems)
	
	* gdk/gdk.h gdk/gdkevents.h: Add gdk_event_peek() to get a copy
	of the next event on the event queue.
	
	* gtk/gtkmain.c (gtk_main_do_event): Use gdk_event_peek()
	to check the next event without causing event queue
	reordering.

Tue Jan 12 15:41:20 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_expose): Minor fix
	to handling of misc->[x/y]pad

Tue Jan 12 14:31:43 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkstyle.[ch] (gtk_style_apply_default_pixmap): 
	Add back as wrapper function to restore source/binary 
	compatibility. grrrr.

Tue Jan 12 13:47:07 1999  Tim Janik  <timj@gtk.org>

	* reworked the redrawing heuristics somewhat, this fixed a bunch of
	existing redrawing problems and majorly reduces overall redrawing needs
	during normal operation. basically we now only queue redraws when
	neccessary and much rely on the draw_area coalescing code in gtkwidget.c
	to optimize the queued portions. widgets will now upon reallocation only
	get redrawed if their allocation has changed. upon hide/show only the
	area allocated by the child will be queued for the parent, this has the
	side effect that parents which change their appearance in dependance on
	the numer of visible children have to keep track of their children's
	visiblity and eventually fully redraw themselves. this is a minor
	constrain with great benefits in terms of redraw reduction, and only got
	triggered by the notebook widget.

	* gtk/gtkwidget.c:
	(gtk_widget_queue_clear): don't bother if width and height == 0.
	(gtk_widget_queue_clear_child): new static function to queue a redraw of
	the area obscured by a child on a parent.
	(gtk_widget_queue_resize): queue_clear the widget if it is drawable.
	(gtk_widget_show): queue resize on the widget before showing.
	(gtk_widget_hide): queue resize on the widget after hiding.
	(gtk_widget_map): queue_draw the widget after mapping.
	(gtk_widget_unmap): queue_clear_child the widget.
	(gtk_widget_size_allocate): queue_clear_child and queue_draw if the
	widget's allocation changed.
	(gtk_widget_unparent): queue_clear_child so the parent redraws obscured
	portions.
	(gtk_widget_real_show):
	(gtk_widget_real_hide):
	(gtk_widget_real_map):
	(gtk_widget_real_unmap):
	(gtk_widget_real_size_allocate): don't bother with redraw queueing,
	descendants that override these functions don't do either and we handle
	all redrawing/resizing related stuff before or after the signal emission
	now.

	* gtk/gtkcontainer.c:
	(gtk_container_resize_children): don't bother about redrawing anymore
	since gtk_widget_size_allocate handles that for us now.

	* gtk/gtknotebook.h:
	* gtk/gtknotebook.c:
	added a flag have_visible_child to indicate whether we need to draw
	non child related portions at all, e.g. shadows etc.
	(gtk_notebook_draw): if have_visible_child changed, do a full paint
	instead of updating a small area only.

Mon Jan 11 20:44:35 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkstyle.c: changed gtk_style_apply_default_pixmap to
	gtk_style_apply_default_background which takes an extra argument
	copy_area to determine NO_WINDOW widget pixmap copying.
	changed callers accordingly.

	* gtk/gtktogglebutton.c:
	(gtk_toggle_size_allocate): 
	(gtk_toggle_button_expose): 
	(gtk_toggle_button_paint): avoid messing with our parent's window if
	toggle_button->draw_indicator == TRUE and we are a NO_WINDOW widget.

	* gtk/gtkcheckbutton.c (gtk_real_check_button_draw_indicator): draw
	the draw_indicator with GTK_STATE_ACTIVE if the toggle button is active.

	* gtk/check-n.xpm:
	* gtk/check-y.xpm:
	* gtk/testgtkrc: set pixmaps for ACTIVE and NORMAL check button
	bg_pixmaps.

Mon Jan 11 23:52:58 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtklist.c (gtk_list_signal_drag_begin)
	(gtk_list_drag_begin): end drag selections if necessary.

	* gtk/gtkspinbutton.c/h (gtk_spin_button_update): made function
	public. Manually force synchronization of spin button text and
 	adjustment value.

Mon Jan 11 15:23:32 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtktogglebutton.c: eliminated some queue_draws when invoking
	gtk_widget_set_state, since that cares about redrawing already.
	some code cleanups.

	* gtk/gtktogglebutton.[hc]:
	* gtk/gtkfontsel.c:
	* gtkgamma.c:
	s/gtk_toggle_button_set_state/gtk_toggle_button_set_active/ since
	set_state is already taken by gtkwidget.h.

	* gtk/gtkcompat.h: #define gtk_toggle_button_set_state
        gtk_toggle_button_set_active.
        
        * gtk/gtkstyle.c: some indentation cleanups.

Mon Jan 11 15:12:33 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtktogglebutton.c (gtk_toggle_button_set_mode): take previous
	visibility state into account when unrealizing.

Mon Jan 11 10:45:28 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c: Only remove handlers for motion/button_release
	at drop, remove "selection_get" handler later.

Mon Jan 11 13:31:49 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtktypeutils.[hc]: removed Paolo Molaro's type creation hooks
	again, since they 1) don't care about infinite recursion (likely
	to achive), 2) we are in feature freeze for 1.2. this definitely
	deserves a sane implementation in 1.3 though (but without a hook
	return value, without seq_id hackery and with recursion checks).

Mon Jan 11 13:18:37 1999  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c:
	(gtk_window_key_release_event): 
	(gtk_window_key_press_event): only pass key events to the focus widget
	if it is sensitive.

	* gtk/gtkmenuitem.c (gtk_menu_item_select_timeout): don't popup the
	submenu if it isn't sensitive.
	(gtk_menu_item_paint): state_type doesn't need to be reset to
	GTK_STATE_INSENSITIVE if the widget is insensitive anyways.

	* gtk/gtkcontainer.c (gtk_container_real_focus): 
	* gtk/gtklist.c (gtk_list_focus): 
	* gtk/gtkmenushell.c (gtk_menu_shell_move_selected): 
	* gtk/gtknotebook.c (gtk_notebook_focus): 
	s/GTK_WIDGET_SENSITIVE/GTK_WIDGET_IS_SENSITIVE/ since a widgets
	sensitivity is determined through the parent as well,
	GTK_WIDGET_SENSITIVE is only of interest inside gtkwidget.c, everywhere
	else GTK_WIDGET_IS_SENSITIVE (widget) needs to be used to check for
	sensitivity.

	* gtk/gtkaccelgroup.c (gtk_accel_group_activate): don't activate
	object if it is an insensitive widget.

Mon, 11 Jan 1999 08:09:08 +0100 Paolo Molaro <lupus@debian.org>

	* gtk/gtktypeutils.[ch]: add gtk_type_{add,remove}_creation_hook().
	You can have a notification when a type is created.

1999-01-11  Tim Janik  <timj@gtk.org>

	* gtk/gtkmain.c (gtk_propagate_event): added an assertement.

Sun Jan 10 14:45:37 1999  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtktext.c (text_properties_equal): Fixed
	cut and paste bug when comparing text property
	bg colors.
	[ Matt Aubury <Matt.Aubury@comlab.ox.ac.uk> ]

1999-01-10  Tim Janik  <timj@gtk.org>

	* gtk/gtksignal.c (gtk_signal_lookup): if the lookup failed, try
	to initialize the object class and reattempt the lookup, reported
	by Paolo Molaro <lupus@lettere.unipd.it>.

Sat Jan  9 17:36:20 1999  Owen Taylor  <otaylor@redhat.com>

	* configure.in (ALL_LINGUAS): Added cs to ALL_LINGUAS.

Sat Jan  9 17:27:49 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkfilesel.c (gtk_file_selection_populate):
	Mark another string for internationalization.
	[ Stanislav Brabec <utx@k332.feld.cvut.cz> ]

Sat Jan  9 14:02:08 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktooltips.c (gtk_tooltips_force_window): Set
	name "gtk-tooltips" on tip window so that a style
	can be set for tooltips.

Fri Jan  8 19:00:17 1999  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c (gdk_window_cache_filter): Fixed
	some list-manipulation breakage.

	* gdk/gdkdnd.c (gdk_window_cache_destroy): Free 
	window cache structure.

	* gtk/gtkdnd.c (gtk_drag_set_icon_pixmap): Set an
	event mask on the drag window so clicking on it
	doesn't pop up root menus, etc.

	* gtk/gtkdnd.c (gtk_drag_button_release_cb): Remove
	signal handlers at button release.

Fri Jan  8 00:42:00 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkspinbutton.c (gtk_spin_button_get_value_as_int)
	(gtk_spin_button_get_value_as_float): call gtk_spin_button_update
	before returning a value

	* gtk/gtkclist.c (gtk_clist_motion): don't allow 'drag selections'
	if clist is a drag source.
	(gtk_clist_drag_begin): remove pointer grabs, end ongoing selections.

	* gtk/gtkctree.c (remove_grab): copy of clist function.
	(gtk_ctree_drag_begin): let clists drag_begin method set the
	source info struct.

Thu Jan  7 19:10:21 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkviewport.c (gtk_viewport_style_set): Fixes
	to drawing the background of the bin window 
	so that clearing and redrawing of child
	widgets work properly.

	* gtk/gtkwidget.c (gtk_widget_idle_draw): Juggle around
	data so that if somebody triggers more redraw queuing
	from a expose_event handler, it doesn't confuse the
	heck out of GTK+. (But is highly liable to cause 
	an infinite loop...)

Thu Jan  7 12:31:41 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkselection.c (gtk_target_list_unref): Fix some
	more memory leaks.

Wed Jan  6 23:14:19 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (gtk_ctree_drag_motion): fix for dnd bug reported
	by Bertrand Guiheneuf. Don't return FALSE if source widget != dest.
	widget.

Wed Jan 06 10:04:12 1999  Tristan Tarrant  <ttarrant@etnoteam.it>

	* configure.in,po/it.po: added Italian translations

Tue Jan 05 21:18:00 1999  George Lebl  <jirka@5z.com>

	* gtk/gtkmenu.c,gtk/gtkmenuitem.c,gtk/gtkeditable.c: free the
	  event that was returned to us by gtk_get_current_event

Tue Jan  5 19:01:18 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcolorsel.c (gtk_color_selection_dialog_init): Push
	GdkRGB's visual and colormap around the color selection
	dialog so that the window and the previews have the
	same colormap. If an app adds things to the colorsel
	dialog, it will have to take care of them itself.

Tue Jan  5 15:03:47 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c (gtk_propagate_event): Make 
	gtk_propagate_event() non-static, we need it in gtkdnd.c 
	so that the button-release we synthesize gets propagated
	correctly.

	* gtk/gtkdnd.c: Use gtk_propagate_event() so
	release gets to a GtkList. But we can't really
	get this right without access to the windows
	event masks and doing X-style propagation ourselves.

Tue Jan  5 12:40:57 1999  Owen Taylor  <otaylor@redhat.com>

        * gtk/gtkpreview.c: Add a size_allocate() routine 
	and set the size of the preview window equal
	to the area we are going to draw on, instead 
	of the entire allocation. Do this to avoid having 
	to set a parent-relative background.
	
Tue Jan  5 11:51:32 1999  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_draw_cursor_on_drawable):
	When redrawing the under-cursor character, don't
	redraw the terminating NULL.
	[ From: dov@imagic.weizmann.ac.il (Dov Grobgeld) ]

Tue Jan  5 11:31:55 1999  Owen Taylor  <otaylor@redhat.com>
	 
	* gtk/gtkselection.c (gtk_target_list_unref): Free
	memory allocated for target lists.

	* gtk/gtkdnd.c (gtk_drag_drop_finished): Release
	selections before destroying info structure.

	* gdk/gdkdnd.c gdktypes.h (gdk_drag_get_protocol): Add
	new value GDK_DRAG_PROTO_NONE, use it for non-drag
	targets, to quiet Purify.

	* gdk/gdkdnd.c (gdk_window_register_dnd): Set size
	of property properly.

Mon Jan  4 03:45:42 CST 1999 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.12

	* INSTALL:
	  NEWS:
	  README:
	  configure.in:
	  gtk+.spec:
	  docs/gtk-config.1:
	  gtk/gtkfeatures.h.in: version=1.1.12

1999-01-04  Sung-Hyun Nam  <namsh@lgic.co.kr>

	* configure.in (ALL_LINGUAS): Added 'ko'.

Sun Jan  3 17:41:22 1999  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (real_tree_expand): fixed auto_resize bug

Sat Jan  2 03:54:30 1999  Tim Janik  <timj@gtk.org>

	* gdk/gdk.h (GDK_PRIORITY_EVENTS): make this G_PRIORITY_DEFAULT.

	* gdk/gdkevents.c (gdk_events_init): add the source and the poll fd with
 	a priority of GDK_PRIORITY_EVENTS.

1999-01-02  Jeff Garzik  <jgarzik@pobox.com>

	* configure.in, config.h.in, gdk/gdkimage.c:
	Removed features.h test.

	* gdk/gdkdnd.c:
	Guard public functions against NULL pointer derefs.

Fri Jan  1 18:41:09 PST 1999 Manish Singh <yosh@gimp.org>

	* gdk/gdk.c
	* gdk/gdkinputnone.h
	* gtk/gtkruler.c: casts to get rid of const warnings

	* gtk/Makefile.am: fix gtktypebuiltins.h dependencies, and do a
	cmp so people don't whine about rebuilds

	* gtk/gtknotebook.c: use g_snprintf on translated strings, so we
	don't get buffer overflows

	* gtk/gtkrc.c: use g_strdup_printf instead of g_malloc/sprintf
	Plug some memleaks.

1999-01-01  Jeff Garzik  <jgarzik@pobox.com>

	* configure.in, config.h.in:
	Check for features.h.

	* gdk/gdkevents.c (gdk_event_put, gdk_events_queue):
	Fixed bug in linked list append logic by replacing hand-coded
	logic with a call to g_list_append.  Bug found by tml.

	* gdk/gdkimage.c:
	'gcc -ansi -pedantic' on GNU/Linux spews warnings and errors
	in sys/ipc.h, including one specific admonishment to use
	_SVID_SOURCE or _XOPEN_SOURCE.	Manually defined the latter, and
	included features.h if present to obtain the necessary
	side-effects.

	* gtk/gtkclist.c, gtk/gtkeditable.c:
	Eliminates comma-after-final-element warnings.

	* gtk/gtkfontsel.c (gtk_font_selection_init):
	Fixed bug where an intl string was declared as _("x") in
	local var initializer.

1998-12-31  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtklabel.c (gtk_label_split_text_wrapped):
	word->space is now initialized correctly.
	Reported by Chi-Deok Hwang <cdhwang@sr.hei.co.kr>.

1998-12-30  Miguel de Icaza  <miguel@nuclecu.unam.mx>

	* gtk/gtkmain.c (gtk_main_do_event): Fix memory leak.
	gdk_event_put would make a copy of next_event, and next_event was
	not being freed.

Wed Dec 30 18:39:21 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.11

	* INSTALL:
	  NEWS:
	  README:
	  configure.in:
	  gtk+.spec:
	  docs/gtk-config.1:
	  gtk/gtkfeatures.h.in: version=1.1.11
	
1998-12-29  Owen Taylor  <otaylor@srv-19-29.roc.ny.frontiernet.net>

	* gdk/gdkim.c (gdk_wcstombs): Fixed off-by-one
	error when computing length.

Thu Dec 24 14:35:48 1998  Jeff Garzik  <jgarzik@pobox.com>

	* gdk/gdkevents.c, gdk/gdkim.c, gdk/gdkrgb.c, gdk/gdkwindow.c,
	  gtk/gtkprogressbar.c:
	Pull in string.h for various mem*() and str*() functions,
	in an autoconf-friendly way.

Thu Dec 24 12:40:45 1998  Jeff Garzik  <jgarzik@pobox.com>

	* gdk/gdkfont.c: removed unused var
	* gdk/gdkim.c: 64-bit cast
	* gtk/gtkaccelgroup.c: point to const data
	* gtk/gtkdnd.[ch]: (gtk_drag_dest_set, gtk_drag_source_set):
	  Made const-correct.
	* gtk/gtkfontsel.c: kill uninitialized var warning
	* gtk/gtkselection.[ch]: (gtk_target_list_new,
	  gtk_target_list_add_table, gtk_selection_add_targets):
	  Made const-correct.
	* gtk/testgtk.c: 64-bit cast

Thu Dec 24 03:16:52 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* INSTALL:
	  NEWS:
	  README:
	  configure.in:
	  gtk+.spec:
	  docs/gtk-config.1:
	  gtk/gtkfeatures.h.in: version=1.1.10

Wed Dec 23 20:31:40 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c: Fix problem where empty labels were 
	getting a requisition height of zero, and trailing 
	newlines were being ignored.

Wed Dec 23 13:58:14 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_parse_uline):
	label->label should be the mb text _after_ removing
	the underlines, not before.

	* gtk/gtkmenu.c: Reverted Elliot's tearoff-menu-item
	title hack. If it deserves being done, it deserves
	being done right.
	
1998-12-23  Elliot Lee  <sopwith@redhat.com>

	* gtk/gtkmenu.c: Allow programmer to gtk_object_set_data(obj,
 	"GtkTearoffMenuItem_window_title", ..) on a GtkMenuItem and have
 	it be recognized. If we're getting the title out of the GtkLabel,
 	then remove all underscores.

Tue Dec 22 17:01:43 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_dest_handle_event): 
	Request XmTRANFER_FAILURE on Motif drops not within
	a drop zone. I don't know why this is necessary,
	but it is.

	* gdk/gdkdnd.c (gdk_drop_reply): Fixed error where
	Motif flag field in response was getting wrong
	values.

Tue Dec 22 15:55:39 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_button_press): 
	Return TRUE for button press events we handle.
	(Allows option menus in radio buttons to work...)

Tue Dec 22 14:50:25 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_find_widget): Optimization -
	when we've already found a widget, skip all checks
	for subsequent children.

	* gtk/gtkdnd.c (gtk_drag_find_widget): Checked for
	!MAPPED, not !VISIBLE, since a widget (like a notebook
	page), can be VISIBLE, but !REALIZED or !MAPPED.

	* gtk/gtkdnd.c (gtk_drag_find_widget): Use forall(),
	not foreach().

Mon Dec 21 22:01:49 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_motion): fixed column resize bug

Sun Dec 20 04:48:59 1998  Tim Janik  <timj@gtk.org>

	* gdk/gdk.h (GDK_PRIORITY_EVENTS): export the priority at which
	events are processed.

	* gtk/gtk[main|signal|container].[ch]: removed deprecated _interp
	variants: gtk_container_foreach_interp, gtk_idle_add_interp,
 	gtk_timeout_add_interp, gtk_signal_connect_interp.

Sat Dec 19 18:45:30 PST 1998 Shawn T. Amundson <amundson@gtk.org>

	* configure.in: added sv to ALL_LIGNUAS

Sat Dec 19 22:49:40 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtktypeutils.c (gtk_type_query): eek, fixed an embarrasing bug
	that caused this function to always return NULL (noticed by marius
 	vollmer).

Sat Dec 19 17:28:30 1998  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Don't add the gthread libs to 
	GLIB_LIBS either, or -lgthread -lpthread will get 
	pulled into all applications because of shlib deps.

	* gtk/gtkmain.h gtk/gtkwidget.c gtk/gtk gdk/gdk: 
	Use GLIB's priority #define. Revise scale of 
	priorities.

Sat Dec 19 03:44:29 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkmain.c: always run a g_main_iteration, even if
	there are no active main loops. This fixes the gimp splash
	screen.

Sat Dec 19 05:37:51 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtklabel.c (gtk_label_expose): removed return_if_fail
 	(label->words != NULL) since that's a valid case when the label
 	is empty, or just default constructed.
	fixed indentation prototype arguments and braces in some places.
	also, pointer comparisions and initializations are done with NULL
	not 0, there's a reason GLib defines NULL.

	* gdk/gdkevents.c (gdk_events_pending): return (queued_events ||
 	putback_events) so this again returns whether events are pending,
	not whether other sources like idles are pending.

	* gtk/gtkmain.c (gtk_main_iteration_do): 
	(gtk_main_iteration): return whether the loop is done, not whether
	something got dispatch to restore the original behaviour (yosh: this
 	fixes code like in GleSelector).

Fri Dec 18 19:20:45 PST 1998 Manish Singh <yosh@gimp.org>

	* gtkbutton.[ch]
	* gtktogglebutton.c: s/(enter|leave)_button/$1/g, since pthreads.h
	no longer conflicts
	
Sat Dec 19 01:56:13 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_button_press): fixed GDK_2BUTTON_PRESS
 	bug.

Fri Dec 18 15:30:43 PST 1998 Manish Singh <yosh@gimp.org>

	* configure.in: add ja to ALL_LINGUAS

Fri Dec 18 15:19:54 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (gtk_socket_filter_func): Marked
	plug window as destroyed before destroying the 
	window.

Fri Dec 18 14:17:14 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenu.c (gtk_menu_popup): Set the usize on the
	tearoff window so when we reparent the window out,
	the window doesn't shrink down.

1998-12-18  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>

	* configure.in: do not export the glib flags for thread support to
	gtk-config.

Fri Dec 18 01:32:59 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkmain.c (gtk_main): added gdk_flush() after g_main_run(), so we
 	get the original behaviour back, i.e. the event queue needs to be flushed
	after a main loop has been quitted.
	(gtk_main): add/remove the current main loop to/from the main loop
 	before/after init/quit functions have been exected to preserve the
 	original gtk_main_quit() behaviour.

Thu Dec 17 23:48:29 1998  Tim Janik  <timj@gtk.org>

	* gdk/gdkevents.c (gdk_events_init): changed argument order in call
	to g_main_add_poll() to match recent glib changes.

Thu Dec 17 20:33:28 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk-config.in: Add @INTLLIBS@. 
	gtk-scier-981116-0.patch  Sean Cier <scier@PostHorizon.com>) ]

	* gtk/gtkcolorsel.c gtk/gtkfilesel.c gtk/gtkfontsel.c
	  gtk/gtkgamma.c gtk/gtkinputdialog.c 
	  gtk/gtknotebook.c gtk/gtkrc.c gtk/gtkthemes.c
	  gtk/gtktipsquery.c: 
	
	Applied parts of gtk-egger-981215-1 [ Daniel Egger
	<Daniel.Egger@t-online.de> ] marking additional strings for
	internationalization.
	
	* po/nl.po: Added Dutch translation from 
	Paul Siegmann <pauls@euronet.nl>.
	
Thu Dec 17 18:25:52 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_drop_finished): Remove the
	info tag from the context so if the source unexpectedly
	responds in the future, we do nothing properly.

Thu Dec 17 18:24:41 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk[hv]paned.c (gtk_[hv]paned_size_allocate): Handle
	the case where one side of the the pane is empty.

	* gtk/gtkfilesel.c (gtk_file_selection_init): Set
	dir_title before using it. (Pointed out by
	Lavoie Philippe <lavoie@zeus.genie.uottawa.ca>)
	
Thu Dec 17 10:53:20 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_set_text): Free 
	previous label->label_wc.

	* gtk/testgtkrc: Leave font, not fontset commented
	in by default.

1998-12-17  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>

	* gdk/gdkim.c: Define gdk_use_mb outside USE_XIM guard. Removed
	unnecessary USE_XIM guard inside another. Made gdk_use_mb
	static. Compile gdk_set_locale also if not USE_XIM.	

Thu Dec 17 00:26:01 1998 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.9

	* INSTALL:
	  NEWS:
	  README:
	  configure.in:
	  gtk+.spec:
	  gtk/gtkfeatures.h.in:
	  docs/gtk-config.1: version=1.1.9

Wed Dec 16 21:20:00 PST 1998 Manish Singh <yosh@gimp.org>

	* autogen.sh: rm -rf intl breaks --disable-nls, put it back

	* gtkbutton.[ch]
	* gtktogglebutton.c: s/(enter|leave)/$1_button/g.
	Digital: 1 GTK+: 0 (for now)

Wed Dec 16 22:38:22 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* gdk/gdkevents.c: updated call to g_main_add_poll
          instead of g_main_poll_add

Wed Dec 16 23:32:05 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_expose): Remove 
	unnecessary cast.

Wed Dec 16 22:50:52 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c gdk/gdkim.c: Check for broken glibc 2.0 
	mb functions, and avoid them.

Wed Dec 16 16:57:55 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c (gdk_events_queue): Don't
	call XPending() if we have putback events.

Wed Dec 16 16:04:41 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.c (gtk_label_expose): Do nothing
	on empty string, quietly.

Wed Dec 16 15:36:19 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c (gtk_entry_draw_cursor_on_drawable):
	Redraw the character under the cursor when removing
	the cursor.

Wed Dec 16 13:06:17 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.[ch] gtk/gtkmain.[ch] gtk/gtkprivate.h: Move main
	thread lock back to GDK - we need it there for locking
	when translating events. Rename things appropriately.

Wed Dec 16 11:44:21 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrange.c (gtk_range_expose): Fix a x/y typo.

Wed Dec 16 10:20:27 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.8

	* ChangeLog:
	  INSTALL:
	  README:
	  gtk+.spec:
	  docs/gtk-config.1: version=1.1.8

1998-12-16  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>

	* gdk/gdkglobals.c: Define gdk_xim_ic only, if USE_XIM is defined.

Wed Dec 16 07:03:32 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.h: 
	* gtk/gtkwidget.c: s/USER_DRAW/APP_PAINTABLE/. provided
	gtk_widget_set_app_paintable() which users can use to make
	a widget paintable for the application. changed other files accordingly.

Wed Dec 16 05:26:32 1998  Tim Janik  <timj@gtk.org>

        * configure.in: version bump to 1.1.8, binary age 0, interface age 0,
	depend on GLib 1.1.8.

	* gdk/gdkprivate.h:
	* gdk/gdkglobals.c: removed last Gdk threads specific bits.

	* gtk/gtkmain.c (gtk_init): s/g_thread_supported/g_thread_supported()/.

	* gtk/gtkprivate.h: changed GTK_THREADS_ENTER and GTK_THREADS_LEAVE
	to function macros GTK_THREADS_ENTER() and GTK_THREADS_LEAVE().
	honour G_THREADS_ENABLED in the definition of GTK_THREADS_ENTER()
 	and GTK_THREADS_LEAVE(). changed callers accordingly.

Tue Dec 15 21:26:26 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* autogen.sh: warn if glib.m4 or gettext.m4 are not found 
          in aclocal's directory.

Tue Dec 15 21:36:14 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/testgtk.c (create_layout): Create buttons,
	not combos again.

1998-12-15  Joel Becker  <jlbec@ocala.cs.miami.edu>

	* autogen.sh: reordered gettextize and aclocal, because
	gettextize was messing up aclocal.m4.

Tue Dec 15 22:30:44 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.h : 
	removed clist flag : GTK_CLIST_DRAG_SELECTION
	added flags : GTK_CLIST_REORDERABLE, GTK_CLIST_USE_DRAG_ICONS,
	GTK_CLIST_DRAW_DRAG_LINE, GTK_CLIST_DRAW_DRAG_RECT
	(GtkCListDragPos) : new enum for DND
 	(GtkButtonAction) : new enum of possible mouse button actions
	(struct _GtkCList): added button_actions array.
 	Added drag_button and click_cell struct, to store cell and
 	mouse button of last button_press_event
	
	(struct _GtkCListClass): new class method draw_drag_highlight.
	(gtk_clist_set_reorderable) (gtk_clist_set_use_drag_icons) :
	new functions. Moved from gtkctree.h. Now clist is reorderable
	as well.
	(gtk_clist_set_button_actions) new function to customize mouse
	button actions.

	* gtk/gtkclist.c:
	(gtk_clist_drag_begin)
	(gtk_clist_drag_motion)
	(gtk_clist_drag_leave)
	(gtk_clist_drag_end)
	(gtk_clist_drag_drop)
	(gtk_clist_drag_data_get)
	(gtk_clist_drag_data_received) : new dnd widget methods to
	implement clists reorderability via DND

	(remove_grab) : new function. remove mouse grab if necessary.
	(draw_drag_highlight) : new method. Draw dnd highlight depending
	on clist flags GTK_CLIST_DRAW_DRAG_LINE and GTK_CLIST_DRAW_DRAG_RECT

	(gtk_clist_class_init): added object args "reorderable" and
 	"use_drag_icons"

	(gtk_clist_button_press) (gtk_clist_button_release) :
	use button_actions array to decide which action to perform.
	(gtk_clist_motion) : start reorder operation if necessary.

	* gtk/gtkctree.h :
	(struct _GtkCTree): removed drag_icon, icon_widht, icon_height,
	drag_row, drag_source, drag_target, reorderable, use_icons,
	in_drag, drag_rect
	(gtk_ctree_set_reorderable) :  deprecated function.
 	use gtk_clist_set_reorderable instead.
	(gtk_ctree_set_use_drag_icons) : deprecated function.
 	use gtk_clist_set_use_drag_icons instead.

	* gtk/gtkctree.c :
	(gtk_ctree_class_init): removed object args "reorderable" and
	and "use_drag_icons"

	(draw_xor_line) (draw_xor_rect) (create_drag_icon) (check_cursor)
	(tree_toggle_selection) (set_mouse_cursor) : removed
	
	(draw_drag_highlight) : new clist method. replacement for
	draw_xor_line and draw_xor_rect functions
	(check_drag) renamed check_cursor function

	(gtk_ctree_drag_begin)
	(gtk_ctree_drag_motion)
	(gtk_ctree_drag_data_received) : new dnd methods to implement ctrees
	reorderability via DND

	(gtk_ctree_button_release)
	(gtk_ctree_button_motion) : removed.

	* gtk/testgtk.c:
	(create_clist) : added new reorderable toggle button
 	
Tue Dec 15 19:50:41 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkctree.c gtk/gtkclist.c gtk/testgtk.c: Use 
	base[NORMAL] instead of bg[PRELIGHT] so CLists now can be
	used in detergent commercials.

Tue Dec 15 16:54:09 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklabel.h: Moved gtk_label_set() compatiblity
	define from <gtkcompat.h> to <gtklabel.h> for
	compatibility.

1998-12-15  Jeff Garzik  <jgarzik@pobox.com>

	* configure.in, gdk/Makefile.am, gtk/Makefile.am:
	Removed last remaining thread-related configure bits 
	that have been moved into GLib.

1998-12-15  Elliot Lee  <sopwith@bogus.cuc.ml.org>

	* gdk/gdkevents.c: Use G_IO_ERR|G_IO_HUP|G_IO_NVAL
	as the mask for checking for GDK_INPUT_EXCEPTION events.

1998-12-15  Martin Baulig  <martin@home-of-linux.org>

	* acinclude.m4: Make the gettext check for for libc5 systems.

	* autogen.sh: Not running gettextize fails on a fresh CVS checkout
	and we'll get a lot of bug reports tomorrow, so I add it back.

	* acinclude.m4: Rename AM_GNU_GETTEXT_GTK to AM_GTK_GNU_GETTEXT and
	AM_WITH_NLS_GTK to AM_GTK_WITH_NLS to avoid this ugly automake
	warnings.

Tue Dec 15 16:06:15 1998  Owen Taylor  <otaylor@redhat.com>

	* acinclude.m4: Provide a hacked version of the
	  gettext macros that never use the included gettext.
	 
	* Makefile.am configure.in: Remove references
	  to intl/
	
	* autogen.sh: Don't run gettextize.

Tue Dec 15 14:30:35 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.h gdk/gdkfonts.c: Added gdk_text_extents_wc()

        * Patch from Jonathan Blanford <jrb@redhat.com> to add line wrapping
	  to label. (Based on patch from Jeff Dairiki
	  <dairiki@mac-ceope.apl.washington.edu> gtk-dairiki-971208-0)

	- Adds new function gtk_label_set_line_wrap()
	- implement GTK_JUSTIFY_FILL.
	- rename gtk_label_set to gtk_label_set_text() add
	   gtk_label_set() to gtkcompat.h.

	* Use an internal wc representation in the label, so
	  that we handle underlining and line breaks correctly
	  for multi-byte strings.

Tue Dec 15 13:32:28 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.h: Added GTK_USER_DRAW flag.

	* gtk/gtkwindow.c: Honor GTK_USER_DRAW flag.

	* gtk/gtkdrawwindow.c gtk/Makefile.am: Removed 
	GtkDrawWindow, which GTK_USER_DRAW obsoletes.

Tue Dec 15 11:37:05 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmain.c: Fixed up some warnings.

Tue Dec 15 10:32:01 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtk{h,v,}paned.{c,h}: Add new functions 
	gtk_paned_set_position(),
	gtk_paned_pack1/2(). The latter take a
	shrink and resize parameters, that allows setting
	minimum sizes and getting 'relative' resizing.

Tue Dec 15 10:26:23 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c: Keep separate putback_events and 
	queued_events queues so that we get both FIFO and 
	preemptive behavior for	gdk_event_put().

Tue Dec 15 09:22:44 1998  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtkrc.c (gtk_rc_init): Removed unused 
	variable, fixed minor memory leak.

	* gdk/gdk.c: Fixed another merge problem.

Tue Dec 15 08:53:38 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c (gdk_get_display): Remove gdk_signal,
	which crept back in in last commit.

Tue Dec 15 01:38:53 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am: Commented out testthreads from
	the build process, since we won't have any idea
	how to create a thread.

	* configure.in (LIBS): use glib-config ... gthread
	so we always build a thread-compatible library.

        * gtk/gtkaccellabel.c gtk/gtkclist.c gtk/gtkcolorsel.c
	  gtk/gtkcombo.c gtk/gtkcontainer.c gtk/gtkentry.c
	  gtk/gtklist.c gtk/gtkmenuitem.c gtk/gtknotebook.c
	  gtk/gtkrange.c gtk/gtkselection.c gtk/gtkspinbutton.c
	  gtk/gtktext.c gtk/gtktooltips.c gtk/gtkwidget.c:
	
	Add GTK_THREADS_ENTER/LEAVE pairs around timeouts
	and idles to account for the fact that they are no
	longer called within the GTK+ lock.

	* gtk/gtkprivate.h: Added definitions for locking
	the main GTK+ mutex.
	
	* gtk/gtkmain.c: Re-implement the main loop 
	in terms of the GLib main loop.

	* gdk/gdk.h gdk/gdkthreads.c gdk/Makefile.am: Removed threading 
	functionality, as it seems better to subsume GDK within the 
	GTK+ lock than vice-versa.

        * gdk/gdkevents.c: New file, containing event handling bits 
	from gdk.c.

	* gdk/gdkevents.c: Implement event source for GDK
	events.
	
	* configure.in gdk/gdkevents.c: Removed attempts to 
	subtract base_id, which were already non-functional.

Mon Dec 14 23:05:20 PST 1998 Manish Singh <yosh@gimp.org>

	* acconfig.h
	* configure.in: removed IPC_RMID_DEFERRED_RELEASE check

	* gdk/gdk.c: remove signal handlers, since we do an IPC_RMID
	after XShmAttach, and nobody complained

Tue Dec 15 02:27:42 MET 1998 Sven Neumann <sven@gimp.org>

	* po/de.po: Replaced the crappy german po-file with a valid one.

Mon Dec 14 16:10:05 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_init): Append locale-specific
	suffixes to default rc file names, and look these
	up in addition to the base filename, to facilitate
	having the correct fontset per-locale.

	move $(sysconfdir)/gtkrc to $(sysconfdir)/gtk/gtkrc

	* gtk/gtkitemfactory.[ch] (gtk_item_factory_set_translate_func):
	New function to set a function to translate menu paths.

	* gtk/gtkrc.c (gtk_rc_add_initial_default_files): Free
	results of g_strsplit().

1998-12-14  Nuno Ferreira  <nmrf@rnl.ist.utl.pt>

	* configure.in (ALL_LINGUAS): Added 'pt'.

	* po/pt.po: Added Portuguese translation.

Mon Dec 14 20:04:31 1998  Stefan Jeske  <stefan@gtk.org>

	* gtk/gtkspinbutton.c: Only call gtk_spin_button_update if
 	the spinbutton is editable.

Mon Dec 14 12:24:13 1998  Owen Taylor  <otaylor@redhat.com>

	* HACKING: Added gettext-10.35

	* autogen.sh: Run gettextize.

Wed Dec  9 16:29:06 1998  Owen Taylor  <otaylor@redhat.com>

        Applied gtk-egger-981010-[12] 
	[ Daniel.Egger@t-online.de (Daniel Egger) ]

	* gtk/gtkintl.h: New file - defines for localization.

	* gtk/gtkfilesel.c gtk/gtkinputdialog.c: Mark strings
	for internationalization.

	* gtk/gtkmain.c: call bindtextdomain

	* po/ - directory for translations. Initially includes
	German translation.

Mon Dec 14 02:42:11 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c: made GtkWidget::grab_focus a RUN_LAST and
	RUN_ACTION signal. moved stuff from gtk_widget_grab_focus() into
	gtk_widget_real_grab_focus() so a signal is always emitted
	if the focus is grabbed on a widget.

Mon Dec 14 02:13:01 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenuitem.c: fixed submenu popup timeouts, we decide whether or
	not to delay the submenu popup from a menu item deselection time stamp.
	the code looks even more hackish than before, but in practice "feels"
	very well.

1998-12-13  Federico Mena Quintero  <federico@nuclecu.unam.mx>

	* gtk/gtkwidget.h (struct _GtkWidgetClass): Added a "grab_focus"
	signal for widgets.  When the signal is emitted, the widget will
	grab the focus.  This is needed to let the user press an
	accelerator key in a dialog box and have the corresponding widget
	be focused.

	* gtk/gtkwidget.c (gtk_widget_class_init): Create the "grab_focus"
	signal.  The default handler is simply gtk_widget_grab_focus().

Sun Dec 13 22:15:48 GMT 1998  Tony Gale  <gale@gtk.org>

	* docs/gtk_tut.sgml: Update the following sections to the
	  current API:
	    - Container Widgets
	    - CList Widget
	    - List Widget
	    - Tree Widget

Sat Dec 12 19:11:35 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkmenuitem.c: made GtkMenuItem::activate a GTK_RUN_ACTION signal.

	* gtk/gtkbutton.c: made GtkButton::clicked a GTK_RUN_ACTION signal.

	* gtk/gtkfeatures.h.in: define GTK_HAVE_FEATURES_1_1_8.

Sat Dec 12 17:46:55 1998  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtklayout.c (gtk_layout_unrealize): Mark
	child->window as destroyed so we don't destroy
	it again.

Sat Dec 12 17:18:32 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkfont.c (gdk_text_extents): Corrections
	to computation of extents of text from a font set.
	(from Chi-Deok Hwang <cdhwang@sr.hei.co.kr>)
         and Akira Higuchi <a-higuti@math.sci.hokudai.ac.jp>)
	
Fri Dec 11 08:59:12 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklistitem.c (gtk_list_item_style_set):
	* gtk/gtklist.c     (gtk_list_style_set):
	Added "style_set" handlers.

Fri Dec 11 05:49:30 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (gtk_clist_style_set): Add in a "style_set"
	handler so that the background of the clist changes
	with the theme.

Thu Dec 10 22:02:49 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.7

	* INSTALL:
	  NEWS:
	  README:
	  configure.in:
	  gtk+.spec:
	  gtk/gtkfeatures.h.in: 
	  docs/gtk-config.1: Version to 1.1.7

Thu Dec 10 20:48:19 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkclist.c: avoid void pointer math

	* gtk/gtkhscale.c
	* gtk/gtkhscrollbar.c
	* gtk/gtkvscale.c
	* gtk/gtkvscrollbar.c: removed trailing , from enums

	* gtk/gtksignal.c: can't use enums as a bitfield type, use guint

	* gtk/testgtk.c: removed C++ comment added by owenpoo

Thu Dec 10 21:48:34 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.[ch]: Added gtk_drag_source_unset()

Thu Dec 10 20:42:22 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_dest_handle_event): Use 
	gdk_window_get_origin() instead of gdk_window_get_position,
	because get_position is unreliable for plugs. 

	This is a bad hack, maybe we need GDK_WINDOW_PLUG?

Thu Dec 10 17:58:49 GMT 1998  Tony Gale  <gale@gtk.org>

	* docs/gtk_tut.sgml:
	  - re-write the GtkProgressBar section to the 1.1 API.
	  - add an Appendix listing all the signals
	    (apologies to TimJ for taking so long in using his hard work
	     in automating the extraction - thanx Tim). 
	* examples/*: bring them all upto the tutorial versions

Thu Dec 10 02:21:16 1998  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/testdnd.c: use g_snprintf, eliminate need for string.h
	* gtk/testrgb.c: include string.h, for strlen

Wed Dec  9 17:39:26 1998  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Add a case for success in 
	test for XUnregisterIMInstantiate, to prevent
	screwing up $LIBS.

Wed Dec  9 13:06:31 1998  Sebastian Wilhelmi  <wilhelmi@ira.uka.de>
 
 	* gdk/gdkim.c (gdk_ic_new,gdk_ic_{set,get}_attr): Fixed argument
 	list and return type for non-XIM fallback.
 
 	* configure.in: Only build XIM-support if available.
 
Wed Dec  9 12:23:30 1998  Owen Taylor  <otaylor@redhat.com>
	
	* gtk/testselection.c (main): Add in missing 'flags'
	field to target list.

	* gdk/gdkproperty.c (gdk_atom_intern): Actually
	add the atoms to the local cache.

Wed Dec  9 04:57:31 PST 1998 Manish Singh <yosh@gimp.org>

	* gdk/gdkprivate.h: put text after #endif in comment

	* gdk/gdktypes.h: change whitespace in enum to shut up makeenums.pl

	* gtk/testdnd.c: #include <string.h>

Mon Dec  7 10:27:09 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c: Destroy widgets _after_ propagating unrealize
	signals through the widget heirarchy. This is unpleasant, as it
	causes more X traffic, but is necessary, because we have to clean
	up our Input Contexts before destroying the X windows.
	(from matsu-981109-0.patch)
	
Mon Dec  7 10:18:18 1998  Owen Taylor  <otaylor@redhat.com>

	Applied gtk-a-higuti-981202-0 : 
	[ a-higuti@math.sci.hokudai.ac.jp (Akira Higuchi) ]
	
	* gdk/gdk.h gdk/gdk.c
		(gdk_mbstowcs): New function. Nearly equals to mbstowcs, but
			implemented by a combination of Xlib functions, so
			it works even with X_LOCALE.
		(gdk_wcstombs): New function.
		(g_mbtowc): Removed. No longer needed.

	* gdk/gdk.h gdk/gdkfont.c gdk/gdkdraw.c: 
	        Added _wc() variants to gdk_text_width(), 
		gdk_char_width(), gdk_draw_text(),
		
	* gdk/gdki18n.h
		(mblen, mbtowc, wctomb, mbstowcs, wcstombs,
		 wcslen, wcscpy, wcsncpy):
			Removed. No longer needed.
		(iswalnum): Removed.
		(gdk_iswalnum): New macro.
		(gdk_iswspace): New macro.
	* gdk/gdktype.h
		(GdkWChar): New typedef.
	
	* gtk/gtkentry.h, gtk/gtkentry.c
		There are many changes according to the change of the
		internal representation of text, from multibyte string
		to wide characters. 
	* gtk/gtkprivate.h, gtk/gtkmain.c
		Removed the variable gtk_use_mb and related codes.
	* gtk/gtkspinbutton.c
		Some changes according to the change of type of entry->text.
	* gtk/gtktext.h, gtk/gtktext.c
		Changed the internal representation of text. We use GdkWchar
		if a fontset is supplied. If not, we use guchar to save
		memory.
	
Tue Dec  1 15:20:39 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_new): When creating
	a window with a specified non-system visual, use
	a matching colormap.

Mon Nov 30 11:50:13 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c gdk/gdkim.c gdk/gdkprivate.h gdk/gdk.h
	  gdk/gdktypes.h gtk/gtkeditable.c gtk/gtkmain.c
	  gtk/gtkentry.c gtk/gtktext.c:

	 Applied matsu-981109-0
	 [ matsu@arch.comp.kyutech.ac.jp (Takashi Matsuda) ]
	
	 - Change system of setting input method values 
	   from varargs to a structure, similar to GC's
	   or window attributes.

	 - Various fixes to event handling.

	 Also:

	 * gdk/gdkim.c: Split of input method stuff into
	   a separate source file.

	 * Remove GdkIM typedef, change everything from
	   GdkIC to GdkIC * to be consistent with the
	   rest of GTK.
	
Wed Dec  9 00:41:41 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_add_initial_default_files): Allocate
	correct amount of memory for strings.

Tue Dec  8 18:29:05 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.6

	* NEWS: updated

        * gtk/Makefile.am:
          gtk/testgtk.c:
          gtk/gtkrc.h:
          gtk/gtkrc.c: Read in default files.

Wed Dec  9 00:49:12 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtktypeutils.h:
	* gtk/gtktypeutils.c: added gtk_type_query() which returns a newly
	allocated structure holding certain type specific informations.
	fixed the big bunch of `discards const' warnings with the
 	initialization of enum/flags values.

Tue Dec  8 15:10:17 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_transient_parent_realized):
	Fixed order of arguments to gdk_window_transient_for().

Tue Dec  8 18:02:57 GMT 1998  Tony Gale  <gale@gtk.org>

	* examples/Makefile: simple top level Makefile that invokes all
	  the sub-directory Makefiles.

1998-12-08  Andrew T. Veliath  <andrewtv@usa.net>

	* gtk/testgtk.c: Functions to test the toolbar space style.

	* gtk/gtktoolbar.c: Add a private GtkToolbarChildSpace subclass of
	GtkToolbarChild to hold allocation. Set default space style to
	GTK_TOOLBAR_SPACE_EMPTY, define SPACE_LINE_* for separator
	fraction defaults.
	(gtk_toolbar_paint_space_line): New function; paints the separator
	line, using "toolbar" as the detail.
	(gtk_toolbar_expose): (gtk_toolbar_draw): Handle CHILD_SPACE when
	style is set to SPACE_LINE.
	(gtk_toolbar_size_allocate): Store space allocations.
	(gtk_toolbar_insert_element): If we are a space, allocate and
	initialize a GtkToolbarChildSpace instead of a GtkToolbarChild.
	(gtk_toolbar_set_space_style): New function.

	* gtk/gtktoolbar.h: Add GtkToolbarSpaceStyle, with styles of EMPTY
	and LINE. Add prototype for gtk_toolbar_set_space_style.

Mon Dec  7 16:03:55 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkthemes.h: Remove random unnecessary includes
	of standard headers.

1998-12-07  Damon Chaplin  <DAChaplin@msn.com>

	* gtk/gtkfontsel.c (gtk_font_selection_select_best_style): made sure
	we only try to match styles which are currently shown.

	(gtk_font_selection_init): set the notebook tabs homogeneous and set
	the border, so we don't need to set the size explicitly (bad for i18n).
	Used the clist auto-resize feature for the font and style lists on the
	main page and all the filters. Used padding for the 'Reset Filter'
	button instead of spaces around it (bad for i18n).

	(gtk_font_selection_find_font): when searching for
	a font, if we can't match both the family and foundry, we return any
	font where just	the family matches. (The foundry can even be '*'.)

	(gtk_font_selection_show_available_styles): 
	(gtk_font_selection_realize_list): don't set the style clist row
	colours (for the charset rows) until the clist is realized, since we
	use the clist style's insensitive colours.

Mon Dec  7 13:38:06 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkimage.c (gdk_image_new): Use IPC_RMID
	_after_ doing XShmAttach. This should work everywhere,
	and avoid the need for signal handlers or configure
	checks.

Thu Dec  3 19:58:45 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkinputdialog.c: Use _add_with_viewport() for
	scrolled window contents.

1998-12-07  Federico Mena Quintero  <federico@nuclecu.unam.mx>

	* gtk/gtkpaned.h (struct _GtkPaned): Removed the unused cursor
	field in the structure.

Mon Dec  7 15:15:06 GMT 1998  Tony Gale <gale@gtk.org>

	* docs/gtk_tut.sgml: Start mass update for GTK 1.1
        * examples/extract.sh: Look for the best version of awk
        * examples/extract.awk: Fix FD leak
        * example/base: minimal example from Tutorial

Mon Dec  7 01:29:27 1998  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtkwindow.c: New functions
        gtk_window_set_transient_for() - set up a "transient for" relationship.
	gtk_window_set_default_size() - set the initial size of a window
	   distinct from its minimum size.
	gtk_window_set_geometry_hints() - Allow the user to set
	   minimum, maximum sizes, aspect rations, and gridded geometry, 
	   possibly all with respect to a subwidget of the window.
	These interfaces are still a wee bit experimental.

	* gdk/gdk.c: Added gdk_window_set_transient_for(),
	gdk_window_set_geometry_hints(), and gdk_window_set_role().

	* gdk/gdktypes.h: Added new types for find-grained specification
	of WM hints.

	* gtk/testgtk.c: Various changes to tests to test the
	above new functions.

	* gtk/gtkfontsel.c: Squash a few 'const' warnings.
	
	* gtk/gtktogglebutton.c (gtk_toggle_button_realize): Restored
	call to gtk_style_set_background() to prevent egregious
	flashing to black.

Mon Dec  7 03:52:01 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtksignal.c (gtk_handlers_run): when marshalling connect_object
	signals, don't pass the data pointer twice, but swap it with the
	object pointer (proposed on Nov 30 1998 on gtk-devel-list).

Mon Dec  7 03:08:39 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtktypeutils.h: 
	* gtk/gtktypeutils.c: reverted Marius's change to expose the type systems
	internal type info data to the user. if such functionality is required
	we should provide wrapping accessors, ala gtk_signal_query(). also the
	GtkTypeInfo structures are dynamically allocated memory portions, so
	only the type system is really allowed to access that stuff.

	* gtk/gtksignal.c (gtk_signal_connect_by_type): reverted marius change,
	since it destroys the possibility to implement automatic marshaller
	lookups some day, and it also disables third party code's ability to
	connect to any signal.

Mon Dec  7 01:32:18 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkfilesel.c (gtk_file_selection_key_press): always intercept the
	Tab key on the entry. the focus shouldn't get lost even if completion
	is attempted from an empty entry, since an empty entry string does
	indeed have a valid completion meaning (complete all).
	(gtk_file_selection_init): cast the gchar array parameter in calls to
	gtk_clist_new_with_titles() to quit compiler warnings.
	(check_dir): the no_stat_dirs struct must not be const, since we do
	indeed modify its contents.

	* gtk/testgtk.c (event_watcher): adapted prototype to fit new emission
	hook semantics.

	* gtk/gtksignal.h:
	* gtk/gtksignal.c:
	changed emission allocation, so we don't use a doubly linked list
	but link ourselfs (singly linked).
	changed emission hooks, they get the emision parameters passed as
	well now and are emitted during the actuall signal emission (after
	the RUN_FIRST class method, but prior to RUN_FIRST handlers).
	the existing restrictions do still apply to signal emission hooks,
 	i.e. an emission may not be stopped or restarted from an emission hook.
	due to possibly huge perfomance impacts, frequent use of emision hooks
	is also not recommended.
 	(gtk_signal_next_and_invalidate): added an
 	assertments which explicits what the code assumes anyways: a
	maximum amount of 65535 signals.

	* gtk/gtkcontainer.h: deprecated gtk_container_foreach_interp(),
	gtk_container_foreach_full() should be used instead.

	* gtk/gtkmain.h:
	deprecated gtk_timeout_add_interp and gtk_idle_add_interp, since
	we provide _full variants.

	* gtk/gtksignal.h: deprecated gtk_signal_connect_interp(), we provide
	gtk_signal_connect_full() for long enough now.

1998-12-06  Marius Vollmer  <mvo@zagadka.ping.de>

	* gtk/gtksignal.c (gtk_signal_newv): Allow a NULL marshaller.
	(gtk_signal_connect_by_type): Allow only no_marshal handlers to
	connect to signals with a NULL marshaller.

	* gtk/gtktypeutils.c (gtk_type_get_info): New.
	gtk/gtktypeutils.h (gtk_type_get_info): New prototype.

Sun Dec  6 14:27:35 1998  Stefan Jeske  <stefan@gtk.org>

	* gtk/gtkspinbutton.c (gtk_spin_button_draw_arrow): Grey out
	arrows if wrap == FALSE and interval borders are reached.

Sat Dec  5 21:07:09 1998  Owen Taylor  <otaylor@gtk.org>

	* gtk/gtkaspectframe.c (gtk_aspect_frame_size_allocate): Fixed
	long-standing typo in aspect ratio computation code.
	(pointed out by Sebastian Rittau <srittau@jroger.in-berlin.de>)

Fri Dec  4 01:20:06 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (gtk_clist_button_release): call toggle_row with
	valid row numbers only
	(toggle_row): check if clist_row != NULL

Fri Dec  4 00:50:12 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (gtk_ctree_export_to_gnode): fixed for-loop.

	* gtk/gtkclist.c 
	(gtk_clist_set_column_visibility)
	(gtk_clist_column_titles_active)
 	(gtk_clist_column_titles_active)
	(gtk_clist_column_title_passive)
 	(gtk_clist_column_title_active): few additional tests whether
 	column->button != NULL

Thu Dec  3 16:49:18 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (DROP_ABORT_TIME): Changed to 5 min
	from 10 seconds, so it doesn't abort while users
	have an ACTION_ASK menu up.

	* gtk/gtkdnd.c: Hide the icon window between sending a a 
	drop event to the destination and displaying the
	snapback animation, so that it doesn't hang around
	during ACTION_ASK.

Thu Dec  3 16:37:42 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkclist.c (get_cell_style): Use GTK_STATE_INSENSITIVE
	for the foreground of cells for CLists in the insensitive
	state, instead of GTK_STATE_PRELIGHT.

Thu Dec  3 06:20:59 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkwindow.c: moved checks upon focus setting from
 	gtk_window_real_set_focus to gtk_window_set_focus, so we don't
	emit the signal if unneccessary.

	* gtk/gtkwidget.c (gtk_widget_grab_focus): clear up the old focus
	containers when grabbing focus on a new widget. this is based on
	a patch from Alexis Mikhailov, submitted to gtk-list on 4 Nov 1998.

	* gtk/gtkclist.c (gtk_clist_focus_out): set CLIST_CHILD_HAS_FOCUS
	flag, so we take the buttons into consideration upon the next focus
	request.

	* gtk/gtkcontainer.c (gtk_container_set_focus_child): fixed an
 	assertment.

Wed Dec  2 17:45:21 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* gtk/gtkpixmap.c: Fixes for low-color displays and a slight
	  enhancement for true-color displays.

	* INSTALL:
	  README:
	  configure.in:
	  gtk+.spec:
	  docs/gtk-config.1: up to version 1.1.6

Wed Dec  2 01:36:49 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkfeatures.h.in: lets #define GTK_HAVE_FEATURES_1_1_6 before
	we release it this time

Wed Dec  2 01:39:02 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtknotebook.h: 
	* gtk/gtknotebook.c: s/gtk_notebook_nth_page/gtk_notebook_get_nth_page/.

	* incremented version number to 1.1.6 and made Gtk
 	dependant on GLib 1.1.6.

	* gtk/gtkwidget.h (struct _GtkRequisition): changed width and height
 	from guint16 to gint16, since sizes bigger than 32767 are not supported
 	anyways, and aritmethics with intermediate negative values are possible
 	now.

Tue Dec  1 00:00:04 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkscrolledwindow.c:
	implementation of GTK_POLICY_NEVER functionality, added rationales
	on the policy and size requisition handling at the top.
	(gtk_scrolled_window_size_request):
	we assume a default minimum for our child's width and height
	if [hv]scrollbar_policy != GTK_POLICY_NEVER, except when the user
	specified the dimension explicitely.
 	(gtk_scrolled_window_size_allocate): 
	do not show scrollbars if [hv]scrollbar_policy == GTK_POLICY_NEVER.

	* gtk/gtkviewport.c (gtk_viewport_size_request): report the real
	size we require (including the child).

        * gtk/gtkclist.c:
	(gtk_clist_size_request): report the real size required.

	* gtk/gtkenums.h (enum GtkPolicyType): added GTK_POLICY_NEVER.

	* gtk/gtkobject.c (gtk_object_init_type): object_type doesn't
	need to be a static variable.

Mon Nov 30 22:41:25 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkclist.h: 
	* gtk/gtkclist.c: 
	* gtk/gtkviewport.h:
	* gtk/gtkviewport.c:
	* gtk/gtktext.h:
	* gtk/gtktext.c:
	* gtk/gtklayout.h:
	* gtk/gtklayout.c:
	* gtk/gtkwidget.h:
	* gtk/gtkwidget.c:
	* gtk/gtkscrolledwindow.h:
	* gtk/gtkscrolledwindow.c:
	s/scroll_adjustements/scroll_adjustments/
	s/scroll_adjustments/set_scroll_adjustments/g

Tue Dec  1 22:45:58 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.h (struct _GtkCListClass): new class method/signal
	row_move.
	* gtk/gtkclist.c (gtk_clist_row_move): new public function.
	emit a row_move signal
	(real_row_move): move source_row to dest_row
	(gtk_clist_swap_rows): use gtk_clist_row_move calls.
	(gtk_clist_columns_autosize): resize all columns to their optimal
	width
	* gtk/gtkctree.c (real_row_move): use gtk_ctree_move to move
	entire sub-tree.
	* gtk/gtknotebook.c (gtk_notebook_nth_page): get nth page widget.

Tue Dec  1 02:40:22 PST 1998 Manish Singh <yosh@gimp.org>

	* configure.in
	* gdk/Makefile.am
	* gtk/Makefile.am: Put -DFOO stuff into Makefile.am INCLUDES.
	Separate vars for each, for granularity.

Tue Dec  1 02:19:54 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkenums.h: fixed a stupid error of mine about the run type
	values.

1998-11-30  Elliot Lee  <sopwith@cuc.ml.org>

	* {gdk,gtk}/*.c: Make read-only data structures "static const" to
	allow them to be shared, mainly including (but not limited to) the
	GtkTypeInfo structures for each class.

	* gtk/gtkfilesel.c: Add /net to the "leave me alone" directory listing.

Mon Nov 30 12:17:10 1998  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtksignal.c:
	Surround debug variable with #ifdef to silence gcc.

	* gtk/gtknotebook.c (gtk_notebook_reorder_child):
	Added initializer to quiet gcc warning.
	Added assertion to check for null pointer deref.

Mon Nov 30 10:11:29 1998  Tim Janik  <timj@gtk.org>

	* gtk/testgtkrc: merged testgtkrc with the pre-themes one, removed
 	system specific includes.

	* gtk/gtksignal.c: asured that stop and restart emissions are also
 	checked and processed for not connected objects. fixed up restart
	emission administration. invoke emission hooks after emission, hooks
	are not supposed to muck around with the current emission, and
	may also not cause emission restarts. fixed up stop emission
	administration.

Mon Nov 30 06:20:36 1998  Tim Janik  <timj@gtk.org>

	* gtk/testgtk.c: added an event watcher for enter/leave based on
	signal emission hooks.

	* gtk/gtkobject.c (gtk_object_class_init): made GtkObject::destroy a
	GTK_RUN_NO_HOOKS signal.

	* gtk/gtksignal.h: 
	* gtk/gtksignal.c: implemented emission hooks, new hooks can be added
	to a signal with gtk_signal_add_emission_hook or
	gtk_signal_add_emission_hook_full, and can be removed again with
	gtk_signal_remove_emission_hook.

	* gtk/gtkenums.h: remove GTK_RUN_MASK, since it doesn't represent
	an appropriate mask for signal runtypes for a long time now.
	added GTK_RUN_NO_HOOKS value, which is used to flag signals
	that do not allow the running of signal hooks.

1998-11-26  Michael Krause  <m.krause@tu-harburg.de>

        * gtk/gtknotebook.c (gtk_notebook_switch_page): made 'page_num'
        argument a gint: switch_page signal delivers valid page numbers
        again.

Sun Nov 29 06:12:01 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_set_[hv]adjustment): 
	set composite names.

	* gtk/gtktypeutils.c (gtk_type_unique): removed default initialization
	check, people must use gtk_type_init().
	fixed up type allocation for foreign fundamentals.

	* gtk/gtkwidget.h: 
	* gtk/gtkwidget.c: added gtk_widget_set_composite_name() which is meant
	for internal use by containers, that want to assign specific composite
	names to their composite children.
	added gtk_widget_get_composite_name() which will return a newly
 	allocated string, containing the composite name of a widget. valid
	composite names can only be retrived from widgets that have a parent
	assigned and are flagged as GTK_COMPOSITE_CHILD.

	* gtk/gtkcontainer.h:
	* gtk/gtkcontainer.c: added a new function
 	gtk_container_child_default_composite_name() which will return a
	newly allocated string, holding the composite name of a containers
	child. a default implementation is provided which will compose the
	composite name out of the widgets type and its sequential children
 	id. this implementation can be overidden through a new class function
	*(composite_name)().

Sat Nov 28 10:57:59 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_expose_event): Removed bogus
	expose_event handler - we had two expose_event
	handlers!

Sat Nov 28 03:13:42 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkscrolledwindow.h: 
	* gtk/gtkscrolledwindow.c: changed scrolled window inheritance,
	it inherits from GtkBin now.

	* gtk/gtkbin.c (gtk_bin_unmap): removed superfluous check for
	visibility of child.
	(gtk_bin_draw): removed superfluous check for GTK_WIDGET_DRAWABLE().
	added check so a child gets only drawn if it's visible.

	* gtk/gtkwidget.h: 
	* gtk/gtkwidget.c: removed gtk_widget_draw_children().

	* gtk/gtkstyle.h: 
	* gtk/gtkstyle.c: rmoved gtk_reset_widget_shapes.

	* gtk/gtkwidget.h: 
	* gtk/gtkwidget.c: removed crufty relict: gtk_widget_is_child().
	added internal function gtk_widget_reset_shapes() from gtkstyle.c.

	* gtk/gtkrc.h:
	* gtk/gtkrc.c: (gtk_rc_find_pixmap_in_path): removed bogus gscanner
	argument, changed callers.

	* gtk/gtkmenufactory.c: GtkMenuFactory is deprecated for a long time,
	it will issue a warning now.

	* gtk/gtkcompat.h: new file to #define aliases for historic
 	function names.

	* changed 8 function names for consistency and provided aliases to keep
	source compatibility in gtkcompat.h:
	(gtk_accel_label_get_accel_width): renamed from gtk_accel_label_accelerator_width
	(gtk_container_set_border_width): renamed from gtk_container_border_width
	(gtk_notebook_get_current_page): renamed from gtk_notebook_current_page
	(gtk_packer_configure): renamed from gtk_packer_set_child_packing
	(gtk_paned_set_gutter_size): renamed from gtk_paned_gutter_size
	(gtk_paned_set_handle_size): renamed from gtk_paned_handle_size
	(gtk_scale_get_value_width): renamed from gtk_scale_value_width
	(gtk_window_set_position): renamed from gtk_window_position

	* renamed a few recently added funtions for consistency:
	(gtk_notebook_get_tab_label): renamed from gtk_notebook_query_tab_label.
	(gtk_notebook_get_menu_label): renamed from gtk_notebook_query_menu_label.
        (gtk_progress_configure): renamed from gtk_progress_reconfigure.

Fri Nov 27 18:57:20 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_add_with_viewport):
	check for existing viewport first, and don't add one if there
	already is one

Sat Nov 28 00:06:49 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.h: 
	* gtk/gtkwidget.c: deprecated gtk_widget_freeze_accelerators and
	gtk_widget_thaw_accelerators, we provide gtk_widget_lock_accelerators
	and gtk_widget_unlock_accelerators.

	* gtk/gtklayout.h:
	* gtk/gtklayout.c: implemented incremental freezing facility.

	* gtk/gtktext.h: 
	* gtk/gtktext.c: implemented incremental freezing facility.

	* gtk/gtkenums.h:
	* gtk/gtkaccelgroup.h: moved enum GtkAccelFlags into this place.

	* gtk/gtkentry.h:
	* gtk/gtkentry.c:
 	deprecated gtk_entry_adjust_scroll().
 	
 	* random GtkType, macro and indentation fixes.

Fri Nov 27 22:50:15 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkclist.h: 
	* gtk/gtkclist.c: implemented incremental freezing facility, added
	a new class member (*refresh)() which takes over the thaw
 	functionality. the clist FROZEN flag got removed on the way.
	* gtk/gtkctree.c: adaptions to feature the clist refresh functionality
	and incremental freezing.

	* gtk/gtkcalendar.c: implemented incremental freezing facility.

Fri Nov 27 11:41:27 1998  Raph Levien  <raph@gimp.org>

	* gdk/gdkinputcommon.h (gdk_input_common_init): Fixed it so that
	it still includes the core pointer in gdk_input_devices even
	if the XInput extension is not present in the X server.

Fri Nov 27 12:17:15 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.[ch] (gtk_drag_get_source_widget): New function to
	get the source widget of a drag.

	* gtk/gtkdnd.[ch]: Target flags GTK_TARGET_SAME_[WIDGET/APP]
	to restrict certain targets to the same widget or to
	the same application.

	* gtk/testdnd.c: Test gtk_drag_get_source_widget().
	
Thu Nov 26 19:11:46 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtk-boxed.defs (GtkCTreeNode): define GtkCTreeNode as boxed type
	* gtk/gtkctree.c (gtk_ctree_class_init): use GTK_CTREE_NODE_TYPE
	instead of GTK_TYPE_POINTER in signal definitions.
	(patch from James Henstridge <james@daa.com.au>)

Thu Nov 26 18:48:44 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (set_cell_contents)
	* gtk/gtkctree.c (set_cell_contents): call column_auto_resize only
 	if auto.resize == TRUE

	* gtk/gtknotebook.c (gtk_notebook_set_shape) (gtk_notebook_expose):
 	don't draw tab, if show_tabs == FALSE
 	(bug reports from Alexis Mikhailov / Dave Cole)
 	(gtk_notebook_focus_changed) (gtk_notebook_draw_focus): draw only
 	the focus rectangle, not the hole tab.

Thu Nov 26 03:18:08 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkclist.h: 
	* gtk/gtkctree.h: 
	* gtk/gtkclist.c:
	* gtk/gtkctree.c: reverted bogus and undocumented!!! changes from
	Jay Cox (98/11/23 13:53:26) which `const' qualified char* arrays.

	* gtk/maketypes.awk: changed underline substitution, so we get
	GTK_TYPE_CTREE_POS instead of the broken GTK_TYPE_C_TREE_POS.
	* gtk/makeenums.pl: likewise.
	* gtk/gtkctree.c: adapted type names accordingly.

Tue Nov 24 11:31:06 1998  Owen Taylor  <otaylor@redhat.com>

	* docs/Changes-1.2.txt: Edited section on the ScrolledWindow.

	* gtk/gtklayout.c (gtk_layout_set_[hv]adjustment): Remove
	some code duplication.

	* gtk/gtklayout.[ch] Fixed mapping and unmapping of child windows
	and child widgets when scrolling greater than 32k pixels.

	* testgtk.c: Modified layout test to test scrolling over 
	long distances.

	* gtk/gtkplug.c: Added a few blank lines.

Tue Nov 24 11:11:05 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtklayout.[ch]: Fixed up copyright message.

	* gdk/gdkrgb.c (DM): Make the dither matrix constant
	so it can be shared.

	* gtk/gtkdnd.c: Make cursor bitmaps const.

	* gdk/gdk.h gdk/gdkpixmap.c: Added const to 
	gdk_pixmap/bitmap_create_from_data.

Tue Nov 24 07:46:09 1998  Tim Janik  <timj@gtk.org>

	* docs/Changes-1.2.txt: added a section on scrolled windows and
	scrollable widgets.

1998-11-24  Andrew T. Veliath  <andrewtv@usa.net>

	* gtk/gtktoolbar.c (gtk_toolbar_insert_element): Include radio
	buttons when setting relief for button items.
	(gtk_toolbar_set_button_relief): Same.

1998-11-23  Jeff Garzik  <jgarzik@pobox.com>

	* gdk/Makefile.am, gtk/Makefile.am:
	Removed DEFS "+=" mess that breaks recent automakes.
	INCLUDES is the correct way to add to CFLAGS from Makefile.am.

	* gdk/gdk.c, gdk/gdkglobals.c, gdk/gdkimage.c, gdk/gdkinput.c,
	gdk/gdkpixmap.c, gdk/gdkthreads.c, gdk/gdkwindow.c,
	gdk/gxid_lib.c, gtk/fnmatch.c, gtk/gtkclist.c, gtk/gtkmain.c,
	gtk/testthreads.c:
	Include "config.h" instead of "../config.h".
	Now that DEFS works again, automake will automatically pass us
	the location of config.h in -I.

Mon Nov 23 22:10:09 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am gtk/gtk.h gtk/gtklayout.[ch]
	gtk/gtkplug.[ch] gtk/gtksocket.[ch] gtk/gtk.h:

	Added layout widget for scrolling arbitrarily big areas.
	Added plug/socket widgets for interprocess embedding.

	These widgets still, at some point, need to be
	made more pure in their use of GDK, as opposed
	to raw X.

	* gtk/testgtk.c: Added test for layout widget.
	
1998-11-23  Jeff Garzik  <jgarzik@pobox.com>

	* gtk/gtkclist.c: (gtk_clist_swap_rows):  Bugfix from
	Brandon Long <blong@fiction.net> - do the right thing with first
	and last, which are the absolute values of row arguments row1
	and row2.

Mon Nov 23 04:24:55 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkprogress.c: (gtk_progress_set_adjustment): make a saner
	default adjustment (from 0 to 100) instead. I'm not sure if this
	is the correct level for the fix, but gtk_progress_bar_new()'s
	original default behavior is restored.

1998-11-23  Martin Baulig  <martin@home-of-linux.org>

	* gtk/gtkfeatures.h.in (GTK_HAVE_FEATURES_1_1_5): Define this so
	we can check for latest GTK features.

1998-11-23  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktoolbar.c: (gtk_toolbar_set_relief):
	(gtk_toolbar_insert_element): When setting relief, also affect
	toggle buttons.

Sun Nov 22 20:37:06 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkobject.h: remove extraneous comma

Mon Nov 23 05:21:50 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkcontainer.c:
 	(gtk_container_add_with_args): 
	(gtk_container_addv): 
	(gtk_container_add): removed assertements for constructed containers
	again, since this essentially breaks the "child" arg.

	* gtk/gtktooltips.c (gtk_tooltips_force_window): fixup the draw_window
	reference count, we don't need to reference toplevels that already have
	destroy notifiers.

	* gtk/gtkscrolledwindow.c: check for the composites existance in
	_forall since we might not be already constructed.

Sun Nov 22 14:34:58 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* Released GTK+ 1.1.5

	* configure.in: require GLib 1.1.5

Mon Nov 23 03:21:17 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtktext.c (gtk_text_destroy): disconnect hadj & vadj, not
	2 * hadj.
	(gtk_text_finalize): only unref the current_font if we have
	been realized.

Sat Nov 21 18:41:13 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* configure.in:
	  INSTALL:
	  NEWS:
	  README:
	  gtk+.spec:
	  docs/gtk-config.1: Version incremented to 1.1.5

Sun Nov 22 16:21:28 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkprogress.c: added args ::show_text, ::text_xalign,
 	::text_yalign, ::activity_mode.

	* gtk/gtkprogressbar.c: added construct arg ::adjustment. added args
 	::bar_style, ::orientation, ::discrete_blocks, ::activity_step,
 	::activity_blocks.
	(gtk_progress_bar_new):
	(gtk_progress_bar_new_with_adjustment): use gtk_widget_new().
	(gtk_progress_bar_construct): deprecated.

	* gtk/gtkvscrollbar.c:
	(gtk_vscrollbar_draw_step_back): 
	(gtk_vscrollbar_draw_step_forw): use "vscrollbar" as detail for
 	gtk_paint_arrow, to be consistent with hscrollbar.

	* gtk/gtktext.c
	added construct args ::hadjustment, ::vadjustment.
	added args ::line_wrap, ::word_wrap.
	(gtk_text_class_init): added scroll_adjustments signal.
	(gtk_text_new): use gtk_widget_new.
	(gtk_text_disconnect): remove adjustement with gtk_text_set_adjustments,
	so we don't screw the reference counts and don't leave signals connected.
 	(gtk_text_destroy): disconnect adjustments signals.
 	(gtk_text_finalize): unref adjustments.

	* gtk/gtkctree.c: added construct args ::n_columns and ::tree_column.
	added args ::indent, ::spacing, ::show_stub, ::reorderable,
 	::use_drag_icons, ::line_style and ::expander_style.
	(gtk_ctree_set_show_stub): renamed from gtk_ctree_show_stub, which is
	deprecated now.

	* gtk/gtkclist.h: remove GTK_CLIST_CONSTRUCT flag.
	* gtk/gtkclist.c:
 	removed ::vadjustment and ::hadjustment args, introduced
 	::scroll_adjustments signal.
	added ::shadow_type, ::selection_mode and ::row_height args.
	added n_columns construct arg.
	(gtk_clist_construct): call gtk_object_constructed().
 	(gtk_clist_set_row_height): if height is passed as 0,
	revert to automatic height calculation.
	(gtk_clist_destroy): before unrefing the adjustments, disconnect our
	signal handlers.

Fri Nov 21 22:34:58 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkwidget.c (gtk_widget_new): call gtk_object_default_construct
	like gtk_object_new.
	(gtk_widget_destroy): assert that we only destroy constructed widgets.

	* gtk/gtkobject.h (enum GtkArgFlags): new flag GTK_ARG_CONSTRUCT_ONLY
	to identify args that may only be used for construction.
	GTK_ARG_CONSTRUCT maybe used as normal arguments besides construction
	time.
	* gtk/gtkobject.c (gtk_object_new): invoke gtk_object_default_construct
	at the end if the object is not fully constructed.
	(gtk_object_newv): likewise.
	(gtk_object_destroy): assert that we only destroy constructed objects.
 	(gtk_object_init): setup GTK_CONSTRUCTED from the
	objects real klass.
	(gtk_object_default_construct): new function to complete default
	construction of an object by applying missing construtor args with
	default values of 0, 0.0 or NULL.
	(gtk_object_constructed): new function to mark an object as being
	constructed (used from within constructors).

	* gtk/gtkarg.c (gtk_arg_type_new_static): return the args info pointer
	so it is immediatedly available for the caller.

	* gtk/gtktypeutils.c (gtk_type_new): pass an object's real class to
	the object initilizer (GtkObjectInitFunc takes a second arg now, the
 	real klass), and asure that object initializers may temporarily alter
	the class pointer.

Fri Nov 20 08:00:30 1998  Tim Janik  <timj@gtk.org>

	* gtk/testgtk.c: change all occourances of gtk_container_add (
	scrolled_window, widget) to gtk_scrolled_window_add_with_viewport (...)
	for widget!=(clist, ctree, text, viewport).

	* gtk/gtkcombo.c:
 	(gtk_combo_init): use gtk_scrolled_window_add_with_viewport()
	to add children to the scrolled window.

	* gtk/gtkscrolledwindow.h:
	* gtk/gtkscrolledwindow.c:
	changed scrolled_window->viewport to scrolled_window->child, and use
	gtk_widget_scroll_adjustements() to set the scroll adjustments for the
	widget, we do not create an additional viewport anymore.
	added ::hadjustment and ::vadjustment constructor args.
 	(gtk_scrolled_window_new): use gtk_widget_new() to create the widget.
	(gtk_scrolled_window_set_hadjustment):
	(gtk_scrolled_window_set_vadjustment): new functions that superceed
	gtk_scrolled_window_construct.
	(gtk_scrolled_window_construct): deprecated this function.
	
	* gtk/gtkhscrollbar.c:
	* gtk/gtkvscrollbar.c:
	* gtk/gtkhscale.c:
	* gtk/gtkvscale.c:
	support a constructor arg "::adjustment", and use gtk_widget_new() for
	the widget creation.

	* gtk/gtkrange.c: added ::update_policy arg.
 	(gtk_range_set_adjustment): if adjustment is passed in as NULL, create
 	a default adjustment so this function can be used for derived widgets
 	that depend on the adjustment's existance.
	(gtk_range_destroy): disconnect the adjustment signal, so we don't
	get called after we got destroyed, we don't destroy the adjustment
	in here, because it might have been provided from another widget.

	* gtk/gtkviewport.c: introduced ::scroll_adjustments signal.
	(gtk_viewport_destroy): same as gtk_range_destroy.

	* gtk/gtkprogress.c (gtk_progress_destroy): same as gtk_range_destroy.

	* gtk/gtkwidget.h: 
	* gtk/gtkwidget.c: changed gtk_widget_activate() to return a
	gboolean, indicating whether this widget supports activation.
	added gtk_widget_scroll_adjustements() to set the scrolling
	adjustments of a widget.

Wed Nov 19 01:22:42 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkoptionmenu.c:
 	(gtk_option_menu_remove_contents):
	(gtk_option_menu_update_contents): removed
 	gtk_container_[un]block_resize() pairs.

	* gtk/gtknotebook.h: 
	* gtk/gtknotebook.c: removed the tab_border field, since it shouldn't
	be used outside of gtknotebook.c anyways. made ARG_TAB_BORDER a
	wrtie-only argument.

	* *.c: made deprecated functions issue a message:
	gtk_clist_set_border, gtk_container_block_resize,
 	gtk_container_unblock_resize, gtk_container_need_resize,
 	gtk_object_class_add_user_signal, gtk_spin_button_construct,
	gtk_scrolled_window_construct.
	removed non-functional functions:
	gtk_container_disable_resize, gtk_container_enable_resize,
	gtk_clist_set_policy.

Wed Nov 18 22:54:36 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtkbox.c (gtk_box_init): 
	* gtk/gtkdrawingarea.c (gtk_drawing_area_init): 
	* gtk/gtkeventbox.c (gtk_event_box_init): 
	* gtk/gtkfixed.c (gtk_fixed_init): 
	* gtk/gtkframe.c (gtk_frame_init): 
	* gtk/gtkhandlebox.c (gtk_handle_box_init): 
	* gtk/gtkpacker.c (gtk_packer_init): 
	* gtk/gtkmisc.c (gtk_misc_init): 
	* gtk/gtkpreview.c (gtk_preview_init): 
	* gtk/gtkprogress.c (gtk_progress_init): 
	* gtk/gtkprogressbar.c (gtk_progress_bar_init): 
	* gtk/gtkseparator.c (gtk_separator_init): 
	* gtk/gtktable.c (gtk_table_init): 
	* gtk/gtkviewport.c (gtk_viewport_init): 
	* gtk/gtkalignment.c (gtk_alignment_init): 
	removed setting of the GTK_BASIC flag.

	* gtk/gtkwidget.h:
	* gtk/gtkwidget.c:
	removed GTK_BASIC, GTK_WIDGET_BASIC and	gtk_widget_basic.

	* miscellaneous GtkType and macro fixups.

Sat Nov 21 18:53:13 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_get_deskrelative_origin): 
	Fixed so it at least works with window managers other
	than Enlightenment, though it probably needs to be
	removed altogether.

1998-11-21  Andrew T. Veliath  <andrewtv@usa.net>

	* gtk/gtkhandlebox.[ch]: Add shadow_type and
	gtk_handle_box_set_shadow_type function (plus a
	GtkHandleBox::shadow arg) to allow configuration of shadow in the
	bin window.

Thu Nov 19 23:47:38 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* gtk/gtkcalendar.c: Fix for marking days from 
	  Dan Reish <dreish@izzy.net>.

Thu Nov 19 00:15:27 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkctree.c (gtk_ctree_node_nth): return the nth GtkCTreeNode
	in row_list. (from Samuel Solon <ssolon@usa.net>)
	
	* gtk/gtkclist.c (gtk_clist_get_column_title): return column title
	(gtk_clist_get_column_widget): return column widget

Wed Nov 18 11:54:57 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_find_widget): Accept drops
	that are sent to a toplevel but are not within the
	toplevels bounds.

	* gdk/gdkdnd.c gdk/gdk.h: Added support for a
	XdndProxy atom which proxies the drag to another window.

1998-11-17  Federico Mena Quintero  <federico@nuclecu.unam.mx>

	* gtk/gtkpaned.h (struct _GtkPaned): Removed the cursor field, now
	that it is not needed.

Tue Nov 17 1998 The Rasterman <raster@redhat.com>
	* gdk/gdk.h, gdk/gdkwindow.c: Added gdk_window_get_deskrelative_origin
	  function to correctly determine gdk window position relative to
	  its "root window" - contains check for an Enlightenment
	  virtual root window.
	* gtk/gtkhandlebox.c: changed gdk_window_get_origin ->
	  gdk_window_get_deskrelative_origin to get the origin of dragged
	  handleboxes correctly. Now it works correctly with E.
	  
Tue Nov 17 1998  Tuomas Lukka <lukka@iki.fi>

	* gtk/gtktypeutils.c: Fix vital bug where LOOKUP was used when
 	  getting types even though we were not using real type names,
	  just the index.  This caused random crashes when more than 
	  256 types were defined.

1998-11-17  Martin Baulig  <martin@home-of-linux.org>

	* gtk/genmarshal.pl: Put output files in the current directory
	and not in the $(srcdir) since the VPATH is ignored for built
	sources.

Tue Nov 17 01:37:53 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/genmarshal.pl
	* gtk/Makefile.am: check for unchanged autogenerated files, so
	we don't rebuild everything just for adding a new function

Mon Nov 16 19:19:00 CST 1998 Shawn T. Amundson <amundson@gtk.org>

	* gtk/gtkpixmap.h
	  gtk/gtkpixmap.c: Pixmaps now grey out when insensitive,
	  code thanks to GNOME stock by Eckehard Berns.  New function
	  gtk_pixmap_set_build_insensitive to provide ability to turn 
	  this off.

Tue Nov 17 00:06:29 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtknotebook.h (struct _GtkNotebook): new flags : homogeneous;
	new guints : tab_hborder, tab_vborder; marked tab_border deprecated
	(struct _GtkNotebookPage): new flags : expand, fill, pack

	* gtk/gtknotebook.h/c
	(gtk_notebook_set_homogeneous_tabs): new function. set homogeneneous
 	tabs
	(gtk_notebook_set_tab_border): set tab_h/vborder to tab_border
	(gtk_notebook_set_tab_hborder): new function. set tab_hborder
	(gtk_notebook_set_tab_vborder): new function. set tab_vborder
	(gtk_notebook_query_tab_label): new function. get tab_label widget.
	(gtk_notebook_set_tab_label): new function. set tab_label widget.
	(gtk_notebook_set_tab_label_text): new function. set tab_label text.
	(gtk_notebook_query_menu_label): new function. get tab_label widget.
	(gtk_notebook_set_menu_label): new function. set tab_label widget.
	(gtk_notebook_set_menu_label_text): new function. set tab_label text.
	(gtk_notebook_set_tab_label_packing): new function. set tab_label
 	fill, expand, fill_type
	(gtk_notebook_query_tab_label_packing): new function. get tab_label
 	fill, expand, fill_type

	(gtk_notebook_real_page_position): return logic page number
	(gtk_notebook_search_page) search next/prev logic page
	(gtk_notebook_update_labels): set logic page number.
	(gtk_notebook_page_compare): renamed gtk_notebook_find_page
	(gtk_notebook_set/get_child_arg): new args CHILD_ARG_TAB_EXPAND,
 	CHILD_ARG_TAB_FILL, CHILD_ARG_TAB_PACK
 	(gtk_notebook_button_press) (gtk_notebook_key_press)
 	(gtk_notebook_focus) (gtk_notebook_pages_allocate)
	(gtk_notebook_calc_tabs) (gtk_notebook_switch_focus_tab)
 	use gtk_notebook_search_page
	(gtk_notebook_page_allocate): fixed allocation bug
	(gtk_notebook_set/get_arg): new args TAB_HBORDER, TAB_VBORDER.
	(gtk_notebook_init): unset GTK_NO_WINDOW flag
	(gtk_notebook_size_request): check whether page->child is visible.
 	changes due to tab h/vborder, homogeneous tabs
	(gtk_notebook_paint): don't draw invisible tabs
	(gtk_notebook_switch_page): calculate page_num if it's less than 0
 	(gtk_notebook_append_*) (gtk_notebook_prepend_*)
 	(gtk_notebook_insert_page): removed sanity checks

	* gtk/testgtk.c (create_notebook): extended Notebook sample a bit.

Mon Nov 16 15:10:33 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktext.c: Optimizations for [advance/decrement]_mark_n.
	(gtk-mailund-980718-0, Thomas Mailund Jensen <mailund@daimi.aau.dk>)

	* gtk/gtkfixed.c: Removed gtk_fixed_umap, which was 
	broken. (GtkWidget's default unmap handler should work fine).
	Pointed out by Patrice Fortier <Patrice.Fortier@aquarel.fr>

Mon Nov 16 00:59:26 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkmenubar.[ch]: added shadow_type setting and
	gtk_menu_bar_set_shadow_type function to allow shadow
	configurability for menubars

	* gtk/gtkviewport.h: use GtkShadowType enum instead of generic
	guint

Mon Nov 16 00:17:53 1998  Tim Janik  <timj@gtk.org>

	* gtk/gtktypeutils.c (gtk_type_new): relookup type node after
	class creation and parent class' object initializer.

1998-11-13  Federico Mena Quintero  <federico@nuclecu.unam.mx>

	* gtk/gtkpaned.c (gtk_paned_realize): Destroy the cursor after we
	have assigned it to the window -- there is no point in keeping it around.
	(gtk_paned_unrealize): No need to destroy the cursor here.

	* gtk/gtkpaned.h (struct _GtkPaned): Removed the cursor field, as
	it is not needed.

Fri Nov 13 11:22:38 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkpixmap.c: New function gdk_pixmap_foreign_new().
	(gtk-blizzard-981005-0. 
	 Christopher Blizzard <blizzard@applied-theory.com)

	* gdk/gdk.h gdk/gdkx.h: Moved gdk_window_foreign_new and
	gdk_pixmap_foreign_new to gdkx.h.

Fri Nov 13 16:06:48 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/Makefile.am: Added rules to generate an empty
	GTK+ theme called "Default" upon installation.
	
	* gtk/gtkrc.c (gtk_rc_parse_style): Fix inheritance
	of fonts and fontsets. 
	(gtk-matsu-980924. Takashi Matsuda matsu@arch.comp.kyutech.ac.jp)

	* gtk/gtkmain.c: Change test to detect glibc's
	utf8 based mb* functions to be more specific.

	* gtk/gtkwindow.[ch] gtk/gtkfixed.c: Indentation 
	cleanups.

Fri Nov 13 16:43:36 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtktogglebutton.c	(gtk_toggle_button_realize): don't
	show event_window
 	(gtk_toggle_button_map) (gtk_toggle_button_unmap): show/hide
	event_window if draw_indicator is set
	(gtk_toggle_button_set_mode):

Thu Nov 12 15:33:54 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkitemfactory.c: cast NULL to GtkItemFactoryCallback to
	ensure proper type (SunPro cc complains)

	* gtk/gtklist.c: removed bogus '*' from "*GTK_CONTAINER_CLASS"

	* gtk/gtktogglebutton.c: use our own draw method so we get proper
	redraws on active state

Thu Nov 12 00:26:13 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkstyle.c (gtk_default_draw_box_gap): use GtkPositionType
	defines.

	* gtk/gtknotebook.c (gtk_notebook_draw_tab): fixed gap_side for
	GTP_POS_RIGHT

Wed Nov 11 19:54:58 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_class_init)
	(gtk_scrolled_window_set_arg) (gtk_scrolled_window_get_arg):
 	added ARG_WINDOW_PLACEMENT

	* gtk/gtkclist.c (size_allocate_columns): resize column if column
 	button > column width and auto_resize is set
	(real_clear) (column_auto_resize) (gtk_clist_optimal_column_width):
 	consider column button width of auto resized columns
	(gtk_clist_parent_set): removed 

	* gtk/gtkctree.c (gtk_ctree_insert_node): call column_auto_resize.
	(auto_resize_columns): auto_resize all columns
	(real_tree_collapse) (gtk_ctree_remove_node): call auto_resize_columns
	(column_auto_resize): respect column button width of auto resized
 	columns

1998-11-10  Martin Baulig  <baulig@merkur.uni-trier.de>

	* gtk/gtkfeatures.h.in (GTK_HAVE_FEATURES_1_1_4): Define this so
	we can check for latest GTK features.

Mon Nov  9 00:39:20 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkenums.h : new enum GtkCornerType 
	* gtk/gtkscrolledwindow.h (struct _GtkScrolledWindow): added
        window_placement.
	* gtk/gtkscrolledwindow.c (gtk_scrolled_window_set_placement): 
        new method to set window_placement.
        (gtk_scrolled_window_viewport_allocate)
        (gtk_scrolled_window_size_allocate): few changes due to
        window_placement.
	* gtk/testgtk.c (remove_selection): fixed while loop.

Sat Nov  7 21:55:00 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/gtkclist.c: check if column[i].button is valid before calling
	gtk_widget_intersect on it in gtk_clist_draw

	* gtk/gtkdnd.c: removed unused variable empty_bits

	* gtk/gtkrc.c: we should use gslist_* functions with GSLists...

	* gtk/gtktypeutils.[ch]: makes more send for gtk_type_is_a to return
	a boolean (thanks to Elrond for noticing this)

1998-11-07  Jay Cox  <jaycox@earthlink.net>

	* gtk/gtkwindow.c: forward declaration for gtk_window_paint
	* gdk/gdkxid.c: declare xid_ht static
	* examples/*/Makefile: get the link ordering right.

Sat Nov  7 16:31:56 1998  Stefan Jeske  <stefan@gtk.org>

	* gtk/gtkclist.c (gtk_clist_realize): Set background of
	title button window to GTK_STATE_NORMAL instead of
	GTK_STATE_SELECTED to avoid ugly flicker.

Fri Nov  6 23:29:40 1998  Lars Hamann  <lars@gtk.org>

	* gtk/gtkclist.c (real_clear) (adjust_adjustments): resize clist
 	if adjustments are NULL and list size has changed
	(gtk_clist_size_request): return real list requsition,
 	if adjustments are NULL.
	(size_allocate_columns): use button->requisition.with, if column
 	width is not set.
	(list_requisition_width): new function. return full list width.
	(gtk_clist_set_hadjustment) (gtk_clist_set_vadjustment): do not
	auto create adjustments.
	(gtk_clist_motion) (move_vertical) (move_horizontal):
 	check adjustment != NULL.

Thu Nov  5 12:06:16 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcheckbutton.c (gtk_check_button_draw_focus): Queue
	a clear/redraw, not just a redraw, so the focus
	gets undrawn properly.

	* gtk/gtktogglebutton.c (gtk_toggle_button_unrealize): 
	Chain to gtk_widget_unrealize() instead of duplicating
	code.

Wed Nov  4 14:34:51 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdk.c gdk/gdkprivate.h gdk/gdkwindow.c: Removed
	last vestiges of old DND.

Tue Nov  3 12:27:52 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c: Restored inner border to entries,
	erase cursors to background image.

Fri Oct 30 12:09:21 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkentry.c gtk/gtkstyle.[ch]: removed paint_entry() -
	it was identical to paint_flat_box().

	* gtk/gtkstyle.c: Coding style fixups.

	* gtk/gtkwindow.c (gtk_window_move_resize): removed useless
	test.

	* gtk/gtkframe.c gtkstyle.[ch] gtknotebook.c: 
	Change 'side' for paint_[box/shadow]_gap and paint_extension
	to be GtkPositionType instead of a random int.

	* gtk/gtkaspectframe.c (gtk_aspect_frame_paint): Use 
	"frame" as detail - an aspectframe should draw identical
	to a frame.

Tue Oct 27 09:58:11 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_merge_child_shapes): renamed
	from combine_child_shapes().

	* gdk/gdkwindow.c: Merge propagate_shapes() and
	propagate_combine_shapes() to remove code duplication.

Thu Nov  5 14:31:57 PST 1998 Manish Singh <yosh@gimp.org>

	* gdk/gdk.c: sometimes we get a KeyRelease before a KeyPress in
	gdk_event_translate, and the USE_XIM buffer isn't allocated yet.
	So allocate some mem if it's not already done.

	* clist scrollbar merges from HEAD

Tue Nov  3 13:16:36 PST 1998 Manish Singh <yosh@gimp.org>

	* gtk/Makefile.am: remove explict -ldl, gmodule takes care of that

	* gtk/gtkdnd.c: start TARGET_MOTIF_SUCCESS from 0x40000000 instead
	of 0x80000000, so we stay within the bounds of a postive signed
	int (it broke some compilers)

	* gtk/gtkmenushell.c
	* gtk/gtkoptionmenu.c: merges from HEAD to make option menus work
	when some of the menuitems are hidden

	* gtk/gtkthemes.h: don't include dlfcn.h explictly, gmodule takes
	care of that

	* gtk/gtkwidget.c: add a dummy continue after the line label
	next_rect, since some compilers don't like label: }

Sun Nov  1 20:05:55 PST 1998 Manish Singh <yosh@gimp.org>

	* Okay, so we need the X11R6 keysyms so programs don't have to
	worry about them. They don't conflict anyway. Reverted the #ifdef
	changes to gtk/*.c

	* gdk/Makefile.am: remove the BUILT_SOURCES rule, and make a
	special rule for them (X-derived-headers)

Sun Nov  1 05:30:32 PST 1998 Manish Singh <yosh@gimp.org>

	* gdk/Makefile.am: changed the awk scripts to generate gdkcursors.h
	and gdkkeysyms.h into sed scripts, since the awk scripts weren't
	portable, and we really shouldn't be using awk anyway.

	* makecursors.awk
	* makekeysyms.awk: bye bye

	* gtk/gtkaccelgroup.c
	* gtk/gtkclist.c
	* gtk/gtknotebook.c
	* gtk/gtkwindow.c: don't use X11R6 keysyms if they aren't there

Sat Oct 31 15:22:14 PST 1998 Manish Singh <yosh@gimp.org>

	* gdk/Makefile.am: do the same built sources trick for gdkcursors.h
	and gdkkeysyms.h. Remove those files from CVS.

Sat Oct 31 14:44:01 PST 1998 Manish Singh <yosh@gimp.org>

	* gdk/gdk.c: move prototype of gdk_wm_protocols_filter outside
	of the USE_XIM #ifdef

	* gtk/Makefile.am: cause the built sources to be rebuild when possible,
        even with --include-deps. Slightly different from timj's fix, to avoid
	circular dependency with gtkmarshal.c

	* autogen.sh
	* gtk/gtkclist.[ch]
	* gtk/gtkctree.c
	* gtk/gtkfontsel.[ch]
	* gtk/gtklist.c
	* gtk/gtklistitem.c
	* gtk/gtkobject.[ch]
	* gtk/testgtk.c: merges from HEAD

	* gtk/gtkmenubar.c
	* gtk/gtkradiomenuitem.c
	* gtk/gtktreeitem.c: cleanups

Wed Oct 28 23:32:19 PST 1998 Manish Singh <yosh@gimp.org>

	* gdk/gdkrgb.c: Oops. s/BIGENDIAN/BIG_ENDIAN/

Wed Oct 28 19:04:49 PST 1998 Manish Singh <yosh@gimp.org>

	* configure.in: AIX has libpthreads, to make sure you can have
	more than one thread. Also add -D_THREAD_SAFE, and reorder
	configure.in so CFLAGS doesn't get clobbered when we actually
	want to modify it

	* gdk/gdkimage.c: initialize the bpp and byte_order fields properly
	in gdk_image_get

	* gtk/testdnd.c: removed unused variable "buf"

Mon Oct 26 16:46:15 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkcontainer.c (gtk_container_unregister_toplevel): 
	remove_link(), not remove()

Thu Oct 22 02:27:30 PDT 1998 Manish Singh <yosh@gimp.org>

	* gdk/gdkrgb.c: use glib endian stuff

	* configure.in: don't need to check for endianness anymore

	* gtk/gtkstyle.h: removed #pragma }, causing a silly warning

Wed Oct 21 17:44:27 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_read_rcfiles): Reset
	all toplevel widgets, not toplevel windows. (I.e.,
	plugs should be reset)

	* gtk/gtkwindow.c (gtk_window_read_rcfiles): Yes, we
	_do_ need to notify the other toplevels - by the time
	the get the client messages, the RC file dates will
	have been updated.

	* gtk/gtkcontainer.h: Added a function call to list
	every toplevel widget.

	* gdk/gdk.c (gdk_event_send_client_message_to_all_recurse): 
	Don't send client messages to _every_ window on display!
	
Tue Oct 20 16:21:04 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_source_event_cb): Don't start drags 
	when dragging across widgets, only in drags
	starting in widget.

Tue Oct 20 15:59:49 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdnd.c (gtk_drag_source_info_destroy): 
	Emit "drag_end" signal at end of drag.

Tue Oct 20 13:07:54 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwindow.c (gtk_window_read_rcfiles): Look
	for "gtk-embedded" data currently set by 
	GtkSocket, and use that to forward client message
	on to embedded windows. Only reset our own toplevel -
	the others will handle themselves. (Now that
	GtkMenus live in GtkWindows)

Mon Oct 19 16:40:40 1998  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkdnd.c (get_client_window_at_coords_recurse): Modify
	client window finding code so that it works with
	WM's other than fvwm.
 
Sun Oct 18 22:48:27 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkdrawwindow.c (gtk_draw_window_get_type): Added
	the "GtkDrawWindow" class, which is a descendent
	of the Window class which leaves its background alone.
	Essentially, a toplevel drawing area, though it does
	allow adding a child.

Sat Oct 17 00:40:51 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkrc.c (gtk_rc_style_init): Duplicate bg_pixmap_name when
	merging RC styles. Report new share/themes path for
	themes directory. Deref theme engines when appropriate.

	* gtk/gtkclist.c: Set all backgrounds in _style_set().
	Make sure that pixel for xor_gc is never 0.

	* gtk/gtkctree.c: Choose colors for plus/minus more
	carefully, in a hopefully style-independent fashion.
	(Still needs a bit more work)

	* gtk/gtkwidget.c: Don't send expose events to widgets
	which are about to be resized and redrawn. (Needs a
	bit more thought.)

	* gtk/gtknotebook.c (gtk_notebook_draw_tab): Avoid
	drawing on tabs for newly allocated, un-sized
	pages - we'll get the size wrong.

Thu Oct  1 17:38:07 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c (gtk_widget_redraw_queue_remove): Fixed
 	up stupidities in last commit.

Thu Oct  1 14:25:43 1998  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkwidget.c: When handling queued resizes, account
	for handleboxes, where the widget heirarchy is different
	than the window heirarchy by just queueing a resize on
	the entire handlebox if the detached child is changed.

	- Remove widgets from the redraw queue when reparenting,
	even if not unrealizing. We queue a resize/redraw in
	any case.

Mon Sep 28 21:07:01 EDT 1998 The Rasterman <raster@redhat.com>
	* gtk/gtkstyle.c: added check to see if the widget has been shaped
	byt the app via gtk_widget_shape_combine_mask and if it has does
	not reset the shape on theme change.
	
